/* Dialog.c generated by valac 0.56.17, the Vala compiler
 * generated from Dialog.vala, do not modify */

/*
 * SPDX-FileCopyrightText: 2021-2023 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-2.1-or-later
 */

#include <granite-7.h>
#include <pantheon-wayland.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gio/gdesktopappinfo.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define ACCESS_TYPE_DIALOG (access_dialog_get_type ())
#define ACCESS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCESS_TYPE_DIALOG, AccessDialog))
#define ACCESS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACCESS_TYPE_DIALOG, AccessDialogClass))
#define ACCESS_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCESS_TYPE_DIALOG))
#define ACCESS_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACCESS_TYPE_DIALOG))
#define ACCESS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACCESS_TYPE_DIALOG, AccessDialogClass))

typedef struct _AccessDialog AccessDialog;
typedef struct _AccessDialogClass AccessDialogClass;
typedef struct _AccessDialogPrivate AccessDialogPrivate;
typedef enum  {
	ACCESS_DIALOG_BUTTON_ACTION_SUGGESTED,
	ACCESS_DIALOG_BUTTON_ACTION_DESTRUCTIVE
} AccessDialogButtonAction;

#define ACCESS_DIALOG_TYPE_BUTTON_ACTION (access_dialog_button_action_get_type ())

#define ACCESS_TYPE_CHOICE (access_choice_get_type ())
#define ACCESS_CHOICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCESS_TYPE_CHOICE, AccessChoice))
#define ACCESS_CHOICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACCESS_TYPE_CHOICE, AccessChoiceClass))
#define ACCESS_IS_CHOICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCESS_TYPE_CHOICE))
#define ACCESS_IS_CHOICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACCESS_TYPE_CHOICE))
#define ACCESS_CHOICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACCESS_TYPE_CHOICE, AccessChoiceClass))

typedef struct _AccessChoice AccessChoice;
typedef struct _AccessChoiceClass AccessChoiceClass;
enum  {
	ACCESS_DIALOG_0_PROPERTY,
	ACCESS_DIALOG_ACTION_PROPERTY,
	ACCESS_DIALOG_PARENT_WINDOW_PROPERTY,
	ACCESS_DIALOG_APP_ID_PROPERTY,
	ACCESS_DIALOG_DENY_LABEL_PROPERTY,
	ACCESS_DIALOG_GRANT_LABEL_PROPERTY,
	ACCESS_DIALOG_BODY_PROPERTY,
	ACCESS_DIALOG_NUM_PROPERTIES
};
static GParamSpec* access_dialog_properties[ACCESS_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_EXTERNAL_WINDOW (external_window_get_type ())
#define EXTERNAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXTERNAL_WINDOW, ExternalWindow))
#define IS_EXTERNAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXTERNAL_WINDOW))
#define EXTERNAL_WINDOW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_EXTERNAL_WINDOW, ExternalWindowIface))

typedef struct _ExternalWindow ExternalWindow;
typedef struct _ExternalWindowIface ExternalWindowIface;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AccessDialog {
	GraniteMessageDialog parent_instance;
	AccessDialogPrivate * priv;
};

struct _AccessDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _AccessDialogPrivate {
	AccessDialogButtonAction _action;
	gchar* _parent_window;
	gchar* _app_id;
	GtkButton* grant_button;
	GtkButton* deny_button;
	GList* choices;
};

struct _ExternalWindowIface {
	GTypeInterface parent_iface;
	void (*set_parent_of) (ExternalWindow* self, GdkSurface* child_surface);
};

static gint AccessDialog_private_offset;
static gpointer access_dialog_parent_class = NULL;
static PantheonWaylandExtendedBehaviorIface * access_dialog_pantheon_wayland_extended_behavior_parent_iface = NULL;

VALA_EXTERN GType access_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AccessDialog, g_object_unref)
VALA_EXTERN guint access_dialog_register_object (void* object,
                                     GDBusConnection* connection,
                                     const gchar* path,
                                     GError** error);
VALA_EXTERN GType access_dialog_button_action_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType access_choice_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AccessChoice, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN AccessDialog* access_dialog_new (AccessDialogButtonAction action,
                                 const gchar* app_id,
                                 const gchar* parent_window,
                                 const gchar* icon);
VALA_EXTERN AccessDialog* access_dialog_construct (GType object_type,
                                       AccessDialogButtonAction action,
                                       const gchar* app_id,
                                       const gchar* parent_window,
                                       const gchar* icon);
static void access_dialog_real_show (GtkWidget* base);
VALA_EXTERN const gchar* access_dialog_get_parent_window (AccessDialog* self);
VALA_EXTERN GType external_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExternalWindow, g_object_unref)
VALA_EXTERN ExternalWindow* external_window_from_handle (const gchar* handle,
                                             GError** error);
VALA_EXTERN void external_window_set_parent_of (ExternalWindow* self,
                                    GdkSurface* child_surface);
static void access_dialog_real_close (GtkDialog* base);
VALA_EXTERN void access_dialog_add_choice (AccessDialog* self,
                               AccessChoice* choice);
VALA_EXTERN GList* access_dialog_get_choices (AccessDialog* self);
VALA_EXTERN void access_dialog_on_close (AccessDialog* self,
                             GError** error);
VALA_EXTERN AccessDialogButtonAction access_dialog_get_action (AccessDialog* self);
static void access_dialog_set_action (AccessDialog* self,
                               AccessDialogButtonAction value);
static void access_dialog_set_parent_window (AccessDialog* self,
                                      const gchar* value);
VALA_EXTERN const gchar* access_dialog_get_app_id (AccessDialog* self);
static void access_dialog_set_app_id (AccessDialog* self,
                               const gchar* value);
VALA_EXTERN void access_dialog_set_deny_label (AccessDialog* self,
                                   const gchar* value);
VALA_EXTERN void access_dialog_set_grant_label (AccessDialog* self,
                                    const gchar* value);
VALA_EXTERN void access_dialog_set_body (AccessDialog* self,
                             const gchar* value);
static GObject * access_dialog_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _access_dialog____lambda6_ (AccessDialog* self);
static void __access_dialog____lambda6__gtk_widget_realize (GtkWidget* _sender,
                                                     gpointer self);
static void access_dialog_finalize (GObject * obj);
static GType access_dialog_get_type_once (void);
static void _vala_access_dialog_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_access_dialog_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _dbus_access_dialog_on_close (AccessDialog* self,
                                   GVariant* _parameters_,
                                   GDBusMethodInvocation* invocation);
static void access_dialog_dbus_interface_method_call (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* method_name,
                                               GVariant* parameters,
                                               GDBusMethodInvocation* invocation,
                                               gpointer user_data);
static GVariant* access_dialog_dbus_interface_get_property (GDBusConnection* connection,
                                                     const gchar* sender,
                                                     const gchar* object_path,
                                                     const gchar* interface_name,
                                                     const gchar* property_name,
                                                     GError** error,
                                                     gpointer user_data);
static GVariant* _dbus_access_dialog_get_action (AccessDialog* self);
static GVariant* _dbus_access_dialog_get_parent_window (AccessDialog* self);
static GVariant* _dbus_access_dialog_get_app_id (AccessDialog* self);
static gboolean access_dialog_dbus_interface_set_property (GDBusConnection* connection,
                                                    const gchar* sender,
                                                    const gchar* object_path,
                                                    const gchar* interface_name,
                                                    const gchar* property_name,
                                                    GVariant* value,
                                                    GError** error,
                                                    gpointer user_data);
static void _dbus_access_dialog_set_action (AccessDialog* self,
                                     GVariant* _value);
static void _dbus_access_dialog_set_parent_window (AccessDialog* self,
                                            GVariant* _value);
static void _dbus_access_dialog_set_app_id (AccessDialog* self,
                                     GVariant* _value);
static void _dbus_access_dialog_set_deny_label (AccessDialog* self,
                                         GVariant* _value);
static void _dbus_access_dialog_set_grant_label (AccessDialog* self,
                                          GVariant* _value);
static void _dbus_access_dialog_set_body (AccessDialog* self,
                                   GVariant* _value);
static void _access_dialog_unregister_object (gpointer user_data);

static const GDBusArgInfo * const _access_dialog_dbus_arg_info_on_close_in[] = {NULL};
static const GDBusArgInfo * const _access_dialog_dbus_arg_info_on_close_out[] = {NULL};
static const GDBusMethodInfo _access_dialog_dbus_method_info_on_close = {-1, "Close", (GDBusArgInfo **) (&_access_dialog_dbus_arg_info_on_close_in), (GDBusArgInfo **) (&_access_dialog_dbus_arg_info_on_close_out), NULL};
static const GDBusMethodInfo * const _access_dialog_dbus_method_info[] = {&_access_dialog_dbus_method_info_on_close, NULL};
static const GDBusSignalInfo * const _access_dialog_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _access_dialog_dbus_property_info_action = {-1, "Action", "i", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _access_dialog_dbus_property_info_parent_window = {-1, "ParentWindow", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _access_dialog_dbus_property_info_app_id = {-1, "AppId", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _access_dialog_dbus_property_info_deny_label = {-1, "DenyLabel", "s", G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _access_dialog_dbus_property_info_grant_label = {-1, "GrantLabel", "s", G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _access_dialog_dbus_property_info_body = {-1, "Body", "s", G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo * const _access_dialog_dbus_property_info[] = {&_access_dialog_dbus_property_info_action, &_access_dialog_dbus_property_info_parent_window, &_access_dialog_dbus_property_info_app_id, &_access_dialog_dbus_property_info_deny_label, &_access_dialog_dbus_property_info_grant_label, &_access_dialog_dbus_property_info_body, NULL};
static const GDBusInterfaceInfo _access_dialog_dbus_interface_info = {-1, "org.freedesktop.impl.portal.Request", (GDBusMethodInfo **) (&_access_dialog_dbus_method_info), (GDBusSignalInfo **) (&_access_dialog_dbus_signal_info), (GDBusPropertyInfo **) (&_access_dialog_dbus_property_info), NULL};
static const GDBusInterfaceVTable _access_dialog_dbus_interface_vtable = {access_dialog_dbus_interface_method_call, access_dialog_dbus_interface_get_property, access_dialog_dbus_interface_set_property};

static inline gpointer
access_dialog_get_instance_private (AccessDialog* self)
{
	return G_STRUCT_MEMBER_P (self, AccessDialog_private_offset);
}

static GType
access_dialog_button_action_get_type_once (void)
{
	static const GEnumValue values[] = {{ACCESS_DIALOG_BUTTON_ACTION_SUGGESTED, "ACCESS_DIALOG_BUTTON_ACTION_SUGGESTED", "suggested"}, {ACCESS_DIALOG_BUTTON_ACTION_DESTRUCTIVE, "ACCESS_DIALOG_BUTTON_ACTION_DESTRUCTIVE", "destructive"}, {0, NULL, NULL}};
	GType access_dialog_button_action_type_id;
	access_dialog_button_action_type_id = g_enum_register_static ("AccessDialogButtonAction", values);
	return access_dialog_button_action_type_id;
}

GType
access_dialog_button_action_get_type (void)
{
	static volatile gsize access_dialog_button_action_type_id__once = 0;
	if (g_once_init_enter (&access_dialog_button_action_type_id__once)) {
		GType access_dialog_button_action_type_id;
		access_dialog_button_action_type_id = access_dialog_button_action_get_type_once ();
		g_once_init_leave (&access_dialog_button_action_type_id__once, access_dialog_button_action_type_id);
	}
	return access_dialog_button_action_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

AccessDialog*
access_dialog_construct (GType object_type,
                         AccessDialogButtonAction action,
                         const gchar* app_id,
                         const gchar* parent_window,
                         const gchar* icon)
{
	AccessDialog * self = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	g_return_val_if_fail (app_id != NULL, NULL);
	g_return_val_if_fail (parent_window != NULL, NULL);
	g_return_val_if_fail (icon != NULL, NULL);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new (icon);
	_tmp1_ = _tmp0_;
	self = (AccessDialog*) g_object_new (object_type, "action", action, "app-id", app_id, "parent-window", parent_window, "image-icon", _tmp1_, "buttons", GTK_BUTTONS_NONE, NULL);
	_g_object_unref0 (_tmp1_);
	return self;
}

AccessDialog*
access_dialog_new (AccessDialogButtonAction action,
                   const gchar* app_id,
                   const gchar* parent_window,
                   const gchar* icon)
{
	return access_dialog_construct (ACCESS_TYPE_DIALOG, action, app_id, parent_window, icon);
}

static void
access_dialog_real_show (GtkWidget* base)
{
	AccessDialog * self;
	GdkToplevel* toplevel = NULL;
	GdkSurface* _tmp0_;
	const gchar* _tmp1_;
	GdkToplevel* _tmp9_;
	GError* _inner_error0_ = NULL;
	self = (AccessDialog*) base;
	gtk_widget_realize (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_TYPE_MESSAGE_DIALOG, GraniteMessageDialog), gtk_widget_get_type (), GtkWidget));
	_tmp0_ = gtk_native_get_surface ((GtkNative*) self);
	toplevel = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gdk_toplevel_get_type (), GdkToplevel);
	_tmp1_ = self->priv->_parent_window;
	if (g_strcmp0 (_tmp1_, "") != 0) {
		{
			ExternalWindow* _tmp2_ = NULL;
			const gchar* _tmp3_;
			ExternalWindow* _tmp4_;
			GdkToplevel* _tmp5_;
			_tmp3_ = self->priv->_parent_window;
			_tmp4_ = external_window_from_handle (_tmp3_, &_inner_error0_);
			_tmp2_ = _tmp4_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp5_ = toplevel;
			external_window_set_parent_of (_tmp2_, (GdkSurface*) _tmp5_);
			_g_object_unref0 (_tmp2_);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp6_;
			GError* _tmp7_;
			const gchar* _tmp8_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp6_ = self->priv->_parent_window;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->message;
			g_warning ("Dialog.vala:95: Failed to associate portal window with parent '%s': %s", _tmp6_, _tmp8_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	GTK_WIDGET_CLASS (access_dialog_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_TYPE_MESSAGE_DIALOG, GraniteMessageDialog));
	_tmp9_ = toplevel;
	gdk_toplevel_focus (_tmp9_, (guint32) GDK_CURRENT_TIME);
}

static void
access_dialog_real_close (GtkDialog* base)
{
	AccessDialog * self;
	self = (AccessDialog*) base;
	gtk_dialog_response ((GtkDialog*) self, (gint) GTK_RESPONSE_CANCEL);
	GTK_DIALOG_CLASS (access_dialog_parent_class)->close ((GtkDialog*) G_TYPE_CHECK_INSTANCE_CAST (self, GRANITE_TYPE_MESSAGE_DIALOG, GraniteMessageDialog));
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
access_dialog_add_choice (AccessDialog* self,
                          AccessChoice* choice)
{
	AccessChoice* _tmp0_;
	GtkBox* _tmp1_;
	GtkBox* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (choice != NULL);
	_tmp0_ = _g_object_ref0 (choice);
	self->priv->choices = g_list_append (self->priv->choices, _tmp0_);
	_tmp1_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
	_tmp2_ = _tmp1_;
	gtk_box_append (_tmp2_, (GtkWidget*) choice);
}

GList*
access_dialog_get_choices (AccessDialog* self)
{
	GList* _tmp0_;
	GList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->choices;
	result = _tmp0_;
	return result;
}

void
access_dialog_on_close (AccessDialog* self,
                        GError** error)
{
	g_return_if_fail (self != NULL);
	gtk_dialog_response ((GtkDialog*) self, (gint) GTK_RESPONSE_DELETE_EVENT);
}

AccessDialogButtonAction
access_dialog_get_action (AccessDialog* self)
{
	AccessDialogButtonAction result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_action;
	return result;
}

static void
access_dialog_set_action (AccessDialog* self,
                          AccessDialogButtonAction value)
{
	AccessDialogButtonAction old_value;
	g_return_if_fail (self != NULL);
	old_value = access_dialog_get_action (self);
	if (old_value != value) {
		self->priv->_action = value;
		g_object_notify_by_pspec ((GObject *) self, access_dialog_properties[ACCESS_DIALOG_ACTION_PROPERTY]);
	}
}

const gchar*
access_dialog_get_parent_window (AccessDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_parent_window;
	result = _tmp0_;
	return result;
}

static void
access_dialog_set_parent_window (AccessDialog* self,
                                 const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = access_dialog_get_parent_window (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_parent_window);
		self->priv->_parent_window = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, access_dialog_properties[ACCESS_DIALOG_PARENT_WINDOW_PROPERTY]);
	}
}

const gchar*
access_dialog_get_app_id (AccessDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_app_id;
	result = _tmp0_;
	return result;
}

static void
access_dialog_set_app_id (AccessDialog* self,
                          const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = access_dialog_get_app_id (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_app_id);
		self->priv->_app_id = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, access_dialog_properties[ACCESS_DIALOG_APP_ID_PROPERTY]);
	}
}

void
access_dialog_set_deny_label (AccessDialog* self,
                              const gchar* value)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->deny_button;
	gtk_button_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, access_dialog_properties[ACCESS_DIALOG_DENY_LABEL_PROPERTY]);
}

void
access_dialog_set_grant_label (AccessDialog* self,
                               const gchar* value)
{
	GtkButton* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->grant_button;
	gtk_button_set_label (_tmp0_, value);
	g_object_notify_by_pspec ((GObject *) self, access_dialog_properties[ACCESS_DIALOG_GRANT_LABEL_PROPERTY]);
}

void
access_dialog_set_body (AccessDialog* self,
                        const gchar* value)
{
	g_return_if_fail (self != NULL);
	if (g_strcmp0 (value, "") != 0) {
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp0_ = granite_message_dialog_get_secondary_text ((GraniteMessageDialog*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_strconcat ("\n\n", value, NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp5_);
		_g_free0 (_tmp5_);
		_g_free0 (_tmp3_);
	}
	g_object_notify_by_pspec ((GObject *) self, access_dialog_properties[ACCESS_DIALOG_BODY_PROPERTY]);
}

static void
_access_dialog____lambda6_ (AccessDialog* self)
{
	pantheon_wayland_extended_behavior_connect_to_shell ((PantheonWaylandExtendedBehavior*) self);
	pantheon_wayland_extended_behavior_make_centered ((PantheonWaylandExtendedBehavior*) self);
	pantheon_wayland_extended_behavior_set_keep_above ((PantheonWaylandExtendedBehavior*) self);
}

static void
__access_dialog____lambda6__gtk_widget_realize (GtkWidget* _sender,
                                                gpointer self)
{
	_access_dialog____lambda6_ ((AccessDialog*) self);
}

static GObject *
access_dialog_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AccessDialog * self;
	const gchar* _tmp0_;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	AccessDialogButtonAction _tmp9_;
	GtkBox* _tmp14_;
	GtkBox* _tmp15_;
	GtkBox* _tmp16_;
	GtkBox* _tmp17_;
	const gchar* _tmp18_;
	parent_class = G_OBJECT_CLASS (access_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCESS_TYPE_DIALOG, AccessDialog);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	(self->priv->choices == NULL) ? NULL : (self->priv->choices = (_g_list_free__g_object_unref0_ (self->priv->choices), NULL));
	self->priv->choices = NULL;
	_tmp0_ = self->priv->_app_id;
	if (g_strcmp0 (_tmp0_, "") != 0) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GDesktopAppInfo* _tmp4_;
		GDesktopAppInfo* _tmp5_;
		GIcon* _tmp6_;
		_tmp1_ = self->priv->_app_id;
		_tmp2_ = g_strconcat (_tmp1_, ".desktop", NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_desktop_app_info_new (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_app_info_get_icon ((GAppInfo*) _tmp5_);
		granite_message_dialog_set_badge_icon ((GraniteMessageDialog*) self, _tmp6_);
		_g_object_unref0 (_tmp5_);
		_g_free0 (_tmp3_);
	}
	_tmp7_ = granite_dialog_add_button ((GraniteDialog*) self, _ ("Deny Access"), (gint) GTK_RESPONSE_CANCEL);
	self->priv->deny_button = G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_button_get_type ()) ? ((GtkButton*) _tmp7_) : NULL;
	_tmp8_ = granite_dialog_add_button ((GraniteDialog*) self, _ ("Grant Access"), (gint) GTK_RESPONSE_OK);
	self->priv->grant_button = G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, gtk_button_get_type ()) ? ((GtkButton*) _tmp8_) : NULL;
	_tmp9_ = self->priv->_action;
	if (_tmp9_ == ACCESS_DIALOG_BUTTON_ACTION_SUGGESTED) {
		GtkButton* _tmp10_;
		GtkButton* _tmp11_;
		_tmp10_ = self->priv->grant_button;
		gtk_widget_add_css_class ((GtkWidget*) _tmp10_, GRANITE_STYLE_CLASS_SUGGESTED_ACTION);
		_tmp11_ = self->priv->grant_button;
		gtk_window_set_default_widget ((GtkWindow*) self, (GtkWidget*) _tmp11_);
	} else {
		GtkButton* _tmp12_;
		GtkButton* _tmp13_;
		_tmp12_ = self->priv->grant_button;
		gtk_widget_add_css_class ((GtkWidget*) _tmp12_, GRANITE_STYLE_CLASS_DESTRUCTIVE_ACTION);
		_tmp13_ = self->priv->deny_button;
		gtk_window_set_default_widget ((GtkWindow*) self, (GtkWidget*) _tmp13_);
	}
	_tmp14_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
	_tmp15_ = _tmp14_;
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp15_, GTK_ORIENTATION_VERTICAL);
	_tmp16_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
	_tmp17_ = _tmp16_;
	gtk_box_set_spacing (_tmp17_, 6);
	_tmp18_ = self->priv->_parent_window;
	if (g_strcmp0 (_tmp18_, "") == 0) {
		GtkWidget* _tmp19_;
		GtkWidget* _tmp20_;
		_tmp19_ = gtk_window_get_child ((GtkWindow*) self);
		_tmp20_ = _tmp19_;
		g_signal_connect_object (_tmp20_, "realize", (GCallback) __access_dialog____lambda6__gtk_widget_realize, self, 0);
	}
	return obj;
}

static void
access_dialog_class_init (AccessDialogClass * klass,
                          gpointer klass_data)
{
	access_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AccessDialog_private_offset);
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) access_dialog_real_show;
	((GtkDialogClass *) klass)->close = (void (*) (GtkDialog*)) access_dialog_real_close;
	G_OBJECT_CLASS (klass)->get_property = _vala_access_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_access_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = access_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = access_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCESS_DIALOG_ACTION_PROPERTY, access_dialog_properties[ACCESS_DIALOG_ACTION_PROPERTY] = g_param_spec_enum ("action", "action", "action", ACCESS_DIALOG_TYPE_BUTTON_ACTION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCESS_DIALOG_PARENT_WINDOW_PROPERTY, access_dialog_properties[ACCESS_DIALOG_PARENT_WINDOW_PROPERTY] = g_param_spec_string ("parent-window", "parent-window", "parent-window", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCESS_DIALOG_APP_ID_PROPERTY, access_dialog_properties[ACCESS_DIALOG_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCESS_DIALOG_DENY_LABEL_PROPERTY, access_dialog_properties[ACCESS_DIALOG_DENY_LABEL_PROPERTY] = g_param_spec_string ("deny-label", "deny-label", "deny-label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCESS_DIALOG_GRANT_LABEL_PROPERTY, access_dialog_properties[ACCESS_DIALOG_GRANT_LABEL_PROPERTY] = g_param_spec_string ("grant-label", "grant-label", "grant-label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCESS_DIALOG_BODY_PROPERTY, access_dialog_properties[ACCESS_DIALOG_BODY_PROPERTY] = g_param_spec_string ("body", "body", "body", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
}

static void
access_dialog_pantheon_wayland_extended_behavior_interface_init (PantheonWaylandExtendedBehaviorIface * iface,
                                                                 gpointer iface_data)
{
	access_dialog_pantheon_wayland_extended_behavior_parent_iface = g_type_interface_peek_parent (iface);
}

static void
access_dialog_instance_init (AccessDialog * self,
                             gpointer klass)
{
	self->priv = access_dialog_get_instance_private (self);
}

static void
access_dialog_finalize (GObject * obj)
{
	AccessDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCESS_TYPE_DIALOG, AccessDialog);
	_g_free0 (self->priv->_parent_window);
	_g_free0 (self->priv->_app_id);
	(self->priv->choices == NULL) ? NULL : (self->priv->choices = (_g_list_free__g_object_unref0_ (self->priv->choices), NULL));
	G_OBJECT_CLASS (access_dialog_parent_class)->finalize (obj);
}

static GType
access_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccessDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) access_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccessDialog), 0, (GInstanceInitFunc) access_dialog_instance_init, NULL };
	static const GInterfaceInfo pantheon_wayland_extended_behavior_info = { (GInterfaceInitFunc) access_dialog_pantheon_wayland_extended_behavior_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType access_dialog_type_id;
	access_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "AccessDialog", &g_define_type_info, 0);
	g_type_add_interface_static (access_dialog_type_id, PANTHEON_WAYLAND_TYPE_EXTENDED_BEHAVIOR, &pantheon_wayland_extended_behavior_info);
	g_type_set_qdata (access_dialog_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) access_dialog_register_object);
	AccessDialog_private_offset = g_type_add_instance_private (access_dialog_type_id, sizeof (AccessDialogPrivate));
	return access_dialog_type_id;
}

GType
access_dialog_get_type (void)
{
	static volatile gsize access_dialog_type_id__once = 0;
	if (g_once_init_enter (&access_dialog_type_id__once)) {
		GType access_dialog_type_id;
		access_dialog_type_id = access_dialog_get_type_once ();
		g_once_init_leave (&access_dialog_type_id__once, access_dialog_type_id);
	}
	return access_dialog_type_id__once;
}

static void
_vala_access_dialog_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	AccessDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACCESS_TYPE_DIALOG, AccessDialog);
	switch (property_id) {
		case ACCESS_DIALOG_ACTION_PROPERTY:
		g_value_set_enum (value, access_dialog_get_action (self));
		break;
		case ACCESS_DIALOG_PARENT_WINDOW_PROPERTY:
		g_value_set_string (value, access_dialog_get_parent_window (self));
		break;
		case ACCESS_DIALOG_APP_ID_PROPERTY:
		g_value_set_string (value, access_dialog_get_app_id (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_access_dialog_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	AccessDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACCESS_TYPE_DIALOG, AccessDialog);
	switch (property_id) {
		case ACCESS_DIALOG_ACTION_PROPERTY:
		access_dialog_set_action (self, g_value_get_enum (value));
		break;
		case ACCESS_DIALOG_PARENT_WINDOW_PROPERTY:
		access_dialog_set_parent_window (self, g_value_get_string (value));
		break;
		case ACCESS_DIALOG_APP_ID_PROPERTY:
		access_dialog_set_app_id (self, g_value_get_string (value));
		break;
		case ACCESS_DIALOG_DENY_LABEL_PROPERTY:
		access_dialog_set_deny_label (self, g_value_get_string (value));
		break;
		case ACCESS_DIALOG_GRANT_LABEL_PROPERTY:
		access_dialog_set_grant_label (self, g_value_get_string (value));
		break;
		case ACCESS_DIALOG_BODY_PROPERTY:
		access_dialog_set_body (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_dbus_access_dialog_on_close (AccessDialog* self,
                              GVariant* _parameters_,
                              GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	access_dialog_on_close (self, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
access_dialog_dbus_interface_method_call (GDBusConnection* connection,
                                          const gchar* sender,
                                          const gchar* object_path,
                                          const gchar* interface_name,
                                          const gchar* method_name,
                                          GVariant* parameters,
                                          GDBusMethodInvocation* invocation,
                                          gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Close") == 0) {
		_dbus_access_dialog_on_close (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_access_dialog_get_action (AccessDialog* self)
{
	AccessDialogButtonAction result;
	GVariant* _reply;
	result = access_dialog_get_action (self);
	_reply = g_variant_new_int32 (result);
	return _reply;
}

static GVariant*
_dbus_access_dialog_get_parent_window (AccessDialog* self)
{
	const gchar* result;
	GVariant* _reply;
	result = access_dialog_get_parent_window (self);
	_reply = g_variant_new_string (result);
	return _reply;
}

static GVariant*
_dbus_access_dialog_get_app_id (AccessDialog* self)
{
	const gchar* result;
	GVariant* _reply;
	result = access_dialog_get_app_id (self);
	_reply = g_variant_new_string (result);
	return _reply;
}

static GVariant*
access_dialog_dbus_interface_get_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Action") == 0) {
		return _dbus_access_dialog_get_action (object);
	} else if (strcmp (property_name, "ParentWindow") == 0) {
		return _dbus_access_dialog_get_parent_window (object);
	} else if (strcmp (property_name, "AppId") == 0) {
		return _dbus_access_dialog_get_app_id (object);
	}
	return NULL;
}

static void
_dbus_access_dialog_set_action (AccessDialog* self,
                                GVariant* _value)
{
	AccessDialogButtonAction value = 0;
	value = g_variant_get_int32 (_value);
	access_dialog_set_action (self, value);
}

static void
_dbus_access_dialog_set_parent_window (AccessDialog* self,
                                       GVariant* _value)
{
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	access_dialog_set_parent_window (self, value);
	_g_free0 (value);
}

static void
_dbus_access_dialog_set_app_id (AccessDialog* self,
                                GVariant* _value)
{
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	access_dialog_set_app_id (self, value);
	_g_free0 (value);
}

static void
_dbus_access_dialog_set_deny_label (AccessDialog* self,
                                    GVariant* _value)
{
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	access_dialog_set_deny_label (self, value);
	_g_free0 (value);
}

static void
_dbus_access_dialog_set_grant_label (AccessDialog* self,
                                     GVariant* _value)
{
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	access_dialog_set_grant_label (self, value);
	_g_free0 (value);
}

static void
_dbus_access_dialog_set_body (AccessDialog* self,
                              GVariant* _value)
{
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	access_dialog_set_body (self, value);
	_g_free0 (value);
}

static gboolean
access_dialog_dbus_interface_set_property (GDBusConnection* connection,
                                           const gchar* sender,
                                           const gchar* object_path,
                                           const gchar* interface_name,
                                           const gchar* property_name,
                                           GVariant* value,
                                           GError** error,
                                           gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Action") == 0) {
		_dbus_access_dialog_set_action (object, value);
		return TRUE;
	} else if (strcmp (property_name, "ParentWindow") == 0) {
		_dbus_access_dialog_set_parent_window (object, value);
		return TRUE;
	} else if (strcmp (property_name, "AppId") == 0) {
		_dbus_access_dialog_set_app_id (object, value);
		return TRUE;
	} else if (strcmp (property_name, "DenyLabel") == 0) {
		_dbus_access_dialog_set_deny_label (object, value);
		return TRUE;
	} else if (strcmp (property_name, "GrantLabel") == 0) {
		_dbus_access_dialog_set_grant_label (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Body") == 0) {
		_dbus_access_dialog_set_body (object, value);
		return TRUE;
	}
	return FALSE;
}

guint
access_dialog_register_object (gpointer object,
                               GDBusConnection* connection,
                               const gchar* path,
                               GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_access_dialog_dbus_interface_info), &_access_dialog_dbus_interface_vtable, data, _access_dialog_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_access_dialog_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

