/* NotificationRequest.c generated by valac 0.56.17, the Vala compiler
 * generated from NotificationRequest.vala, do not modify */

/*
 * SPDX-FileCopyrightText: 2023 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: LGPL-2.1-or-later
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define FDO_NOTIFICATIONS_NAME "org.freedesktop.Notifications"
#define FDO_NOTIFICATIONS_PATH "/org/freedesktop/Notifications"
#define BACKGROUND_NOTIFICATION_REQUEST_ACTION_ALLOW_BACKGROUND "background.allow"
#define BACKGROUND_NOTIFICATION_REQUEST_ACTION_FORBID_BACKGROUND "background.forbid"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FDO_TYPE_NOTIFICATIONS (fdo_notifications_get_type ())
#define FDO_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FDO_TYPE_NOTIFICATIONS, FdoNotifications))
#define FDO_IS_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FDO_TYPE_NOTIFICATIONS))
#define FDO_NOTIFICATIONS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), FDO_TYPE_NOTIFICATIONS, FdoNotificationsIface))

typedef struct _FdoNotifications FdoNotifications;
typedef struct _FdoNotificationsIface FdoNotificationsIface;

#define FDO_TYPE_NOTIFICATIONS_PROXY (fdo_notifications_proxy_get_type ())
typedef enum  {
	FDO_NOTIFICATIONS_CLOSE_REASON_EXPIRED = 1,
	FDO_NOTIFICATIONS_CLOSE_REASON_DIMISSED,
	FDO_NOTIFICATIONS_CLOSE_REASON_CANCELLED
} FdoNotificationsCloseReason;

#define FDO_NOTIFICATIONS_TYPE_CLOSE_REASON (fdo_notifications_close_reason_get_type ())
enum  {
	FDO_NOTIFICATIONS_ACTION_INVOKED_SIGNAL,
	FDO_NOTIFICATIONS_NOTIFICATION_CLOSED_SIGNAL,
	FDO_NOTIFICATIONS_NUM_SIGNALS
};
static guint fdo_notifications_signals[FDO_NOTIFICATIONS_NUM_SIGNALS] = {0};
typedef GDBusProxy FdoNotificationsProxy;
typedef GDBusProxyClass FdoNotificationsProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _FdoNotificationsCloseNotificationReadyData FdoNotificationsCloseNotificationReadyData;
typedef struct _FdoNotificationsNotifyReadyData FdoNotificationsNotifyReadyData;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define BACKGROUND_TYPE_NOTIFICATION_REQUEST (background_notification_request_get_type ())
#define BACKGROUND_NOTIFICATION_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BACKGROUND_TYPE_NOTIFICATION_REQUEST, BackgroundNotificationRequest))
#define BACKGROUND_NOTIFICATION_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BACKGROUND_TYPE_NOTIFICATION_REQUEST, BackgroundNotificationRequestClass))
#define BACKGROUND_IS_NOTIFICATION_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BACKGROUND_TYPE_NOTIFICATION_REQUEST))
#define BACKGROUND_IS_NOTIFICATION_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BACKGROUND_TYPE_NOTIFICATION_REQUEST))
#define BACKGROUND_NOTIFICATION_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BACKGROUND_TYPE_NOTIFICATION_REQUEST, BackgroundNotificationRequestClass))

typedef struct _BackgroundNotificationRequest BackgroundNotificationRequest;
typedef struct _BackgroundNotificationRequestClass BackgroundNotificationRequestClass;
typedef struct _BackgroundNotificationRequestPrivate BackgroundNotificationRequestPrivate;
enum  {
	BACKGROUND_NOTIFICATION_REQUEST_0_PROPERTY,
	BACKGROUND_NOTIFICATION_REQUEST_NUM_PROPERTIES
};
static GParamSpec* background_notification_request_properties[BACKGROUND_NOTIFICATION_REQUEST_NUM_PROPERTIES];
typedef enum  {
	BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_FORBID,
	BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_ALLOW,
	BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_ALLOW_ONCE,
	BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_CANCELLED,
	BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_FAILED
} BackgroundNotificationRequestNotifyBackgroundResult;

#define BACKGROUND_NOTIFICATION_REQUEST_TYPE_NOTIFY_BACKGROUND_RESULT (background_notification_request_notify_background_result_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _BackgroundNotificationRequestSendNotificationData BackgroundNotificationRequestSendNotificationData;
typedef struct _BackgroundNotificationRequestCloseData BackgroundNotificationRequestCloseData;
enum  {
	BACKGROUND_NOTIFICATION_REQUEST_RESPONSE_SIGNAL,
	BACKGROUND_NOTIFICATION_REQUEST_NUM_SIGNALS
};
static guint background_notification_request_signals[BACKGROUND_NOTIFICATION_REQUEST_NUM_SIGNALS] = {0};
typedef struct _BackgroundNotificationRequestCloseReadyData BackgroundNotificationRequestCloseReadyData;

struct _FdoNotificationsIface {
	GTypeInterface parent_iface;
	void (*close_notification) (FdoNotifications* self, guint32 id, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*close_notification_finish) (FdoNotifications* self, GAsyncResult* _res_, GError** error);
	void (*notify) (FdoNotifications* self, const gchar* app_name, guint32 replaces_id, const gchar* app_icon, const gchar* summary, const gchar* body, gchar** actions, gint actions_length1, GHashTable* hints, gint32 expire_timeout, GAsyncReadyCallback _callback_, gpointer _user_data_);
	guint32 (*notify_finish) (FdoNotifications* self, GAsyncResult* _res_, GError** error);
};

struct _FdoNotificationsCloseNotificationReadyData {
	GDBusMethodInvocation* _invocation_;
	guint32 id;
};

struct _FdoNotificationsNotifyReadyData {
	GDBusMethodInvocation* _invocation_;
	gchar* app_name;
	guint32 replaces_id;
	gchar* app_icon;
	gchar* summary;
	gchar* body;
	gchar** actions;
	gint actions_length1;
	GHashTable* hints;
	gint32 expire_timeout;
};

struct _BackgroundNotificationRequest {
	GObject parent_instance;
	BackgroundNotificationRequestPrivate * priv;
};

struct _BackgroundNotificationRequestClass {
	GObjectClass parent_class;
};

struct _BackgroundNotificationRequestPrivate {
	guint32 id;
};

struct _BackgroundNotificationRequestSendNotificationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BackgroundNotificationRequest* self;
	gchar* app_id;
	gchar* app_name;
	FdoNotifications* _tmp0_;
	FdoNotifications* _tmp1_;
	FdoNotifications* _tmp2_;
	FdoNotifications* _tmp3_;
	FdoNotifications* _tmp4_;
	FdoNotifications* _tmp5_;
	gchar** actions;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gint actions_length1;
	gint _actions_size_;
	GHashTable* hints;
	GHashTable* _tmp11_;
	GHashTable* _tmp12_;
	gchar* _tmp13_;
	GVariant* _tmp14_;
	GHashTable* _tmp15_;
	gchar* _tmp16_;
	GVariant* _tmp17_;
	guint32 _tmp18_;
	FdoNotifications* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	GHashTable* _tmp23_;
	guint32 _tmp24_;
	GHashTable* _tmp25_;
	GError* _inner_error0_;
};

struct _BackgroundNotificationRequestCloseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BackgroundNotificationRequest* self;
	FdoNotifications* _tmp0_;
	GError* _inner_error0_;
};

struct _BackgroundNotificationRequestCloseReadyData {
	GDBusMethodInvocation* _invocation_;
};

static gint BackgroundNotificationRequest_private_offset;
static gpointer background_notification_request_parent_class = NULL;
static GHashTable* background_notification_request_requests;
static GHashTable* background_notification_request_requests = NULL;
static FdoNotifications* background_notification_request_notifications;
static FdoNotifications* background_notification_request_notifications = NULL;

VALA_EXTERN GType fdo_notifications_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint fdo_notifications_register_object (void* object,
                                         GDBusConnection* connection,
                                         const gchar* path,
                                         GError** error);
VALA_EXTERN GType fdo_notifications_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FdoNotifications, g_object_unref)
VALA_EXTERN GType fdo_notifications_close_reason_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void fdo_notifications_close_notification (FdoNotifications* self,
                                           guint32 id,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
VALA_EXTERN void fdo_notifications_close_notification_finish (FdoNotifications* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
VALA_EXTERN void fdo_notifications_notify (FdoNotifications* self,
                               const gchar* app_name,
                               guint32 replaces_id,
                               const gchar* app_icon,
                               const gchar* summary,
                               const gchar* body,
                               gchar** actions,
                               gint actions_length1,
                               GHashTable* hints,
                               gint32 expire_timeout,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN guint32 fdo_notifications_notify_finish (FdoNotifications* self,
                                         GAsyncResult* _res_,
                                         GError** error);
static void g_cclosure_user_marshal_VOID__UINT_STRING (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UINT_ENUM (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GType fdo_notifications_get_type_once (void);
static void fdo_notifications_proxy_g_signal (GDBusProxy* proxy,
                                       const gchar* sender_name,
                                       const gchar* signal_name,
                                       GVariant* parameters);
static void _dbus_handle_fdo_notifications_action_invoked (FdoNotifications* self,
                                                    GVariant* parameters);
static void _dbus_handle_fdo_notifications_notification_closed (FdoNotifications* self,
                                                         GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object,
                                   GAsyncResult *res,
                                   void *user_data);
static void fdo_notifications_proxy_close_notification_async (FdoNotifications* self,
                                                       guint32 id,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void fdo_notifications_proxy_close_notification_finish (FdoNotifications* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
static void fdo_notifications_proxy_notify_async (FdoNotifications* self,
                                           const gchar* app_name,
                                           guint32 replaces_id,
                                           const gchar* app_icon,
                                           const gchar* summary,
                                           const gchar* body,
                                           gchar** actions,
                                           gint actions_length1,
                                           GHashTable* hints,
                                           gint32 expire_timeout,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static guint32 fdo_notifications_proxy_notify_finish (FdoNotifications* self,
                                               GAsyncResult* _res_,
                                               GError** error);
static void fdo_notifications_proxy_fdo_notifications_interface_init (FdoNotificationsIface* iface);
static void _dbus_fdo_notifications_close_notification (FdoNotifications* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation);
static void _dbus_fdo_notifications_close_notification_ready (GObject * source_object,
                                                       GAsyncResult * _res_,
                                                       gpointer _user_data_);
static void _dbus_fdo_notifications_notify (FdoNotifications* self,
                                     GVariant* _parameters_,
                                     GDBusMethodInvocation* invocation);
static void _dbus_fdo_notifications_notify_ready (GObject * source_object,
                                           GAsyncResult * _res_,
                                           gpointer _user_data_);
static void fdo_notifications_dbus_interface_method_call (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* method_name,
                                                   GVariant* parameters,
                                                   GDBusMethodInvocation* invocation,
                                                   gpointer user_data);
static GVariant* fdo_notifications_dbus_interface_get_property (GDBusConnection* connection,
                                                         const gchar* sender,
                                                         const gchar* object_path,
                                                         const gchar* interface_name,
                                                         const gchar* property_name,
                                                         GError** error,
                                                         gpointer user_data);
static gboolean fdo_notifications_dbus_interface_set_property (GDBusConnection* connection,
                                                        const gchar* sender,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* property_name,
                                                        GVariant* value,
                                                        GError** error,
                                                        gpointer user_data);
static void _dbus_fdo_notifications_action_invoked (GObject* _sender,
                                             guint32 id,
                                             const gchar* action_key,
                                             gpointer* _data);
static void _dbus_fdo_notifications_notification_closed (GObject* _sender,
                                                  guint32 id,
                                                  FdoNotificationsCloseReason reason,
                                                  gpointer* _data);
static void _fdo_notifications_unregister_object (gpointer user_data);
VALA_EXTERN GType background_notification_request_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackgroundNotificationRequest, g_object_unref)
VALA_EXTERN guint background_notification_request_register_object (void* object,
                                                       GDBusConnection* connection,
                                                       const gchar* path,
                                                       GError** error);
VALA_EXTERN GType background_notification_request_notify_background_result_get_type (void) G_GNUC_CONST ;
static void background_notification_request_action_invoked (guint32 id,
                                                     const gchar* action_key);
static void background_notification_request_notification_closed (guint32 id,
                                                          FdoNotificationsCloseReason reason);
static void background_notification_request_send_notification_data_free (gpointer _data);
VALA_EXTERN void background_notification_request_send_notification (BackgroundNotificationRequest* self,
                                                        const gchar* app_id,
                                                        const gchar* app_name,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
VALA_EXTERN void background_notification_request_send_notification_finish (BackgroundNotificationRequest* self,
                                                               GAsyncResult* _res_,
                                                               GError** error);
static gboolean background_notification_request_send_notification_co (BackgroundNotificationRequestSendNotificationData* _data_);
static void background_notification_request_send_notification_ready (GObject* source_object,
                                                              GAsyncResult* _res_,
                                                              gpointer _user_data_);
static void _background_notification_request_action_invoked_fdo_notifications_action_invoked (FdoNotifications* _sender,
                                                                                       guint32 id,
                                                                                       const gchar* action_key,
                                                                                       gpointer self);
static void _background_notification_request_notification_closed_fdo_notifications_notification_closed (FdoNotifications* _sender,
                                                                                                 guint32 id,
                                                                                                 FdoNotificationsCloseReason reason,
                                                                                                 gpointer self);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
static GVariant* _variant_new2 (const gchar* value);
static GVariant* _variant_new3 (guint8 value);
static void background_notification_request_close_data_free (gpointer _data);
VALA_EXTERN void background_notification_request_close (BackgroundNotificationRequest* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN void background_notification_request_close_finish (BackgroundNotificationRequest* self,
                                                   GAsyncResult* _res_,
                                                   GError** error);
static gboolean background_notification_request_close_co (BackgroundNotificationRequestCloseData* _data_);
static void background_notification_request_close_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
VALA_EXTERN BackgroundNotificationRequest* background_notification_request_new (void);
VALA_EXTERN BackgroundNotificationRequest* background_notification_request_construct (GType object_type);
static void background_notification_request_finalize (GObject * obj);
static GType background_notification_request_get_type_once (void);
static void _dbus_background_notification_request_close (BackgroundNotificationRequest* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation);
static void _dbus_background_notification_request_close_ready (GObject * source_object,
                                                        GAsyncResult * _res_,
                                                        gpointer _user_data_);
static void background_notification_request_dbus_interface_method_call (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* method_name,
                                                                 GVariant* parameters,
                                                                 GDBusMethodInvocation* invocation,
                                                                 gpointer user_data);
static GVariant* background_notification_request_dbus_interface_get_property (GDBusConnection* connection,
                                                                       const gchar* sender,
                                                                       const gchar* object_path,
                                                                       const gchar* interface_name,
                                                                       const gchar* property_name,
                                                                       GError** error,
                                                                       gpointer user_data);
static gboolean background_notification_request_dbus_interface_set_property (GDBusConnection* connection,
                                                                      const gchar* sender,
                                                                      const gchar* object_path,
                                                                      const gchar* interface_name,
                                                                      const gchar* property_name,
                                                                      GVariant* value,
                                                                      GError** error,
                                                                      gpointer user_data);
static void _background_notification_request_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo _fdo_notifications_dbus_arg_info_close_notification_id = {-1, "id", "u", NULL};
static const GDBusArgInfo * const _fdo_notifications_dbus_arg_info_close_notification_in[] = {&_fdo_notifications_dbus_arg_info_close_notification_id, NULL};
static const GDBusArgInfo * const _fdo_notifications_dbus_arg_info_close_notification_out[] = {NULL};
static const GDBusMethodInfo _fdo_notifications_dbus_method_info_close_notification = {-1, "CloseNotification", (GDBusArgInfo **) (&_fdo_notifications_dbus_arg_info_close_notification_in), (GDBusArgInfo **) (&_fdo_notifications_dbus_arg_info_close_notification_out), NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notify_app_name = {-1, "app_name", "s", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notify_replaces_id = {-1, "replaces_id", "u", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notify_app_icon = {-1, "app_icon", "s", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notify_summary = {-1, "summary", "s", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notify_body = {-1, "body", "s", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notify_actions = {-1, "actions", "as", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notify_hints = {-1, "hints", "a{sv}", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notify_expire_timeout = {-1, "expire_timeout", "i", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notify_result = {-1, "result", "u", NULL};
static const GDBusArgInfo * const _fdo_notifications_dbus_arg_info_notify_in[] = {&_fdo_notifications_dbus_arg_info_notify_app_name, &_fdo_notifications_dbus_arg_info_notify_replaces_id, &_fdo_notifications_dbus_arg_info_notify_app_icon, &_fdo_notifications_dbus_arg_info_notify_summary, &_fdo_notifications_dbus_arg_info_notify_body, &_fdo_notifications_dbus_arg_info_notify_actions, &_fdo_notifications_dbus_arg_info_notify_hints, &_fdo_notifications_dbus_arg_info_notify_expire_timeout, NULL};
static const GDBusArgInfo * const _fdo_notifications_dbus_arg_info_notify_out[] = {&_fdo_notifications_dbus_arg_info_notify_result, NULL};
static const GDBusMethodInfo _fdo_notifications_dbus_method_info_notify = {-1, "Notify", (GDBusArgInfo **) (&_fdo_notifications_dbus_arg_info_notify_in), (GDBusArgInfo **) (&_fdo_notifications_dbus_arg_info_notify_out), NULL};
static const GDBusMethodInfo * const _fdo_notifications_dbus_method_info[] = {&_fdo_notifications_dbus_method_info_close_notification, &_fdo_notifications_dbus_method_info_notify, NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_action_invoked_id = {-1, "id", "u", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_action_invoked_action_key = {-1, "action_key", "s", NULL};
static const GDBusArgInfo * const _fdo_notifications_dbus_arg_info_action_invoked[] = {&_fdo_notifications_dbus_arg_info_action_invoked_id, &_fdo_notifications_dbus_arg_info_action_invoked_action_key, NULL};
static const GDBusSignalInfo _fdo_notifications_dbus_signal_info_action_invoked = {-1, "ActionInvoked", (GDBusArgInfo **) (&_fdo_notifications_dbus_arg_info_action_invoked), NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notification_closed_id = {-1, "id", "u", NULL};
static const GDBusArgInfo _fdo_notifications_dbus_arg_info_notification_closed_reason = {-1, "reason", "u", NULL};
static const GDBusArgInfo * const _fdo_notifications_dbus_arg_info_notification_closed[] = {&_fdo_notifications_dbus_arg_info_notification_closed_id, &_fdo_notifications_dbus_arg_info_notification_closed_reason, NULL};
static const GDBusSignalInfo _fdo_notifications_dbus_signal_info_notification_closed = {-1, "NotificationClosed", (GDBusArgInfo **) (&_fdo_notifications_dbus_arg_info_notification_closed), NULL};
static const GDBusSignalInfo * const _fdo_notifications_dbus_signal_info[] = {&_fdo_notifications_dbus_signal_info_action_invoked, &_fdo_notifications_dbus_signal_info_notification_closed, NULL};
static const GDBusPropertyInfo * const _fdo_notifications_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _fdo_notifications_dbus_interface_info = {-1, "org.freedesktop.Notifications", (GDBusMethodInfo **) (&_fdo_notifications_dbus_method_info), (GDBusSignalInfo **) (&_fdo_notifications_dbus_signal_info), (GDBusPropertyInfo **) (&_fdo_notifications_dbus_property_info), NULL};
static const GDBusInterfaceVTable _fdo_notifications_dbus_interface_vtable = {fdo_notifications_dbus_interface_method_call, fdo_notifications_dbus_interface_get_property, fdo_notifications_dbus_interface_set_property};
static const GDBusArgInfo * const _background_notification_request_dbus_arg_info_close_in[] = {NULL};
static const GDBusArgInfo * const _background_notification_request_dbus_arg_info_close_out[] = {NULL};
static const GDBusMethodInfo _background_notification_request_dbus_method_info_close = {-1, "Close", (GDBusArgInfo **) (&_background_notification_request_dbus_arg_info_close_in), (GDBusArgInfo **) (&_background_notification_request_dbus_arg_info_close_out), NULL};
static const GDBusMethodInfo * const _background_notification_request_dbus_method_info[] = {&_background_notification_request_dbus_method_info_close, NULL};
static const GDBusSignalInfo * const _background_notification_request_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _background_notification_request_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _background_notification_request_dbus_interface_info = {-1, "org.freedesktop.impl.portal.Request", (GDBusMethodInfo **) (&_background_notification_request_dbus_method_info), (GDBusSignalInfo **) (&_background_notification_request_dbus_signal_info), (GDBusPropertyInfo **) (&_background_notification_request_dbus_property_info), NULL};
static const GDBusInterfaceVTable _background_notification_request_dbus_interface_vtable = {background_notification_request_dbus_interface_method_call, background_notification_request_dbus_interface_get_property, background_notification_request_dbus_interface_set_property};

static GType
fdo_notifications_close_reason_get_type_once (void)
{
	static const GEnumValue values[] = {{FDO_NOTIFICATIONS_CLOSE_REASON_EXPIRED, "FDO_NOTIFICATIONS_CLOSE_REASON_EXPIRED", "expired"}, {FDO_NOTIFICATIONS_CLOSE_REASON_DIMISSED, "FDO_NOTIFICATIONS_CLOSE_REASON_DIMISSED", "dimissed"}, {FDO_NOTIFICATIONS_CLOSE_REASON_CANCELLED, "FDO_NOTIFICATIONS_CLOSE_REASON_CANCELLED", "cancelled"}, {0, NULL, NULL}};
	GType fdo_notifications_close_reason_type_id;
	fdo_notifications_close_reason_type_id = g_enum_register_static ("FdoNotificationsCloseReason", values);
	return fdo_notifications_close_reason_type_id;
}

GType
fdo_notifications_close_reason_get_type (void)
{
	static volatile gsize fdo_notifications_close_reason_type_id__once = 0;
	if (g_once_init_enter (&fdo_notifications_close_reason_type_id__once)) {
		GType fdo_notifications_close_reason_type_id;
		fdo_notifications_close_reason_type_id = fdo_notifications_close_reason_get_type_once ();
		g_once_init_leave (&fdo_notifications_close_reason_type_id__once, fdo_notifications_close_reason_type_id);
	}
	return fdo_notifications_close_reason_type_id__once;
}

void
fdo_notifications_close_notification (FdoNotifications* self,
                                      guint32 id,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	FdoNotificationsIface* _iface_;
	_iface_ = FDO_NOTIFICATIONS_GET_INTERFACE (self);
	if (_iface_->close_notification) {
		_iface_->close_notification (self, id, _callback_, _user_data_);
	}
}

void
fdo_notifications_close_notification_finish (FdoNotifications* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	FdoNotificationsIface* _iface_;
	_iface_ = FDO_NOTIFICATIONS_GET_INTERFACE (self);
	if (_iface_->close_notification_finish) {
		_iface_->close_notification_finish (self, _res_, error);
	}
}

void
fdo_notifications_notify (FdoNotifications* self,
                          const gchar* app_name,
                          guint32 replaces_id,
                          const gchar* app_icon,
                          const gchar* summary,
                          const gchar* body,
                          gchar** actions,
                          gint actions_length1,
                          GHashTable* hints,
                          gint32 expire_timeout,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	FdoNotificationsIface* _iface_;
	_iface_ = FDO_NOTIFICATIONS_GET_INTERFACE (self);
	if (_iface_->notify) {
		_iface_->notify (self, app_name, replaces_id, app_icon, summary, body, actions, actions_length1, hints, expire_timeout, _callback_, _user_data_);
	}
}

guint32
fdo_notifications_notify_finish (FdoNotifications* self,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	FdoNotificationsIface* _iface_;
	_iface_ = FDO_NOTIFICATIONS_GET_INTERFACE (self);
	if (_iface_->notify_finish) {
		return _iface_->notify_finish (self, _res_, error);
	}
	return 0U;
}

static void
g_cclosure_user_marshal_VOID__UINT_STRING (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_STRING) (gpointer data1, guint32 arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_string (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__UINT_ENUM (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT_ENUM) (gpointer data1, guint32 arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__UINT_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_enum (param_values + 2), data2);
}

static void
fdo_notifications_default_init (FdoNotificationsIface * iface,
                                gpointer iface_data)
{
	fdo_notifications_signals[FDO_NOTIFICATIONS_ACTION_INVOKED_SIGNAL] = g_signal_new ("action-invoked", FDO_TYPE_NOTIFICATIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_STRING, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_STRING);
	fdo_notifications_signals[FDO_NOTIFICATIONS_NOTIFICATION_CLOSED_SIGNAL] = g_signal_new ("notification-closed", FDO_TYPE_NOTIFICATIONS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_ENUM, G_TYPE_NONE, 2, G_TYPE_UINT, FDO_NOTIFICATIONS_TYPE_CLOSE_REASON);
}

static GType
fdo_notifications_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FdoNotificationsIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fdo_notifications_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType fdo_notifications_type_id;
	fdo_notifications_type_id = g_type_register_static (G_TYPE_INTERFACE, "FdoNotifications", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (fdo_notifications_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (fdo_notifications_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) fdo_notifications_proxy_get_type);
	g_type_set_qdata (fdo_notifications_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.Notifications");
	g_type_set_qdata (fdo_notifications_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_fdo_notifications_dbus_interface_info));
	g_type_set_qdata (fdo_notifications_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) fdo_notifications_register_object);
	return fdo_notifications_type_id;
}

GType
fdo_notifications_get_type (void)
{
	static volatile gsize fdo_notifications_type_id__once = 0;
	if (g_once_init_enter (&fdo_notifications_type_id__once)) {
		GType fdo_notifications_type_id;
		fdo_notifications_type_id = fdo_notifications_get_type_once ();
		g_once_init_leave (&fdo_notifications_type_id__once, fdo_notifications_type_id);
	}
	return fdo_notifications_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (FdoNotificationsProxy, fdo_notifications_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (FDO_TYPE_NOTIFICATIONS, fdo_notifications_proxy_fdo_notifications_interface_init) )
static void
fdo_notifications_proxy_class_init (FdoNotificationsProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = fdo_notifications_proxy_g_signal;
}

static void
_dbus_handle_fdo_notifications_action_invoked (FdoNotifications* self,
                                               GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint32 id = 0U;
	GVariant* _tmp36_;
	gchar* action_key = NULL;
	GVariant* _tmp37_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp36_ = g_variant_iter_next_value (&_arguments_iter);
	id = g_variant_get_uint32 (_tmp36_);
	g_variant_unref (_tmp36_);
	_tmp37_ = g_variant_iter_next_value (&_arguments_iter);
	action_key = g_variant_dup_string (_tmp37_, NULL);
	g_variant_unref (_tmp37_);
	g_signal_emit_by_name (self, "action-invoked", id, action_key);
	_g_free0 (action_key);
}

static void
_dbus_handle_fdo_notifications_notification_closed (FdoNotifications* self,
                                                    GVariant* parameters)
{
	GVariantIter _arguments_iter;
	guint32 id = 0U;
	GVariant* _tmp38_;
	FdoNotificationsCloseReason reason = 0;
	GVariant* _tmp39_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp38_ = g_variant_iter_next_value (&_arguments_iter);
	id = g_variant_get_uint32 (_tmp38_);
	g_variant_unref (_tmp38_);
	_tmp39_ = g_variant_iter_next_value (&_arguments_iter);
	reason = g_variant_get_uint32 (_tmp39_);
	g_variant_unref (_tmp39_);
	g_signal_emit_by_name (self, "notification-closed", id, reason);
}

static void
fdo_notifications_proxy_g_signal (GDBusProxy* proxy,
                                  const gchar* sender_name,
                                  const gchar* signal_name,
                                  GVariant* parameters)
{
	if (strcmp (signal_name, "ActionInvoked") == 0) {
		_dbus_handle_fdo_notifications_action_invoked ((FdoNotifications*) proxy, parameters);
	} else if (strcmp (signal_name, "NotificationClosed") == 0) {
		_dbus_handle_fdo_notifications_notification_closed ((FdoNotifications*) proxy, parameters);
	}
}

static void
fdo_notifications_proxy_init (FdoNotificationsProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_fdo_notifications_dbus_interface_info));
}

static void
_vala_g_async_ready_callback (GObject *source_object,
                              GAsyncResult *res,
                              void *user_data)
{
	g_task_return_pointer (user_data, g_object_ref (res), g_object_unref);
	g_object_unref (user_data);
}

static void
fdo_notifications_proxy_close_notification_async (FdoNotifications* self,
                                                  guint32 id,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.Notifications", "CloseNotification");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (id));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	if (_callback_ != NULL) {
		g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
	} else {
		g_dbus_message_set_flags (_message, G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED);
		g_dbus_connection_send_message (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	}
	g_object_unref (_message);
}

static void
fdo_notifications_proxy_close_notification_finish (FdoNotifications* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
	g_object_unref (_inner_res);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
fdo_notifications_proxy_notify_async (FdoNotifications* self,
                                      const gchar* app_name,
                                      guint32 replaces_id,
                                      const gchar* app_icon,
                                      const gchar* summary,
                                      const gchar* body,
                                      gchar** actions,
                                      gint actions_length1,
                                      GHashTable* hints,
                                      gint32 expire_timeout,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	gchar** _tmp40_;
	GVariantBuilder _tmp41_;
	gint _tmp42_;
	GVariantBuilder _tmp43_;
	GHashTableIter _tmp44_;
	gpointer _tmp45_;
	gpointer _tmp46_;
	G_DBUS_ERROR;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.Notifications", "Notify");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_name));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (replaces_id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (app_icon));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (summary));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (body));
	_tmp40_ = actions;
	g_variant_builder_init (&_tmp41_, G_VARIANT_TYPE ("as"));
	for (_tmp42_ = 0; _tmp42_ < actions_length1; _tmp42_++) {
		g_variant_builder_add_value (&_tmp41_, g_variant_new_string (*_tmp40_));
		_tmp40_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp41_));
	g_hash_table_iter_init (&_tmp44_, hints);
	g_variant_builder_init (&_tmp43_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp44_, &_tmp45_, &_tmp46_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp45_;
		_value = (GVariant*) _tmp46_;
		g_variant_builder_add (&_tmp43_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp43_));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (expire_timeout));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	if (_callback_ != NULL) {
		g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
	} else {
		g_dbus_message_set_flags (_message, G_DBUS_MESSAGE_FLAGS_NO_REPLY_EXPECTED);
		g_dbus_connection_send_message (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	}
	g_object_unref (_message);
}

static guint32
fdo_notifications_proxy_notify_finish (FdoNotifications* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint32 _result = 0U;
	GVariant* _tmp49_;
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
	g_object_unref (_inner_res);
	if (!_reply_message) {
		guint32 _tmp47_ = 0U;
		return _tmp47_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		guint32 _tmp48_ = 0U;
		g_object_unref (_reply_message);
		return _tmp48_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp49_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_uint32 (_tmp49_);
	g_variant_unref (_tmp49_);
	g_object_unref (_reply_message);
	return _result;
}

static void
fdo_notifications_proxy_fdo_notifications_interface_init (FdoNotificationsIface* iface)
{
	iface->close_notification = fdo_notifications_proxy_close_notification_async;
	iface->close_notification_finish = fdo_notifications_proxy_close_notification_finish;
	iface->notify = fdo_notifications_proxy_notify_async;
	iface->notify_finish = fdo_notifications_proxy_notify_finish;
}

static void
_dbus_fdo_notifications_close_notification (FdoNotifications* self,
                                            GVariant* _parameters_,
                                            GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	FdoNotificationsCloseNotificationReadyData* _ready_data;
	GVariant* _tmp50_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (FdoNotificationsCloseNotificationReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp50_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->id = g_variant_get_uint32 (_tmp50_);
	g_variant_unref (_tmp50_);
	fdo_notifications_close_notification (self, _ready_data->id, (GAsyncReadyCallback) _dbus_fdo_notifications_close_notification_ready, _ready_data);
}

static void
_dbus_fdo_notifications_close_notification_ready (GObject * source_object,
                                                  GAsyncResult * _res_,
                                                  gpointer _user_data_)
{
	FdoNotificationsCloseNotificationReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	fdo_notifications_close_notification_finish ((FdoNotifications*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	g_slice_free (FdoNotificationsCloseNotificationReadyData, _ready_data);
}

static void
_dbus_fdo_notifications_notify (FdoNotifications* self,
                                GVariant* _parameters_,
                                GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	FdoNotificationsNotifyReadyData* _ready_data;
	GVariant* _tmp51_;
	GVariant* _tmp52_;
	GVariant* _tmp53_;
	GVariant* _tmp54_;
	GVariant* _tmp55_;
	GVariant* _tmp56_;
	gchar** _tmp57_;
	gint _tmp57__length;
	gint _tmp57__size;
	gint _tmp57__length1;
	GVariantIter _tmp58_;
	GVariant* _tmp59_;
	GVariant* _tmp60_;
	GHashTable* _tmp61_;
	GVariantIter _tmp62_;
	GVariant* _tmp63_;
	GVariant* _tmp64_;
	GVariant* _tmp65_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (FdoNotificationsNotifyReadyData);
	_ready_data->_invocation_ = invocation;
	_tmp51_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->app_name = g_variant_dup_string (_tmp51_, NULL);
	g_variant_unref (_tmp51_);
	_tmp52_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->replaces_id = g_variant_get_uint32 (_tmp52_);
	g_variant_unref (_tmp52_);
	_tmp53_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->app_icon = g_variant_dup_string (_tmp53_, NULL);
	g_variant_unref (_tmp53_);
	_tmp54_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->summary = g_variant_dup_string (_tmp54_, NULL);
	g_variant_unref (_tmp54_);
	_tmp55_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->body = g_variant_dup_string (_tmp55_, NULL);
	g_variant_unref (_tmp55_);
	_tmp56_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp57_ = g_new (gchar*, 5);
	_tmp57__length = 0;
	_tmp57__size = 4;
	_tmp57__length1 = 0;
	g_variant_iter_init (&_tmp58_, _tmp56_);
	for (; (_tmp59_ = g_variant_iter_next_value (&_tmp58_)) != NULL; _tmp57__length1++) {
		if (_tmp57__size == _tmp57__length) {
			_tmp57__size = 2 * _tmp57__size;
			_tmp57_ = g_renew (gchar*, _tmp57_, _tmp57__size + 1);
		}
		_tmp57_[_tmp57__length++] = g_variant_dup_string (_tmp59_, NULL);
		g_variant_unref (_tmp59_);
	}
	_ready_data->actions_length1 = _tmp57__length1;
	_tmp57_[_tmp57__length] = NULL;
	_ready_data->actions = _tmp57_;
	g_variant_unref (_tmp56_);
	_tmp60_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp61_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp62_, _tmp60_);
	while (g_variant_iter_loop (&_tmp62_, "{?*}", &_tmp63_, &_tmp64_)) {
		g_hash_table_insert (_tmp61_, g_variant_dup_string (_tmp63_, NULL), g_variant_get_variant (_tmp64_));
	}
	_ready_data->hints = _tmp61_;
	g_variant_unref (_tmp60_);
	_tmp65_ = g_variant_iter_next_value (&_arguments_iter);
	_ready_data->expire_timeout = g_variant_get_int32 (_tmp65_);
	g_variant_unref (_tmp65_);
	fdo_notifications_notify (self, _ready_data->app_name, _ready_data->replaces_id, _ready_data->app_icon, _ready_data->summary, _ready_data->body, _ready_data->actions, _ready_data->actions_length1, _ready_data->hints, _ready_data->expire_timeout, (GAsyncReadyCallback) _dbus_fdo_notifications_notify_ready, _ready_data);
	_error:
	;
}

static void
_dbus_fdo_notifications_notify_ready (GObject * source_object,
                                      GAsyncResult * _res_,
                                      gpointer _user_data_)
{
	FdoNotificationsNotifyReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint32 result;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	result = fdo_notifications_notify_finish ((FdoNotifications*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (_ready_data->app_name);
	_g_free0 (_ready_data->app_icon);
	_g_free0 (_ready_data->summary);
	_g_free0 (_ready_data->body);
	_ready_data->actions = (_vala_array_free (_ready_data->actions, _ready_data->actions_length1, (GDestroyNotify) g_free), NULL);
	_g_hash_table_unref0 (_ready_data->hints);
	g_slice_free (FdoNotificationsNotifyReadyData, _ready_data);
}

static void
fdo_notifications_dbus_interface_method_call (GDBusConnection* connection,
                                              const gchar* sender,
                                              const gchar* object_path,
                                              const gchar* interface_name,
                                              const gchar* method_name,
                                              GVariant* parameters,
                                              GDBusMethodInvocation* invocation,
                                              gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "CloseNotification") == 0) {
		_dbus_fdo_notifications_close_notification (object, parameters, invocation);
	} else if (strcmp (method_name, "Notify") == 0) {
		_dbus_fdo_notifications_notify (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
fdo_notifications_dbus_interface_get_property (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* property_name,
                                               GError** error,
                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
fdo_notifications_dbus_interface_set_property (GDBusConnection* connection,
                                               const gchar* sender,
                                               const gchar* object_path,
                                               const gchar* interface_name,
                                               const gchar* property_name,
                                               GVariant* value,
                                               GError** error,
                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static void
_dbus_fdo_notifications_action_invoked (GObject* _sender,
                                        guint32 id,
                                        const gchar* action_key,
                                        gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (action_key));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.Notifications", "ActionInvoked", _arguments, NULL);
}

static void
_dbus_fdo_notifications_notification_closed (GObject* _sender,
                                             guint32 id,
                                             FdoNotificationsCloseReason reason,
                                             gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (id));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (reason));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.freedesktop.Notifications", "NotificationClosed", _arguments, NULL);
}

guint
fdo_notifications_register_object (gpointer object,
                                   GDBusConnection* connection,
                                   const gchar* path,
                                   GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_fdo_notifications_dbus_interface_info), &_fdo_notifications_dbus_interface_vtable, data, _fdo_notifications_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "action-invoked", (GCallback) _dbus_fdo_notifications_action_invoked, data);
	g_signal_connect (object, "notification-closed", (GCallback) _dbus_fdo_notifications_notification_closed, data);
	return result;
}

static void
_fdo_notifications_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_fdo_notifications_action_invoked, data);
	g_signal_handlers_disconnect_by_func (data[0], _dbus_fdo_notifications_notification_closed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
background_notification_request_get_instance_private (BackgroundNotificationRequest* self)
{
	return G_STRUCT_MEMBER_P (self, BackgroundNotificationRequest_private_offset);
}

static GType
background_notification_request_notify_background_result_get_type_once (void)
{
	static const GEnumValue values[] = {{BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_FORBID, "BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_FORBID", "forbid"}, {BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_ALLOW, "BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_ALLOW", "allow"}, {BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_ALLOW_ONCE, "BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_ALLOW_ONCE", "allow-once"}, {BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_CANCELLED, "BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_CANCELLED", "cancelled"}, {BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_FAILED, "BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_FAILED", "failed"}, {0, NULL, NULL}};
	GType background_notification_request_notify_background_result_type_id;
	background_notification_request_notify_background_result_type_id = g_enum_register_static ("BackgroundNotificationRequestNotifyBackgroundResult", values);
	return background_notification_request_notify_background_result_type_id;
}

GType
background_notification_request_notify_background_result_get_type (void)
{
	static volatile gsize background_notification_request_notify_background_result_type_id__once = 0;
	if (g_once_init_enter (&background_notification_request_notify_background_result_type_id__once)) {
		GType background_notification_request_notify_background_result_type_id;
		background_notification_request_notify_background_result_type_id = background_notification_request_notify_background_result_get_type_once ();
		g_once_init_leave (&background_notification_request_notify_background_result_type_id__once, background_notification_request_notify_background_result_type_id);
	}
	return background_notification_request_notify_background_result_type_id__once;
}

static gpointer
_vala_g_hash_table_take (GHashTable* self,
                         gconstpointer key,
                         gboolean* exists)
{
	gboolean _vala_exists = FALSE;
	GHashTable* ht = NULL;
	void** htp = NULL;
	gconstpointer _tmp0_;
	gpointer result;
	g_return_val_if_fail (self != NULL, NULL);
	ht = NULL;
	htp = &ht;
	_tmp0_ = g_hash_table_lookup (self, key);
	*htp = _tmp0_;
	_vala_exists = g_hash_table_steal (self, key);
	result = ht;
	if (exists) {
		*exists = _vala_exists;
	}
	return result;
}

static void
background_notification_request_action_invoked (guint32 id,
                                                const gchar* action_key)
{
	BackgroundNotificationRequest* notification = NULL;
	GHashTable* _tmp0_;
	gpointer _tmp1_;
	BackgroundNotificationRequest* _tmp2_;
	g_return_if_fail (action_key != NULL);
	_tmp0_ = background_notification_request_requests;
	_tmp1_ = _vala_g_hash_table_take (_tmp0_, (gpointer) ((guintptr) id), NULL);
	notification = (BackgroundNotificationRequest*) _tmp1_;
	_tmp2_ = notification;
	if (_tmp2_ == NULL) {
		return;
	}
	if (g_strcmp0 (action_key, BACKGROUND_NOTIFICATION_REQUEST_ACTION_ALLOW_BACKGROUND) == 0) {
		BackgroundNotificationRequest* _tmp3_;
		_tmp3_ = notification;
		g_signal_emit (_tmp3_, background_notification_request_signals[BACKGROUND_NOTIFICATION_REQUEST_RESPONSE_SIGNAL], 0, BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_ALLOW);
	} else {
		BackgroundNotificationRequest* _tmp4_;
		_tmp4_ = notification;
		g_signal_emit (_tmp4_, background_notification_request_signals[BACKGROUND_NOTIFICATION_REQUEST_RESPONSE_SIGNAL], 0, BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_FORBID);
	}
}

static void
background_notification_request_notification_closed (guint32 id,
                                                     FdoNotificationsCloseReason reason)
{
	BackgroundNotificationRequest* notification = NULL;
	GHashTable* _tmp0_;
	gpointer _tmp1_;
	BackgroundNotificationRequest* _tmp2_;
	_tmp0_ = background_notification_request_requests;
	_tmp1_ = _vala_g_hash_table_take (_tmp0_, (gpointer) ((guintptr) id), NULL);
	notification = (BackgroundNotificationRequest*) _tmp1_;
	_tmp2_ = notification;
	if (_tmp2_ == NULL) {
		return;
	}
	if (reason == FDO_NOTIFICATIONS_CLOSE_REASON_CANCELLED) {
		BackgroundNotificationRequest* _tmp3_;
		_tmp3_ = notification;
		g_signal_emit (_tmp3_, background_notification_request_signals[BACKGROUND_NOTIFICATION_REQUEST_RESPONSE_SIGNAL], 0, BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_CANCELLED);
	} else {
		BackgroundNotificationRequest* _tmp4_;
		_tmp4_ = notification;
		g_signal_emit (_tmp4_, background_notification_request_signals[BACKGROUND_NOTIFICATION_REQUEST_RESPONSE_SIGNAL], 0, BACKGROUND_NOTIFICATION_REQUEST_NOTIFY_BACKGROUND_RESULT_ALLOW_ONCE);
	}
}

static void
background_notification_request_send_notification_data_free (gpointer _data)
{
	BackgroundNotificationRequestSendNotificationData* _data_;
	_data_ = _data;
	_g_free0 (_data_->app_id);
	_g_free0 (_data_->app_name);
	_g_object_unref0 (_data_->self);
	g_slice_free (BackgroundNotificationRequestSendNotificationData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
background_notification_request_send_notification (BackgroundNotificationRequest* self,
                                                   const gchar* app_id,
                                                   const gchar* app_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	BackgroundNotificationRequestSendNotificationData* _data_;
	BackgroundNotificationRequest* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (app_id != NULL);
	g_return_if_fail (app_name != NULL);
	_data_ = g_slice_new0 (BackgroundNotificationRequestSendNotificationData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, background_notification_request_send_notification_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (app_id);
	_g_free0 (_data_->app_id);
	_data_->app_id = _tmp1_;
	_tmp2_ = g_strdup (app_name);
	_g_free0 (_data_->app_name);
	_data_->app_name = _tmp2_;
	background_notification_request_send_notification_co (_data_);
}

void
background_notification_request_send_notification_finish (BackgroundNotificationRequest* self,
                                                          GAsyncResult* _res_,
                                                          GError** error)
{
	BackgroundNotificationRequestSendNotificationData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static void
background_notification_request_send_notification_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_)
{
	BackgroundNotificationRequestSendNotificationData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	background_notification_request_send_notification_co (_data_);
}

static void
_background_notification_request_action_invoked_fdo_notifications_action_invoked (FdoNotifications* _sender,
                                                                                  guint32 id,
                                                                                  const gchar* action_key,
                                                                                  gpointer self)
{
	background_notification_request_action_invoked (id, action_key);
}

static void
_background_notification_request_notification_closed_fdo_notifications_notification_closed (FdoNotifications* _sender,
                                                                                            guint32 id,
                                                                                            FdoNotificationsCloseReason reason,
                                                                                            gpointer self)
{
	background_notification_request_notification_closed (id, reason);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static void
_g_variant_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
}

static GVariant*
_variant_new2 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new3 (guint8 value)
{
	return g_variant_ref_sink (g_variant_new_byte (value));
}

static gboolean
background_notification_request_send_notification_co (BackgroundNotificationRequestSendNotificationData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = background_notification_request_notifications;
	if (_data_->_tmp0_ == NULL) {
		_data_->_state_ = 1;
		g_async_initable_new_async (FDO_TYPE_NOTIFICATIONS_PROXY, 0, NULL, background_notification_request_send_notification_ready, _data_, "g-flags", G_DBUS_PROXY_FLAGS_NONE, "g-name", FDO_NOTIFICATIONS_NAME, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", FDO_NOTIFICATIONS_PATH, "g-interface-name", "org.freedesktop.Notifications", NULL);
		return FALSE;
		_state_1:
		_data_->_tmp2_ = (FdoNotifications*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp1_ = (FdoNotifications*) _data_->_tmp2_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp3_ = _data_->_tmp1_;
		_data_->_tmp1_ = NULL;
		_g_object_unref0 (background_notification_request_notifications);
		background_notification_request_notifications = _data_->_tmp3_;
		_data_->_tmp4_ = background_notification_request_notifications;
		g_signal_connect (_data_->_tmp4_, "action-invoked", (GCallback) _background_notification_request_action_invoked_fdo_notifications_action_invoked, NULL);
		_data_->_tmp5_ = background_notification_request_notifications;
		g_signal_connect (_data_->_tmp5_, "notification-closed", (GCallback) _background_notification_request_notification_closed_fdo_notifications_notification_closed, NULL);
		_g_object_unref0 (_data_->_tmp1_);
	}
	_data_->_tmp6_ = g_strdup (BACKGROUND_NOTIFICATION_REQUEST_ACTION_ALLOW_BACKGROUND);
	_data_->_tmp7_ = g_strdup (_ ("Allow"));
	_data_->_tmp8_ = g_strdup (BACKGROUND_NOTIFICATION_REQUEST_ACTION_FORBID_BACKGROUND);
	_data_->_tmp9_ = g_strdup (_ ("Forbid"));
	_data_->_tmp10_ = g_new0 (gchar*, 4 + 1);
	_data_->_tmp10_[0] = _data_->_tmp6_;
	_data_->_tmp10_[1] = _data_->_tmp7_;
	_data_->_tmp10_[2] = _data_->_tmp8_;
	_data_->_tmp10_[3] = _data_->_tmp9_;
	_data_->actions = _data_->_tmp10_;
	_data_->actions_length1 = 4;
	_data_->_actions_size_ = _data_->actions_length1;
	_data_->_tmp11_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_variant_unref0_);
	_data_->hints = _data_->_tmp11_;
	_data_->_tmp12_ = _data_->hints;
	_data_->_tmp13_ = g_strdup ("desktop-entry");
	_data_->_tmp14_ = _variant_new2 (_data_->app_id);
	g_hash_table_insert (_data_->_tmp12_, _data_->_tmp13_, _data_->_tmp14_);
	_data_->_tmp15_ = _data_->hints;
	_data_->_tmp16_ = g_strdup ("urgency");
	_data_->_tmp17_ = _variant_new3 ((guint8) 1);
	g_hash_table_insert (_data_->_tmp15_, _data_->_tmp16_, _data_->_tmp17_);
	_data_->_tmp19_ = background_notification_request_notifications;
	_data_->_tmp20_ = g_strdup_printf (_ ("“%s” is running in the background without appropriate permission"), _data_->app_name);
	_data_->_tmp21_ = _data_->_tmp20_;
	_data_->_tmp22_ = _data_->actions;
	_data_->_tmp22__length1 = _data_->actions_length1;
	_data_->_tmp23_ = _data_->hints;
	_data_->_state_ = 2;
	fdo_notifications_notify (_data_->_tmp19_, _data_->app_name, (guint32) 0, "", _ ("Background activity"), _data_->_tmp21_, _data_->_tmp22_, (gint) _data_->_tmp22__length1, _data_->_tmp23_, (gint32) -1, background_notification_request_send_notification_ready, _data_);
	return FALSE;
	_state_2:
	_data_->_tmp24_ = fdo_notifications_notify_finish (_data_->_tmp19_, _data_->_res_, &_data_->_inner_error0_);
	_g_free0 (_data_->_tmp21_);
	_data_->_tmp18_ = _data_->_tmp24_;
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		_g_hash_table_unref0 (_data_->hints);
		_data_->actions = (_vala_array_free (_data_->actions, _data_->actions_length1, (GDestroyNotify) g_free), NULL);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->self->priv->id = _data_->_tmp18_;
	_data_->_tmp25_ = background_notification_request_requests;
	g_hash_table_insert (_data_->_tmp25_, (gpointer) ((guintptr) _data_->self->priv->id), _data_->self);
	_g_hash_table_unref0 (_data_->hints);
	_data_->actions = (_vala_array_free (_data_->actions, _data_->actions_length1, (GDestroyNotify) g_free), NULL);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
background_notification_request_close_data_free (gpointer _data)
{
	BackgroundNotificationRequestCloseData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (BackgroundNotificationRequestCloseData, _data_);
}

void
background_notification_request_close (BackgroundNotificationRequest* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	BackgroundNotificationRequestCloseData* _data_;
	BackgroundNotificationRequest* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (BackgroundNotificationRequestCloseData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, background_notification_request_close_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	background_notification_request_close_co (_data_);
}

void
background_notification_request_close_finish (BackgroundNotificationRequest* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	BackgroundNotificationRequestCloseData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static void
background_notification_request_close_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	BackgroundNotificationRequestCloseData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	background_notification_request_close_co (_data_);
}

static gboolean
background_notification_request_close_co (BackgroundNotificationRequestCloseData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_tmp0_ = background_notification_request_notifications;
		_data_->_state_ = 1;
		fdo_notifications_close_notification (_data_->_tmp0_, _data_->self->priv->id, background_notification_request_close_ready, _data_);
		return FALSE;
		_state_1:
		fdo_notifications_close_notification_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_data_->_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		if ((_data_->_inner_error0_->domain == G_DBUS_ERROR) || (_data_->_inner_error0_->domain == G_IO_ERROR)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

BackgroundNotificationRequest*
background_notification_request_construct (GType object_type)
{
	BackgroundNotificationRequest * self = NULL;
	self = (BackgroundNotificationRequest*) g_object_new (object_type, NULL);
	return self;
}

BackgroundNotificationRequest*
background_notification_request_new (void)
{
	return background_notification_request_construct (BACKGROUND_TYPE_NOTIFICATION_REQUEST);
}

static void
background_notification_request_class_init (BackgroundNotificationRequestClass * klass,
                                            gpointer klass_data)
{
	GHashTable* _tmp0_;
	background_notification_request_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BackgroundNotificationRequest_private_offset);
	G_OBJECT_CLASS (klass)->finalize = background_notification_request_finalize;
	background_notification_request_signals[BACKGROUND_NOTIFICATION_REQUEST_RESPONSE_SIGNAL] = g_signal_new ("response", BACKGROUND_TYPE_NOTIFICATION_REQUEST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, BACKGROUND_NOTIFICATION_REQUEST_TYPE_NOTIFY_BACKGROUND_RESULT);
	_tmp0_ = g_hash_table_new_full (NULL, NULL, NULL, NULL);
	_g_hash_table_unref0 (background_notification_request_requests);
	background_notification_request_requests = _tmp0_;
}

static void
background_notification_request_instance_init (BackgroundNotificationRequest * self,
                                               gpointer klass)
{
	self->priv = background_notification_request_get_instance_private (self);
	self->priv->id = (guint32) 0;
}

static void
background_notification_request_finalize (GObject * obj)
{
	BackgroundNotificationRequest * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BACKGROUND_TYPE_NOTIFICATION_REQUEST, BackgroundNotificationRequest);
	G_OBJECT_CLASS (background_notification_request_parent_class)->finalize (obj);
}

static GType
background_notification_request_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BackgroundNotificationRequestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_notification_request_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundNotificationRequest), 0, (GInstanceInitFunc) background_notification_request_instance_init, NULL };
	GType background_notification_request_type_id;
	background_notification_request_type_id = g_type_register_static (G_TYPE_OBJECT, "BackgroundNotificationRequest", &g_define_type_info, 0);
	g_type_set_qdata (background_notification_request_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) background_notification_request_register_object);
	BackgroundNotificationRequest_private_offset = g_type_add_instance_private (background_notification_request_type_id, sizeof (BackgroundNotificationRequestPrivate));
	return background_notification_request_type_id;
}

GType
background_notification_request_get_type (void)
{
	static volatile gsize background_notification_request_type_id__once = 0;
	if (g_once_init_enter (&background_notification_request_type_id__once)) {
		GType background_notification_request_type_id;
		background_notification_request_type_id = background_notification_request_get_type_once ();
		g_once_init_leave (&background_notification_request_type_id__once, background_notification_request_type_id);
	}
	return background_notification_request_type_id__once;
}

static void
_dbus_background_notification_request_close (BackgroundNotificationRequest* self,
                                             GVariant* _parameters_,
                                             GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	BackgroundNotificationRequestCloseReadyData* _ready_data;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (BackgroundNotificationRequestCloseReadyData);
	_ready_data->_invocation_ = invocation;
	background_notification_request_close (self, (GAsyncReadyCallback) _dbus_background_notification_request_close_ready, _ready_data);
}

static void
_dbus_background_notification_request_close_ready (GObject * source_object,
                                                   GAsyncResult * _res_,
                                                   gpointer _user_data_)
{
	BackgroundNotificationRequestCloseReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	background_notification_request_close_finish ((BackgroundNotificationRequest*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	g_slice_free (BackgroundNotificationRequestCloseReadyData, _ready_data);
}

static void
background_notification_request_dbus_interface_method_call (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* method_name,
                                                            GVariant* parameters,
                                                            GDBusMethodInvocation* invocation,
                                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Close") == 0) {
		_dbus_background_notification_request_close (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
background_notification_request_dbus_interface_get_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GError** error,
                                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}

static gboolean
background_notification_request_dbus_interface_set_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GVariant* value,
                                                             GError** error,
                                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
background_notification_request_register_object (gpointer object,
                                                 GDBusConnection* connection,
                                                 const gchar* path,
                                                 GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_background_notification_request_dbus_interface_info), &_background_notification_request_dbus_interface_vtable, data, _background_notification_request_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_background_notification_request_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

