/* Interface.c generated by valac 0.56.17, the Vala compiler
 * generated from Interface.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE (mutter_display_config_interface_get_type ())
#define MUTTER_DISPLAY_CONFIG_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, MutterDisplayConfigInterface))
#define IS_MUTTER_DISPLAY_CONFIG_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE))
#define MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, MutterDisplayConfigInterfaceIface))

typedef struct _MutterDisplayConfigInterface MutterDisplayConfigInterface;
typedef struct _MutterDisplayConfigInterfaceIface MutterDisplayConfigInterfaceIface;

#define TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE_PROXY (mutter_display_config_interface_proxy_get_type ())

#define TYPE_MUTTER_READ_DISPLAY_CRTC (mutter_read_display_crtc_get_type ())
typedef struct _MutterReadDisplayCrtc MutterReadDisplayCrtc;
typedef enum  {
	DISPLAY_TRANSFORM_NORMAL = 0,
	DISPLAY_TRANSFORM_ROTATION_90 = 1,
	DISPLAY_TRANSFORM_ROTATION_180 = 2,
	DISPLAY_TRANSFORM_ROTATION_270 = 3,
	DISPLAY_TRANSFORM_FLIPPED = 4,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_90 = 5,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_180 = 6,
	DISPLAY_TRANSFORM_FLIPPED_ROTATION_270 = 7
} DisplayTransform;

#define TYPE_DISPLAY_TRANSFORM (display_transform_get_type ())

#define TYPE_MUTTER_READ_DISPLAY_OUTPUT (mutter_read_display_output_get_type ())
typedef struct _MutterReadDisplayOutput MutterReadDisplayOutput;

#define TYPE_MUTTER_READ_DISPLAY_MODE (mutter_read_display_mode_get_type ())
typedef struct _MutterReadDisplayMode MutterReadDisplayMode;

#define TYPE_MUTTER_WRITE_DISPLAY_CRTC (mutter_write_display_crtc_get_type ())
typedef struct _MutterWriteDisplayCrtc MutterWriteDisplayCrtc;

#define TYPE_MUTTER_WRITE_DISPLAY_OUTPUT (mutter_write_display_output_get_type ())
typedef struct _MutterWriteDisplayOutput MutterWriteDisplayOutput;

#define TYPE_MUTTER_READ_MONITOR (mutter_read_monitor_get_type ())
typedef struct _MutterReadMonitor MutterReadMonitor;

#define TYPE_MUTTER_READ_MONITOR_INFO (mutter_read_monitor_info_get_type ())
typedef struct _MutterReadMonitorInfo MutterReadMonitorInfo;

#define TYPE_MUTTER_READ_MONITOR_MODE (mutter_read_monitor_mode_get_type ())
typedef struct _MutterReadMonitorMode MutterReadMonitorMode;

#define TYPE_MUTTER_READ_LOGICAL_MONITOR (mutter_read_logical_monitor_get_type ())
typedef struct _MutterReadLogicalMonitor MutterReadLogicalMonitor;
typedef enum  {
	MUTTER_APPLY_METHOD_VERIFY = 0,
	MUTTER_APPLY_METHOD_TEMPORARY = 1,
	MUTTER_APPLY_METHOD_PERSISTENT = 2
} MutterApplyMethod;

#define TYPE_MUTTER_APPLY_METHOD (mutter_apply_method_get_type ())

#define TYPE_MUTTER_WRITE_LOGICAL_MONITOR (mutter_write_logical_monitor_get_type ())
typedef struct _MutterWriteLogicalMonitor MutterWriteLogicalMonitor;

#define TYPE_MUTTER_WRITE_MONITOR (mutter_write_monitor_get_type ())
typedef struct _MutterWriteMonitor MutterWriteMonitor;
enum  {
	MUTTER_DISPLAY_CONFIG_INTERFACE_MONITORS_CHANGED_SIGNAL,
	MUTTER_DISPLAY_CONFIG_INTERFACE_NUM_SIGNALS
};
static guint mutter_display_config_interface_signals[MUTTER_DISPLAY_CONFIG_INTERFACE_NUM_SIGNALS] = {0};
typedef GDBusProxy MutterDisplayConfigInterfaceProxy;
typedef GDBusProxyClass MutterDisplayConfigInterfaceProxyClass;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _MutterReadDisplayCrtc {
	guint id;
	gint64 winsys_id;
	gint x;
	gint y;
	gint width;
	gint height;
	gint current_mode;
	DisplayTransform current_transform;
	DisplayTransform* transforms;
	gint transforms_length1;
	GHashTable* properties;
};

struct _MutterReadDisplayOutput {
	guint id;
	gint64 winsys_id;
	gint current_crtc;
	guint* possible_crtcs;
	gint possible_crtcs_length1;
	gchar* connector_name;
	guint* modes;
	gint modes_length1;
	guint* clones;
	gint clones_length1;
	GHashTable* properties;
};

struct _MutterReadDisplayMode {
	guint id;
	gint64 winsys_id;
	guint width;
	guint height;
	gdouble frequency;
	guint flags;
};

struct _MutterWriteDisplayCrtc {
	guint id;
	gint new_mode;
	gint x;
	gint y;
	DisplayTransform transform;
	guint* outputs;
	gint outputs_length1;
	GHashTable* properties;
};

struct _MutterWriteDisplayOutput {
	guint id;
	GHashTable* properties;
};

struct _MutterReadMonitorInfo {
	gchar* connector;
	gchar* vendor;
	gchar* product;
	gchar* serial;
};

struct _MutterReadMonitorMode {
	gchar* id;
	gint width;
	gint height;
	gdouble frequency;
	gdouble preferred_scale;
	gdouble* supported_scales;
	gint supported_scales_length1;
	GHashTable* properties;
};

struct _MutterReadMonitor {
	MutterReadMonitorInfo monitor;
	MutterReadMonitorMode* modes;
	gint modes_length1;
	GHashTable* properties;
};

struct _MutterReadLogicalMonitor {
	gint x;
	gint y;
	gdouble scale;
	DisplayTransform transform;
	gboolean primary;
	MutterReadMonitorInfo* monitors;
	gint monitors_length1;
	GHashTable* properties;
};

struct _MutterWriteMonitor {
	gchar* connector;
	gchar* monitor_mode;
	GHashTable* properties;
};

struct _MutterWriteLogicalMonitor {
	gint x;
	gint y;
	gdouble scale;
	DisplayTransform transform;
	gboolean primary;
	MutterWriteMonitor* monitors;
	gint monitors_length1;
};

struct _MutterDisplayConfigInterfaceIface {
	GTypeInterface parent_iface;
	void (*get_resources) (MutterDisplayConfigInterface* self, guint* serial, MutterReadDisplayCrtc** crtcs, gint* crtcs_length1, MutterReadDisplayOutput** outputs, gint* outputs_length1, MutterReadDisplayMode** modes, gint* modes_length1, gint* max_screen_width, gint* max_screen_height, GError** error);
	void (*apply_configuration) (MutterDisplayConfigInterface* self, guint serial, gboolean persistent, MutterWriteDisplayCrtc* crtcs, gint crtcs_length1, MutterWriteDisplayOutput* outputs, gint outputs_length1, GError** error);
	gint (*change_backlight) (MutterDisplayConfigInterface* self, guint serial, guint output, gint value, GError** error);
	void (*get_crtc_gamma) (MutterDisplayConfigInterface* self, guint serial, guint crtc, guint** red, gint* red_length1, guint** green, gint* green_length1, guint** blue, gint* blue_length1, GError** error);
	void (*set_crtc_gamma) (MutterDisplayConfigInterface* self, guint serial, guint crtc, guint* red, gint red_length1, guint* green, gint green_length1, guint* blue, gint blue_length1, GError** error);
	void (*get_current_state) (MutterDisplayConfigInterface* self, guint* serial, MutterReadMonitor** monitors, gint* monitors_length1, MutterReadLogicalMonitor** logical_monitors, gint* logical_monitors_length1, GHashTable** properties, GError** error);
	void (*apply_monitors_config) (MutterDisplayConfigInterface* self, guint serial, MutterApplyMethod method, MutterWriteLogicalMonitor* logical_monitors, gint logical_monitors_length1, GHashTable* properties, GError** error);
	gint (*get_power_save_mode) (MutterDisplayConfigInterface* self);
	void (*set_power_save_mode) (MutterDisplayConfigInterface* self, gint value);
};

VALA_EXTERN GType mutter_display_config_interface_proxy_get_type (void) G_GNUC_CONST ;
VALA_EXTERN guint mutter_display_config_interface_register_object (void* object,
                                                       GDBusConnection* connection,
                                                       const gchar* path,
                                                       GError** error);
VALA_EXTERN GType mutter_read_display_crtc_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType display_transform_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MutterReadDisplayCrtc* mutter_read_display_crtc_dup (const MutterReadDisplayCrtc* self);
VALA_EXTERN void mutter_read_display_crtc_free (MutterReadDisplayCrtc* self);
VALA_EXTERN void mutter_read_display_crtc_copy (const MutterReadDisplayCrtc* self,
                                    MutterReadDisplayCrtc* dest);
VALA_EXTERN void mutter_read_display_crtc_destroy (MutterReadDisplayCrtc* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterReadDisplayCrtc, mutter_read_display_crtc_destroy)
VALA_EXTERN GType mutter_read_display_output_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MutterReadDisplayOutput* mutter_read_display_output_dup (const MutterReadDisplayOutput* self);
VALA_EXTERN void mutter_read_display_output_free (MutterReadDisplayOutput* self);
VALA_EXTERN void mutter_read_display_output_copy (const MutterReadDisplayOutput* self,
                                      MutterReadDisplayOutput* dest);
VALA_EXTERN void mutter_read_display_output_destroy (MutterReadDisplayOutput* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterReadDisplayOutput, mutter_read_display_output_destroy)
VALA_EXTERN GType mutter_read_display_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MutterReadDisplayMode* mutter_read_display_mode_dup (const MutterReadDisplayMode* self);
VALA_EXTERN void mutter_read_display_mode_free (MutterReadDisplayMode* self);
VALA_EXTERN GType mutter_write_display_crtc_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MutterWriteDisplayCrtc* mutter_write_display_crtc_dup (const MutterWriteDisplayCrtc* self);
VALA_EXTERN void mutter_write_display_crtc_free (MutterWriteDisplayCrtc* self);
VALA_EXTERN void mutter_write_display_crtc_copy (const MutterWriteDisplayCrtc* self,
                                     MutterWriteDisplayCrtc* dest);
VALA_EXTERN void mutter_write_display_crtc_destroy (MutterWriteDisplayCrtc* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterWriteDisplayCrtc, mutter_write_display_crtc_destroy)
VALA_EXTERN GType mutter_write_display_output_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MutterWriteDisplayOutput* mutter_write_display_output_dup (const MutterWriteDisplayOutput* self);
VALA_EXTERN void mutter_write_display_output_free (MutterWriteDisplayOutput* self);
VALA_EXTERN void mutter_write_display_output_copy (const MutterWriteDisplayOutput* self,
                                       MutterWriteDisplayOutput* dest);
VALA_EXTERN void mutter_write_display_output_destroy (MutterWriteDisplayOutput* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterWriteDisplayOutput, mutter_write_display_output_destroy)
VALA_EXTERN GType mutter_read_monitor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType mutter_read_monitor_info_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MutterReadMonitorInfo* mutter_read_monitor_info_dup (const MutterReadMonitorInfo* self);
VALA_EXTERN void mutter_read_monitor_info_free (MutterReadMonitorInfo* self);
VALA_EXTERN void mutter_read_monitor_info_copy (const MutterReadMonitorInfo* self,
                                    MutterReadMonitorInfo* dest);
VALA_EXTERN void mutter_read_monitor_info_destroy (MutterReadMonitorInfo* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterReadMonitorInfo, mutter_read_monitor_info_destroy)
VALA_EXTERN GType mutter_read_monitor_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MutterReadMonitorMode* mutter_read_monitor_mode_dup (const MutterReadMonitorMode* self);
VALA_EXTERN void mutter_read_monitor_mode_free (MutterReadMonitorMode* self);
VALA_EXTERN void mutter_read_monitor_mode_copy (const MutterReadMonitorMode* self,
                                    MutterReadMonitorMode* dest);
VALA_EXTERN void mutter_read_monitor_mode_destroy (MutterReadMonitorMode* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterReadMonitorMode, mutter_read_monitor_mode_destroy)
VALA_EXTERN MutterReadMonitor* mutter_read_monitor_dup (const MutterReadMonitor* self);
VALA_EXTERN void mutter_read_monitor_free (MutterReadMonitor* self);
VALA_EXTERN void mutter_read_monitor_copy (const MutterReadMonitor* self,
                               MutterReadMonitor* dest);
VALA_EXTERN void mutter_read_monitor_destroy (MutterReadMonitor* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterReadMonitor, mutter_read_monitor_destroy)
VALA_EXTERN GType mutter_read_logical_monitor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MutterReadLogicalMonitor* mutter_read_logical_monitor_dup (const MutterReadLogicalMonitor* self);
VALA_EXTERN void mutter_read_logical_monitor_free (MutterReadLogicalMonitor* self);
VALA_EXTERN void mutter_read_logical_monitor_copy (const MutterReadLogicalMonitor* self,
                                       MutterReadLogicalMonitor* dest);
VALA_EXTERN void mutter_read_logical_monitor_destroy (MutterReadLogicalMonitor* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterReadLogicalMonitor, mutter_read_logical_monitor_destroy)
VALA_EXTERN GType mutter_apply_method_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType mutter_write_logical_monitor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType mutter_write_monitor_get_type (void) G_GNUC_CONST ;
VALA_EXTERN MutterWriteMonitor* mutter_write_monitor_dup (const MutterWriteMonitor* self);
VALA_EXTERN void mutter_write_monitor_free (MutterWriteMonitor* self);
VALA_EXTERN void mutter_write_monitor_copy (const MutterWriteMonitor* self,
                                MutterWriteMonitor* dest);
VALA_EXTERN void mutter_write_monitor_destroy (MutterWriteMonitor* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterWriteMonitor, mutter_write_monitor_destroy)
VALA_EXTERN MutterWriteLogicalMonitor* mutter_write_logical_monitor_dup (const MutterWriteLogicalMonitor* self);
VALA_EXTERN void mutter_write_logical_monitor_free (MutterWriteLogicalMonitor* self);
VALA_EXTERN void mutter_write_logical_monitor_copy (const MutterWriteLogicalMonitor* self,
                                        MutterWriteLogicalMonitor* dest);
VALA_EXTERN void mutter_write_logical_monitor_destroy (MutterWriteLogicalMonitor* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (MutterWriteLogicalMonitor, mutter_write_logical_monitor_destroy)
VALA_EXTERN GType mutter_display_config_interface_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MutterDisplayConfigInterface, g_object_unref)
VALA_EXTERN void mutter_display_config_interface_get_resources (MutterDisplayConfigInterface* self,
                                                    guint* serial,
                                                    MutterReadDisplayCrtc** crtcs,
                                                    gint* crtcs_length1,
                                                    MutterReadDisplayOutput** outputs,
                                                    gint* outputs_length1,
                                                    MutterReadDisplayMode** modes,
                                                    gint* modes_length1,
                                                    gint* max_screen_width,
                                                    gint* max_screen_height,
                                                    GError** error);
VALA_EXTERN void mutter_display_config_interface_apply_configuration (MutterDisplayConfigInterface* self,
                                                          guint serial,
                                                          gboolean persistent,
                                                          MutterWriteDisplayCrtc* crtcs,
                                                          gint crtcs_length1,
                                                          MutterWriteDisplayOutput* outputs,
                                                          gint outputs_length1,
                                                          GError** error);
VALA_EXTERN gint mutter_display_config_interface_change_backlight (MutterDisplayConfigInterface* self,
                                                       guint serial,
                                                       guint output,
                                                       gint value,
                                                       GError** error);
VALA_EXTERN void mutter_display_config_interface_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                     guint serial,
                                                     guint crtc,
                                                     guint** red,
                                                     gint* red_length1,
                                                     guint** green,
                                                     gint* green_length1,
                                                     guint** blue,
                                                     gint* blue_length1,
                                                     GError** error);
VALA_EXTERN void mutter_display_config_interface_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                     guint serial,
                                                     guint crtc,
                                                     guint* red,
                                                     gint red_length1,
                                                     guint* green,
                                                     gint green_length1,
                                                     guint* blue,
                                                     gint blue_length1,
                                                     GError** error);
VALA_EXTERN void mutter_display_config_interface_get_current_state (MutterDisplayConfigInterface* self,
                                                        guint* serial,
                                                        MutterReadMonitor** monitors,
                                                        gint* monitors_length1,
                                                        MutterReadLogicalMonitor** logical_monitors,
                                                        gint* logical_monitors_length1,
                                                        GHashTable** properties,
                                                        GError** error);
VALA_EXTERN void mutter_display_config_interface_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                            guint serial,
                                                            MutterApplyMethod method,
                                                            MutterWriteLogicalMonitor* logical_monitors,
                                                            gint logical_monitors_length1,
                                                            GHashTable* properties,
                                                            GError** error);
VALA_EXTERN gint mutter_display_config_interface_get_power_save_mode (MutterDisplayConfigInterface* self);
VALA_EXTERN void mutter_display_config_interface_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                          gint value);
static GType mutter_display_config_interface_get_type_once (void);
static void mutter_display_config_interface_proxy_g_signal (GDBusProxy* proxy,
                                                     const gchar* sender_name,
                                                     const gchar* signal_name,
                                                     GVariant* parameters);
static void _dbus_handle_mutter_display_config_interface_monitors_changed (MutterDisplayConfigInterface* self,
                                                                    GVariant* parameters);
static void mutter_display_config_interface_proxy_get_resources (MutterDisplayConfigInterface* self,
                                                          guint* serial,
                                                          MutterReadDisplayCrtc** crtcs,
                                                          gint* crtcs_length1,
                                                          MutterReadDisplayOutput** outputs,
                                                          gint* outputs_length1,
                                                          MutterReadDisplayMode** modes,
                                                          gint* modes_length1,
                                                          gint* max_screen_width,
                                                          gint* max_screen_height,
                                                          GError** error);
static void mutter_display_config_interface_proxy_apply_configuration (MutterDisplayConfigInterface* self,
                                                                guint serial,
                                                                gboolean persistent,
                                                                MutterWriteDisplayCrtc* crtcs,
                                                                gint crtcs_length1,
                                                                MutterWriteDisplayOutput* outputs,
                                                                gint outputs_length1,
                                                                GError** error);
static gint mutter_display_config_interface_proxy_change_backlight (MutterDisplayConfigInterface* self,
                                                             guint serial,
                                                             guint output,
                                                             gint value,
                                                             GError** error);
static void mutter_display_config_interface_proxy_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                           guint serial,
                                                           guint crtc,
                                                           guint** red,
                                                           gint* red_length1,
                                                           guint** green,
                                                           gint* green_length1,
                                                           guint** blue,
                                                           gint* blue_length1,
                                                           GError** error);
static void mutter_display_config_interface_proxy_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                           guint serial,
                                                           guint crtc,
                                                           guint* red,
                                                           gint red_length1,
                                                           guint* green,
                                                           gint green_length1,
                                                           guint* blue,
                                                           gint blue_length1,
                                                           GError** error);
static void mutter_display_config_interface_proxy_get_current_state (MutterDisplayConfigInterface* self,
                                                              guint* serial,
                                                              MutterReadMonitor** monitors,
                                                              gint* monitors_length1,
                                                              MutterReadLogicalMonitor** logical_monitors,
                                                              gint* logical_monitors_length1,
                                                              GHashTable** properties,
                                                              GError** error);
static void mutter_display_config_interface_proxy_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                                  guint serial,
                                                                  MutterApplyMethod method,
                                                                  MutterWriteLogicalMonitor* logical_monitors,
                                                                  gint logical_monitors_length1,
                                                                  GHashTable* properties,
                                                                  GError** error);
static gint mutter_display_config_interface_dbus_proxy_get_power_save_mode (MutterDisplayConfigInterface* self);
static void mutter_display_config_interface_dbus_proxy_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                                     gint value);
static void mutter_display_config_interface_proxy_mutter_display_config_interface_interface_init (MutterDisplayConfigInterfaceIface* iface);
static void _vala_MutterReadDisplayCrtc_array_free (MutterReadDisplayCrtc * array,
                                             gssize array_length);
static void _vala_MutterReadDisplayOutput_array_free (MutterReadDisplayOutput * array,
                                               gssize array_length);
static void _dbus_mutter_display_config_interface_get_resources (MutterDisplayConfigInterface* self,
                                                          GVariant* _parameters_,
                                                          GDBusMethodInvocation* invocation);
static void _vala_MutterWriteDisplayCrtc_array_free (MutterWriteDisplayCrtc * array,
                                              gssize array_length);
static void _vala_MutterWriteDisplayOutput_array_free (MutterWriteDisplayOutput * array,
                                                gssize array_length);
static void _dbus_mutter_display_config_interface_apply_configuration (MutterDisplayConfigInterface* self,
                                                                GVariant* _parameters_,
                                                                GDBusMethodInvocation* invocation);
static void _dbus_mutter_display_config_interface_change_backlight (MutterDisplayConfigInterface* self,
                                                             GVariant* _parameters_,
                                                             GDBusMethodInvocation* invocation);
static void _dbus_mutter_display_config_interface_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation);
static void _dbus_mutter_display_config_interface_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation);
static void _vala_MutterReadMonitor_array_free (MutterReadMonitor * array,
                                         gssize array_length);
static void _vala_MutterReadLogicalMonitor_array_free (MutterReadLogicalMonitor * array,
                                                gssize array_length);
static void _dbus_mutter_display_config_interface_get_current_state (MutterDisplayConfigInterface* self,
                                                              GVariant* _parameters_,
                                                              GDBusMethodInvocation* invocation);
static void _vala_MutterWriteLogicalMonitor_array_free (MutterWriteLogicalMonitor * array,
                                                 gssize array_length);
static void _dbus_mutter_display_config_interface_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                                  GVariant* _parameters_,
                                                                  GDBusMethodInvocation* invocation);
static void mutter_display_config_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* method_name,
                                                                 GVariant* parameters,
                                                                 GDBusMethodInvocation* invocation,
                                                                 gpointer user_data);
static GVariant* mutter_display_config_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                                       const gchar* sender,
                                                                       const gchar* object_path,
                                                                       const gchar* interface_name,
                                                                       const gchar* property_name,
                                                                       GError** error,
                                                                       gpointer user_data);
static GVariant* _dbus_mutter_display_config_interface_get_power_save_mode (MutterDisplayConfigInterface* self);
static gboolean mutter_display_config_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                                      const gchar* sender,
                                                                      const gchar* object_path,
                                                                      const gchar* interface_name,
                                                                      const gchar* property_name,
                                                                      GVariant* value,
                                                                      GError** error,
                                                                      gpointer user_data);
static void _dbus_mutter_display_config_interface_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                                GVariant* _value);
static void _dbus_mutter_display_config_interface_monitors_changed (GObject* _sender,
                                                             gpointer* _data);
static void _mutter_display_config_interface_unregister_object (gpointer user_data);
VALA_EXTERN gchar* display_transform_to_string (DisplayTransform self);
VALA_EXTERN guint mutter_read_monitor_info_get_hash (MutterReadMonitorInfo* self);
static gdouble* _vala_array_dup1 (gdouble* self,
                           gssize length);
static void _vala_MutterReadMonitorMode_array_free (MutterReadMonitorMode * array,
                                             gssize array_length);
static MutterReadMonitorMode* _vala_array_dup2 (MutterReadMonitorMode* self,
                                         gssize length);
static void _vala_MutterReadMonitorInfo_array_free (MutterReadMonitorInfo * array,
                                             gssize array_length);
static MutterReadMonitorInfo* _vala_array_dup3 (MutterReadMonitorInfo* self,
                                         gssize length);
static void _vala_MutterWriteMonitor_array_free (MutterWriteMonitor * array,
                                          gssize array_length);
static MutterWriteMonitor* _vala_array_dup4 (MutterWriteMonitor* self,
                                      gssize length);
static DisplayTransform* _vala_array_dup5 (DisplayTransform* self,
                                    gssize length);
static guint* _vala_array_dup6 (guint* self,
                         gssize length);
static guint* _vala_array_dup7 (guint* self,
                         gssize length);
static guint* _vala_array_dup8 (guint* self,
                         gssize length);
static guint* _vala_array_dup9 (guint* self,
                         gssize length);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_crtcs = {-1, "crtcs", "a(uxiiiiiuaua{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_outputs = {-1, "outputs", "a(uxiausauaua{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_modes = {-1, "modes", "a(uxuudu)", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_max_screen_width = {-1, "max_screen_width", "i", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_resources_max_screen_height = {-1, "max_screen_height", "i", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_resources_in[] = {NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_resources_out[] = {&_mutter_display_config_interface_dbus_arg_info_get_resources_serial, &_mutter_display_config_interface_dbus_arg_info_get_resources_crtcs, &_mutter_display_config_interface_dbus_arg_info_get_resources_outputs, &_mutter_display_config_interface_dbus_arg_info_get_resources_modes, &_mutter_display_config_interface_dbus_arg_info_get_resources_max_screen_width, &_mutter_display_config_interface_dbus_arg_info_get_resources_max_screen_height, NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_get_resources = {-1, "GetResources", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_resources_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_resources_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_configuration_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_configuration_persistent = {-1, "persistent", "b", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_configuration_crtcs = {-1, "crtcs", "a(uiiiuaua{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_configuration_outputs = {-1, "outputs", "a(ua{sv})", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_apply_configuration_in[] = {&_mutter_display_config_interface_dbus_arg_info_apply_configuration_serial, &_mutter_display_config_interface_dbus_arg_info_apply_configuration_persistent, &_mutter_display_config_interface_dbus_arg_info_apply_configuration_crtcs, &_mutter_display_config_interface_dbus_arg_info_apply_configuration_outputs, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_apply_configuration_out[] = {NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_apply_configuration = {-1, "ApplyConfiguration", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_apply_configuration_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_apply_configuration_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_change_backlight_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_change_backlight_output = {-1, "output", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_change_backlight_value = {-1, "value", "i", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_change_backlight_result = {-1, "result", "i", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_change_backlight_in[] = {&_mutter_display_config_interface_dbus_arg_info_change_backlight_serial, &_mutter_display_config_interface_dbus_arg_info_change_backlight_output, &_mutter_display_config_interface_dbus_arg_info_change_backlight_value, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_change_backlight_out[] = {&_mutter_display_config_interface_dbus_arg_info_change_backlight_result, NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_change_backlight = {-1, "ChangeBacklight", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_change_backlight_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_change_backlight_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_crtc = {-1, "crtc", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_red = {-1, "red", "au", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_green = {-1, "green", "au", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_blue = {-1, "blue", "au", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_in[] = {&_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_serial, &_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_crtc, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_out[] = {&_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_red, &_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_green, &_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_blue, NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_get_crtc_gamma = {-1, "GetCrtcGamma", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_crtc_gamma_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_crtc = {-1, "crtc", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_red = {-1, "red", "au", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_green = {-1, "green", "au", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_blue = {-1, "blue", "au", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_in[] = {&_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_serial, &_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_crtc, &_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_red, &_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_green, &_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_blue, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_out[] = {NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_set_crtc_gamma = {-1, "SetCrtcGamma", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_set_crtc_gamma_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_current_state_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_current_state_monitors = {-1, "monitors", "a((ssss)a(siiddada{sv})a{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_current_state_logical_monitors = {-1, "logical_monitors", "a(iiduba(ssss)a{sv})", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_get_current_state_properties = {-1, "properties", "a{sv}", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_current_state_in[] = {NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_get_current_state_out[] = {&_mutter_display_config_interface_dbus_arg_info_get_current_state_serial, &_mutter_display_config_interface_dbus_arg_info_get_current_state_monitors, &_mutter_display_config_interface_dbus_arg_info_get_current_state_logical_monitors, &_mutter_display_config_interface_dbus_arg_info_get_current_state_properties, NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_get_current_state = {-1, "GetCurrentState", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_current_state_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_get_current_state_out), NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_serial = {-1, "serial", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_method = {-1, "method", "u", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_logical_monitors = {-1, "logical_monitors", "a(iiduba(ssa{sv}))", NULL};
static const GDBusArgInfo _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_properties = {-1, "properties", "a{sv}", NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_in[] = {&_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_serial, &_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_method, &_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_logical_monitors, &_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_properties, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_apply_monitors_config_out[] = {NULL};
static const GDBusMethodInfo _mutter_display_config_interface_dbus_method_info_apply_monitors_config = {-1, "ApplyMonitorsConfig", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_in), (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_apply_monitors_config_out), NULL};
static const GDBusMethodInfo * const _mutter_display_config_interface_dbus_method_info[] = {&_mutter_display_config_interface_dbus_method_info_get_resources, &_mutter_display_config_interface_dbus_method_info_apply_configuration, &_mutter_display_config_interface_dbus_method_info_change_backlight, &_mutter_display_config_interface_dbus_method_info_get_crtc_gamma, &_mutter_display_config_interface_dbus_method_info_set_crtc_gamma, &_mutter_display_config_interface_dbus_method_info_get_current_state, &_mutter_display_config_interface_dbus_method_info_apply_monitors_config, NULL};
static const GDBusArgInfo * const _mutter_display_config_interface_dbus_arg_info_monitors_changed[] = {NULL};
static const GDBusSignalInfo _mutter_display_config_interface_dbus_signal_info_monitors_changed = {-1, "MonitorsChanged", (GDBusArgInfo **) (&_mutter_display_config_interface_dbus_arg_info_monitors_changed), NULL};
static const GDBusSignalInfo * const _mutter_display_config_interface_dbus_signal_info[] = {&_mutter_display_config_interface_dbus_signal_info_monitors_changed, NULL};
static const GDBusPropertyInfo _mutter_display_config_interface_dbus_property_info_power_save_mode = {-1, "PowerSaveMode", "i", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo * const _mutter_display_config_interface_dbus_property_info[] = {&_mutter_display_config_interface_dbus_property_info_power_save_mode, NULL};
static const GDBusInterfaceInfo _mutter_display_config_interface_dbus_interface_info = {-1, "org.gnome.Mutter.DisplayConfig", (GDBusMethodInfo **) (&_mutter_display_config_interface_dbus_method_info), (GDBusSignalInfo **) (&_mutter_display_config_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_mutter_display_config_interface_dbus_property_info), NULL};
static const GDBusInterfaceVTable _mutter_display_config_interface_dbus_interface_vtable = {mutter_display_config_interface_dbus_interface_method_call, mutter_display_config_interface_dbus_interface_get_property, mutter_display_config_interface_dbus_interface_set_property};

void
mutter_display_config_interface_get_resources (MutterDisplayConfigInterface* self,
                                               guint* serial,
                                               MutterReadDisplayCrtc** crtcs,
                                               gint* crtcs_length1,
                                               MutterReadDisplayOutput** outputs,
                                               gint* outputs_length1,
                                               MutterReadDisplayMode** modes,
                                               gint* modes_length1,
                                               gint* max_screen_width,
                                               gint* max_screen_height,
                                               GError** error)
{
	MutterDisplayConfigInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_resources) {
		_iface_->get_resources (self, serial, crtcs, crtcs_length1, outputs, outputs_length1, modes, modes_length1, max_screen_width, max_screen_height, error);
	}
}

void
mutter_display_config_interface_apply_configuration (MutterDisplayConfigInterface* self,
                                                     guint serial,
                                                     gboolean persistent,
                                                     MutterWriteDisplayCrtc* crtcs,
                                                     gint crtcs_length1,
                                                     MutterWriteDisplayOutput* outputs,
                                                     gint outputs_length1,
                                                     GError** error)
{
	MutterDisplayConfigInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self);
	if (_iface_->apply_configuration) {
		_iface_->apply_configuration (self, serial, persistent, crtcs, crtcs_length1, outputs, outputs_length1, error);
	}
}

gint
mutter_display_config_interface_change_backlight (MutterDisplayConfigInterface* self,
                                                  guint serial,
                                                  guint output,
                                                  gint value,
                                                  GError** error)
{
	MutterDisplayConfigInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, 0);
	_iface_ = MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self);
	if (_iface_->change_backlight) {
		return _iface_->change_backlight (self, serial, output, value, error);
	}
	return -1;
}

void
mutter_display_config_interface_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                guint serial,
                                                guint crtc,
                                                guint** red,
                                                gint* red_length1,
                                                guint** green,
                                                gint* green_length1,
                                                guint** blue,
                                                gint* blue_length1,
                                                GError** error)
{
	MutterDisplayConfigInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_crtc_gamma) {
		_iface_->get_crtc_gamma (self, serial, crtc, red, red_length1, green, green_length1, blue, blue_length1, error);
	}
}

void
mutter_display_config_interface_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                guint serial,
                                                guint crtc,
                                                guint* red,
                                                gint red_length1,
                                                guint* green,
                                                gint green_length1,
                                                guint* blue,
                                                gint blue_length1,
                                                GError** error)
{
	MutterDisplayConfigInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self);
	if (_iface_->set_crtc_gamma) {
		_iface_->set_crtc_gamma (self, serial, crtc, red, red_length1, green, green_length1, blue, blue_length1, error);
	}
}

void
mutter_display_config_interface_get_current_state (MutterDisplayConfigInterface* self,
                                                   guint* serial,
                                                   MutterReadMonitor** monitors,
                                                   gint* monitors_length1,
                                                   MutterReadLogicalMonitor** logical_monitors,
                                                   gint* logical_monitors_length1,
                                                   GHashTable** properties,
                                                   GError** error)
{
	MutterDisplayConfigInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_current_state) {
		_iface_->get_current_state (self, serial, monitors, monitors_length1, logical_monitors, logical_monitors_length1, properties, error);
	}
}

void
mutter_display_config_interface_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                       guint serial,
                                                       MutterApplyMethod method,
                                                       MutterWriteLogicalMonitor* logical_monitors,
                                                       gint logical_monitors_length1,
                                                       GHashTable* properties,
                                                       GError** error)
{
	MutterDisplayConfigInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self);
	if (_iface_->apply_monitors_config) {
		_iface_->apply_monitors_config (self, serial, method, logical_monitors, logical_monitors_length1, properties, error);
	}
}

gint
mutter_display_config_interface_get_power_save_mode (MutterDisplayConfigInterface* self)
{
	MutterDisplayConfigInterfaceIface* _iface_;
	g_return_val_if_fail (self != NULL, 0);
	_iface_ = MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self);
	if (_iface_->get_power_save_mode) {
		return _iface_->get_power_save_mode (self);
	}
	return -1;
}

void
mutter_display_config_interface_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                     gint value)
{
	MutterDisplayConfigInterfaceIface* _iface_;
	g_return_if_fail (self != NULL);
	_iface_ = MUTTER_DISPLAY_CONFIG_INTERFACE_GET_INTERFACE (self);
	if (_iface_->set_power_save_mode) {
		_iface_->set_power_save_mode (self, value);
	}
}

static void
mutter_display_config_interface_default_init (MutterDisplayConfigInterfaceIface * iface,
                                              gpointer iface_data)
{
	mutter_display_config_interface_signals[MUTTER_DISPLAY_CONFIG_INTERFACE_MONITORS_CHANGED_SIGNAL] = g_signal_new ("monitors-changed", TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static GType
mutter_display_config_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MutterDisplayConfigInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mutter_display_config_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType mutter_display_config_interface_type_id;
	mutter_display_config_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "MutterDisplayConfigInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (mutter_display_config_interface_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (mutter_display_config_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) mutter_display_config_interface_proxy_get_type);
	g_type_set_qdata (mutter_display_config_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.gnome.Mutter.DisplayConfig");
	g_type_set_qdata (mutter_display_config_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_mutter_display_config_interface_dbus_interface_info));
	g_type_set_qdata (mutter_display_config_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) mutter_display_config_interface_register_object);
	return mutter_display_config_interface_type_id;
}

GType
mutter_display_config_interface_get_type (void)
{
	static volatile gsize mutter_display_config_interface_type_id__once = 0;
	if (g_once_init_enter (&mutter_display_config_interface_type_id__once)) {
		GType mutter_display_config_interface_type_id;
		mutter_display_config_interface_type_id = mutter_display_config_interface_get_type_once ();
		g_once_init_leave (&mutter_display_config_interface_type_id__once, mutter_display_config_interface_type_id);
	}
	return mutter_display_config_interface_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (MutterDisplayConfigInterfaceProxy, mutter_display_config_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_MUTTER_DISPLAY_CONFIG_INTERFACE, mutter_display_config_interface_proxy_mutter_display_config_interface_interface_init) )
static void
mutter_display_config_interface_proxy_class_init (MutterDisplayConfigInterfaceProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = mutter_display_config_interface_proxy_g_signal;
}

static void
_dbus_handle_mutter_display_config_interface_monitors_changed (MutterDisplayConfigInterface* self,
                                                               GVariant* parameters)
{
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "monitors-changed");
}

static void
mutter_display_config_interface_proxy_g_signal (GDBusProxy* proxy,
                                                const gchar* sender_name,
                                                const gchar* signal_name,
                                                GVariant* parameters)
{
	if (strcmp (signal_name, "MonitorsChanged") == 0) {
		_dbus_handle_mutter_display_config_interface_monitors_changed ((MutterDisplayConfigInterface*) proxy, parameters);
	}
}

static void
mutter_display_config_interface_proxy_init (MutterDisplayConfigInterfaceProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_mutter_display_config_interface_dbus_interface_info));
}

static void
mutter_display_config_interface_proxy_get_resources (MutterDisplayConfigInterface* self,
                                                     guint* serial,
                                                     MutterReadDisplayCrtc** crtcs,
                                                     gint* crtcs_length1,
                                                     MutterReadDisplayOutput** outputs,
                                                     gint* outputs_length1,
                                                     MutterReadDisplayMode** modes,
                                                     gint* modes_length1,
                                                     gint* max_screen_width,
                                                     gint* max_screen_height,
                                                     GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint _vala_serial = 0U;
	GVariant* _tmp84_;
	MutterReadDisplayCrtc* _vala_crtcs = NULL;
	gint _vala_crtcs_length1;
	GVariant* _tmp85_;
	MutterReadDisplayCrtc* _tmp86_;
	gint _tmp86__length;
	gint _tmp86__size;
	gint _tmp86__length1;
	GVariantIter _tmp87_;
	GVariant* _tmp88_;
	MutterReadDisplayOutput* _vala_outputs = NULL;
	gint _vala_outputs_length1;
	GVariant* _tmp108_;
	MutterReadDisplayOutput* _tmp109_;
	gint _tmp109__length;
	gint _tmp109__size;
	gint _tmp109__length1;
	GVariantIter _tmp110_;
	GVariant* _tmp111_;
	MutterReadDisplayMode* _vala_modes = NULL;
	gint _vala_modes_length1;
	GVariant* _tmp135_;
	MutterReadDisplayMode* _tmp136_;
	gint _tmp136__length;
	gint _tmp136__size;
	gint _tmp136__length1;
	GVariantIter _tmp137_;
	GVariant* _tmp138_;
	gint _vala_max_screen_width = 0;
	GVariant* _tmp147_;
	gint _vala_max_screen_height = 0;
	GVariant* _tmp148_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "GetResources");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp84_ = g_variant_iter_next_value (&_reply_iter);
	_vala_serial = g_variant_get_uint32 (_tmp84_);
	g_variant_unref (_tmp84_);
	*serial = _vala_serial;
	_vala_crtcs_length1 = 0;
	_tmp85_ = g_variant_iter_next_value (&_reply_iter);
	_tmp86_ = g_new (MutterReadDisplayCrtc, 5);
	_tmp86__length = 0;
	_tmp86__size = 4;
	_tmp86__length1 = 0;
	g_variant_iter_init (&_tmp87_, _tmp85_);
	for (; (_tmp88_ = g_variant_iter_next_value (&_tmp87_)) != NULL; _tmp86__length1++) {
		MutterReadDisplayCrtc _tmp89_;
		GVariantIter _tmp90_;
		GVariant* _tmp91_;
		GVariant* _tmp92_;
		GVariant* _tmp93_;
		GVariant* _tmp94_;
		GVariant* _tmp95_;
		GVariant* _tmp96_;
		GVariant* _tmp97_;
		GVariant* _tmp98_;
		GVariant* _tmp99_;
		DisplayTransform* _tmp100_;
		gint _tmp100__length;
		gint _tmp100__size;
		gint _tmp100__length1;
		GVariantIter _tmp101_;
		GVariant* _tmp102_;
		GVariant* _tmp103_;
		GHashTable* _tmp104_;
		GVariantIter _tmp105_;
		GVariant* _tmp106_;
		GVariant* _tmp107_;
		if (_tmp86__size == _tmp86__length) {
			_tmp86__size = 2 * _tmp86__size;
			_tmp86_ = g_renew (MutterReadDisplayCrtc, _tmp86_, _tmp86__size + 1);
		}
		g_variant_iter_init (&_tmp90_, _tmp88_);
		_tmp91_ = g_variant_iter_next_value (&_tmp90_);
		_tmp89_.id = g_variant_get_uint32 (_tmp91_);
		g_variant_unref (_tmp91_);
		_tmp92_ = g_variant_iter_next_value (&_tmp90_);
		_tmp89_.winsys_id = g_variant_get_int64 (_tmp92_);
		g_variant_unref (_tmp92_);
		_tmp93_ = g_variant_iter_next_value (&_tmp90_);
		_tmp89_.x = g_variant_get_int32 (_tmp93_);
		g_variant_unref (_tmp93_);
		_tmp94_ = g_variant_iter_next_value (&_tmp90_);
		_tmp89_.y = g_variant_get_int32 (_tmp94_);
		g_variant_unref (_tmp94_);
		_tmp95_ = g_variant_iter_next_value (&_tmp90_);
		_tmp89_.width = g_variant_get_int32 (_tmp95_);
		g_variant_unref (_tmp95_);
		_tmp96_ = g_variant_iter_next_value (&_tmp90_);
		_tmp89_.height = g_variant_get_int32 (_tmp96_);
		g_variant_unref (_tmp96_);
		_tmp97_ = g_variant_iter_next_value (&_tmp90_);
		_tmp89_.current_mode = g_variant_get_int32 (_tmp97_);
		g_variant_unref (_tmp97_);
		_tmp98_ = g_variant_iter_next_value (&_tmp90_);
		_tmp89_.current_transform = g_variant_get_uint32 (_tmp98_);
		g_variant_unref (_tmp98_);
		_tmp99_ = g_variant_iter_next_value (&_tmp90_);
		_tmp100_ = g_new (DisplayTransform, 5);
		_tmp100__length = 0;
		_tmp100__size = 4;
		_tmp100__length1 = 0;
		g_variant_iter_init (&_tmp101_, _tmp99_);
		for (; (_tmp102_ = g_variant_iter_next_value (&_tmp101_)) != NULL; _tmp100__length1++) {
			if (_tmp100__size == _tmp100__length) {
				_tmp100__size = 2 * _tmp100__size;
				_tmp100_ = g_renew (DisplayTransform, _tmp100_, _tmp100__size + 1);
			}
			_tmp100_[_tmp100__length++] = g_variant_get_uint32 (_tmp102_);
			g_variant_unref (_tmp102_);
		}
		_tmp89_.transforms_length1 = _tmp100__length1;
		_tmp89_.transforms = _tmp100_;
		g_variant_unref (_tmp99_);
		_tmp103_ = g_variant_iter_next_value (&_tmp90_);
		_tmp104_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp105_, _tmp103_);
		while (g_variant_iter_loop (&_tmp105_, "{?*}", &_tmp106_, &_tmp107_)) {
			g_hash_table_insert (_tmp104_, g_variant_dup_string (_tmp106_, NULL), g_variant_get_variant (_tmp107_));
		}
		_tmp89_.properties = _tmp104_;
		g_variant_unref (_tmp103_);
		_tmp86_[_tmp86__length++] = _tmp89_;
		g_variant_unref (_tmp88_);
	}
	_vala_crtcs_length1 = _tmp86__length1;
	_vala_crtcs = _tmp86_;
	g_variant_unref (_tmp85_);
	*crtcs = _vala_crtcs;
	*crtcs_length1 = _vala_crtcs_length1;
	_vala_outputs_length1 = 0;
	_tmp108_ = g_variant_iter_next_value (&_reply_iter);
	_tmp109_ = g_new (MutterReadDisplayOutput, 5);
	_tmp109__length = 0;
	_tmp109__size = 4;
	_tmp109__length1 = 0;
	g_variant_iter_init (&_tmp110_, _tmp108_);
	for (; (_tmp111_ = g_variant_iter_next_value (&_tmp110_)) != NULL; _tmp109__length1++) {
		MutterReadDisplayOutput _tmp112_;
		GVariantIter _tmp113_;
		GVariant* _tmp114_;
		GVariant* _tmp115_;
		GVariant* _tmp116_;
		GVariant* _tmp117_;
		guint* _tmp118_;
		gint _tmp118__length;
		gint _tmp118__size;
		gint _tmp118__length1;
		GVariantIter _tmp119_;
		GVariant* _tmp120_;
		GVariant* _tmp121_;
		GVariant* _tmp122_;
		guint* _tmp123_;
		gint _tmp123__length;
		gint _tmp123__size;
		gint _tmp123__length1;
		GVariantIter _tmp124_;
		GVariant* _tmp125_;
		GVariant* _tmp126_;
		guint* _tmp127_;
		gint _tmp127__length;
		gint _tmp127__size;
		gint _tmp127__length1;
		GVariantIter _tmp128_;
		GVariant* _tmp129_;
		GVariant* _tmp130_;
		GHashTable* _tmp131_;
		GVariantIter _tmp132_;
		GVariant* _tmp133_;
		GVariant* _tmp134_;
		if (_tmp109__size == _tmp109__length) {
			_tmp109__size = 2 * _tmp109__size;
			_tmp109_ = g_renew (MutterReadDisplayOutput, _tmp109_, _tmp109__size + 1);
		}
		g_variant_iter_init (&_tmp113_, _tmp111_);
		_tmp114_ = g_variant_iter_next_value (&_tmp113_);
		_tmp112_.id = g_variant_get_uint32 (_tmp114_);
		g_variant_unref (_tmp114_);
		_tmp115_ = g_variant_iter_next_value (&_tmp113_);
		_tmp112_.winsys_id = g_variant_get_int64 (_tmp115_);
		g_variant_unref (_tmp115_);
		_tmp116_ = g_variant_iter_next_value (&_tmp113_);
		_tmp112_.current_crtc = g_variant_get_int32 (_tmp116_);
		g_variant_unref (_tmp116_);
		_tmp117_ = g_variant_iter_next_value (&_tmp113_);
		_tmp118_ = g_new (guint, 5);
		_tmp118__length = 0;
		_tmp118__size = 4;
		_tmp118__length1 = 0;
		g_variant_iter_init (&_tmp119_, _tmp117_);
		for (; (_tmp120_ = g_variant_iter_next_value (&_tmp119_)) != NULL; _tmp118__length1++) {
			if (_tmp118__size == _tmp118__length) {
				_tmp118__size = 2 * _tmp118__size;
				_tmp118_ = g_renew (guint, _tmp118_, _tmp118__size + 1);
			}
			_tmp118_[_tmp118__length++] = g_variant_get_uint32 (_tmp120_);
			g_variant_unref (_tmp120_);
		}
		_tmp112_.possible_crtcs_length1 = _tmp118__length1;
		_tmp112_.possible_crtcs = _tmp118_;
		g_variant_unref (_tmp117_);
		_tmp121_ = g_variant_iter_next_value (&_tmp113_);
		_tmp112_.connector_name = g_variant_dup_string (_tmp121_, NULL);
		g_variant_unref (_tmp121_);
		_tmp122_ = g_variant_iter_next_value (&_tmp113_);
		_tmp123_ = g_new (guint, 5);
		_tmp123__length = 0;
		_tmp123__size = 4;
		_tmp123__length1 = 0;
		g_variant_iter_init (&_tmp124_, _tmp122_);
		for (; (_tmp125_ = g_variant_iter_next_value (&_tmp124_)) != NULL; _tmp123__length1++) {
			if (_tmp123__size == _tmp123__length) {
				_tmp123__size = 2 * _tmp123__size;
				_tmp123_ = g_renew (guint, _tmp123_, _tmp123__size + 1);
			}
			_tmp123_[_tmp123__length++] = g_variant_get_uint32 (_tmp125_);
			g_variant_unref (_tmp125_);
		}
		_tmp112_.modes_length1 = _tmp123__length1;
		_tmp112_.modes = _tmp123_;
		g_variant_unref (_tmp122_);
		_tmp126_ = g_variant_iter_next_value (&_tmp113_);
		_tmp127_ = g_new (guint, 5);
		_tmp127__length = 0;
		_tmp127__size = 4;
		_tmp127__length1 = 0;
		g_variant_iter_init (&_tmp128_, _tmp126_);
		for (; (_tmp129_ = g_variant_iter_next_value (&_tmp128_)) != NULL; _tmp127__length1++) {
			if (_tmp127__size == _tmp127__length) {
				_tmp127__size = 2 * _tmp127__size;
				_tmp127_ = g_renew (guint, _tmp127_, _tmp127__size + 1);
			}
			_tmp127_[_tmp127__length++] = g_variant_get_uint32 (_tmp129_);
			g_variant_unref (_tmp129_);
		}
		_tmp112_.clones_length1 = _tmp127__length1;
		_tmp112_.clones = _tmp127_;
		g_variant_unref (_tmp126_);
		_tmp130_ = g_variant_iter_next_value (&_tmp113_);
		_tmp131_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp132_, _tmp130_);
		while (g_variant_iter_loop (&_tmp132_, "{?*}", &_tmp133_, &_tmp134_)) {
			g_hash_table_insert (_tmp131_, g_variant_dup_string (_tmp133_, NULL), g_variant_get_variant (_tmp134_));
		}
		_tmp112_.properties = _tmp131_;
		g_variant_unref (_tmp130_);
		_tmp109_[_tmp109__length++] = _tmp112_;
		g_variant_unref (_tmp111_);
	}
	_vala_outputs_length1 = _tmp109__length1;
	_vala_outputs = _tmp109_;
	g_variant_unref (_tmp108_);
	*outputs = _vala_outputs;
	*outputs_length1 = _vala_outputs_length1;
	_vala_modes_length1 = 0;
	_tmp135_ = g_variant_iter_next_value (&_reply_iter);
	_tmp136_ = g_new (MutterReadDisplayMode, 5);
	_tmp136__length = 0;
	_tmp136__size = 4;
	_tmp136__length1 = 0;
	g_variant_iter_init (&_tmp137_, _tmp135_);
	for (; (_tmp138_ = g_variant_iter_next_value (&_tmp137_)) != NULL; _tmp136__length1++) {
		MutterReadDisplayMode _tmp139_;
		GVariantIter _tmp140_;
		GVariant* _tmp141_;
		GVariant* _tmp142_;
		GVariant* _tmp143_;
		GVariant* _tmp144_;
		GVariant* _tmp145_;
		GVariant* _tmp146_;
		if (_tmp136__size == _tmp136__length) {
			_tmp136__size = 2 * _tmp136__size;
			_tmp136_ = g_renew (MutterReadDisplayMode, _tmp136_, _tmp136__size + 1);
		}
		g_variant_iter_init (&_tmp140_, _tmp138_);
		_tmp141_ = g_variant_iter_next_value (&_tmp140_);
		_tmp139_.id = g_variant_get_uint32 (_tmp141_);
		g_variant_unref (_tmp141_);
		_tmp142_ = g_variant_iter_next_value (&_tmp140_);
		_tmp139_.winsys_id = g_variant_get_int64 (_tmp142_);
		g_variant_unref (_tmp142_);
		_tmp143_ = g_variant_iter_next_value (&_tmp140_);
		_tmp139_.width = g_variant_get_uint32 (_tmp143_);
		g_variant_unref (_tmp143_);
		_tmp144_ = g_variant_iter_next_value (&_tmp140_);
		_tmp139_.height = g_variant_get_uint32 (_tmp144_);
		g_variant_unref (_tmp144_);
		_tmp145_ = g_variant_iter_next_value (&_tmp140_);
		_tmp139_.frequency = g_variant_get_double (_tmp145_);
		g_variant_unref (_tmp145_);
		_tmp146_ = g_variant_iter_next_value (&_tmp140_);
		_tmp139_.flags = g_variant_get_uint32 (_tmp146_);
		g_variant_unref (_tmp146_);
		_tmp136_[_tmp136__length++] = _tmp139_;
		g_variant_unref (_tmp138_);
	}
	_vala_modes_length1 = _tmp136__length1;
	_vala_modes = _tmp136_;
	g_variant_unref (_tmp135_);
	*modes = _vala_modes;
	*modes_length1 = _vala_modes_length1;
	_tmp147_ = g_variant_iter_next_value (&_reply_iter);
	_vala_max_screen_width = g_variant_get_int32 (_tmp147_);
	g_variant_unref (_tmp147_);
	*max_screen_width = _vala_max_screen_width;
	_tmp148_ = g_variant_iter_next_value (&_reply_iter);
	_vala_max_screen_height = g_variant_get_int32 (_tmp148_);
	g_variant_unref (_tmp148_);
	*max_screen_height = _vala_max_screen_height;
	g_object_unref (_reply_message);
}

static void
mutter_display_config_interface_proxy_apply_configuration (MutterDisplayConfigInterface* self,
                                                           guint serial,
                                                           gboolean persistent,
                                                           MutterWriteDisplayCrtc* crtcs,
                                                           gint crtcs_length1,
                                                           MutterWriteDisplayOutput* outputs,
                                                           gint outputs_length1,
                                                           GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	MutterWriteDisplayCrtc* _tmp149_;
	GVariantBuilder _tmp150_;
	gint _tmp151_;
	MutterWriteDisplayOutput* _tmp160_;
	GVariantBuilder _tmp161_;
	gint _tmp162_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "ApplyConfiguration");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (persistent));
	_tmp149_ = crtcs;
	g_variant_builder_init (&_tmp150_, G_VARIANT_TYPE ("a(uiiiuaua{sv})"));
	for (_tmp151_ = 0; _tmp151_ < crtcs_length1; _tmp151_++) {
		GVariantBuilder _tmp152_;
		guint* _tmp153_;
		GVariantBuilder _tmp154_;
		gint _tmp155_;
		GVariantBuilder _tmp156_;
		GHashTableIter _tmp157_;
		gpointer _tmp158_;
		gpointer _tmp159_;
		g_variant_builder_init (&_tmp152_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp152_, g_variant_new_uint32 ((*_tmp149_).id));
		g_variant_builder_add_value (&_tmp152_, g_variant_new_int32 ((*_tmp149_).new_mode));
		g_variant_builder_add_value (&_tmp152_, g_variant_new_int32 ((*_tmp149_).x));
		g_variant_builder_add_value (&_tmp152_, g_variant_new_int32 ((*_tmp149_).y));
		g_variant_builder_add_value (&_tmp152_, g_variant_new_uint32 ((*_tmp149_).transform));
		_tmp153_ = (*_tmp149_).outputs;
		g_variant_builder_init (&_tmp154_, G_VARIANT_TYPE ("au"));
		for (_tmp155_ = 0; _tmp155_ < (*_tmp149_).outputs_length1; _tmp155_++) {
			g_variant_builder_add_value (&_tmp154_, g_variant_new_uint32 (*_tmp153_));
			_tmp153_++;
		}
		g_variant_builder_add_value (&_tmp152_, g_variant_builder_end (&_tmp154_));
		g_hash_table_iter_init (&_tmp157_, (*_tmp149_).properties);
		g_variant_builder_init (&_tmp156_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp157_, &_tmp158_, &_tmp159_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp158_;
			_value = (GVariant*) _tmp159_;
			g_variant_builder_add (&_tmp156_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp152_, g_variant_builder_end (&_tmp156_));
		g_variant_builder_add_value (&_tmp150_, g_variant_builder_end (&_tmp152_));
		_tmp149_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp150_));
	_tmp160_ = outputs;
	g_variant_builder_init (&_tmp161_, G_VARIANT_TYPE ("a(ua{sv})"));
	for (_tmp162_ = 0; _tmp162_ < outputs_length1; _tmp162_++) {
		GVariantBuilder _tmp163_;
		GVariantBuilder _tmp164_;
		GHashTableIter _tmp165_;
		gpointer _tmp166_;
		gpointer _tmp167_;
		g_variant_builder_init (&_tmp163_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp163_, g_variant_new_uint32 ((*_tmp160_).id));
		g_hash_table_iter_init (&_tmp165_, (*_tmp160_).properties);
		g_variant_builder_init (&_tmp164_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp165_, &_tmp166_, &_tmp167_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp166_;
			_value = (GVariant*) _tmp167_;
			g_variant_builder_add (&_tmp164_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp163_, g_variant_builder_end (&_tmp164_));
		g_variant_builder_add_value (&_tmp161_, g_variant_builder_end (&_tmp163_));
		_tmp160_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp161_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static gint
mutter_display_config_interface_proxy_change_backlight (MutterDisplayConfigInterface* self,
                                                        guint serial,
                                                        guint output,
                                                        gint value,
                                                        GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gint _result = 0;
	GVariant* _tmp170_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "ChangeBacklight");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (output));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (value));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		gint _tmp168_ = 0;
		return _tmp168_;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		gint _tmp169_ = 0;
		g_object_unref (_reply_message);
		return _tmp169_;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp170_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_get_int32 (_tmp170_);
	g_variant_unref (_tmp170_);
	g_object_unref (_reply_message);
	return _result;
}

static void
mutter_display_config_interface_proxy_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                      guint serial,
                                                      guint crtc,
                                                      guint** red,
                                                      gint* red_length1,
                                                      guint** green,
                                                      gint* green_length1,
                                                      guint** blue,
                                                      gint* blue_length1,
                                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint* _vala_red = NULL;
	gint _vala_red_length1;
	GVariant* _tmp171_;
	guint* _tmp172_;
	gint _tmp172__length;
	gint _tmp172__size;
	gint _tmp172__length1;
	GVariantIter _tmp173_;
	GVariant* _tmp174_;
	guint* _vala_green = NULL;
	gint _vala_green_length1;
	GVariant* _tmp175_;
	guint* _tmp176_;
	gint _tmp176__length;
	gint _tmp176__size;
	gint _tmp176__length1;
	GVariantIter _tmp177_;
	GVariant* _tmp178_;
	guint* _vala_blue = NULL;
	gint _vala_blue_length1;
	GVariant* _tmp179_;
	guint* _tmp180_;
	gint _tmp180__length;
	gint _tmp180__size;
	gint _tmp180__length1;
	GVariantIter _tmp181_;
	GVariant* _tmp182_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "GetCrtcGamma");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (crtc));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_vala_red_length1 = 0;
	_tmp171_ = g_variant_iter_next_value (&_reply_iter);
	_tmp172_ = g_new (guint, 5);
	_tmp172__length = 0;
	_tmp172__size = 4;
	_tmp172__length1 = 0;
	g_variant_iter_init (&_tmp173_, _tmp171_);
	for (; (_tmp174_ = g_variant_iter_next_value (&_tmp173_)) != NULL; _tmp172__length1++) {
		if (_tmp172__size == _tmp172__length) {
			_tmp172__size = 2 * _tmp172__size;
			_tmp172_ = g_renew (guint, _tmp172_, _tmp172__size + 1);
		}
		_tmp172_[_tmp172__length++] = g_variant_get_uint32 (_tmp174_);
		g_variant_unref (_tmp174_);
	}
	_vala_red_length1 = _tmp172__length1;
	_vala_red = _tmp172_;
	g_variant_unref (_tmp171_);
	*red = _vala_red;
	*red_length1 = _vala_red_length1;
	_vala_green_length1 = 0;
	_tmp175_ = g_variant_iter_next_value (&_reply_iter);
	_tmp176_ = g_new (guint, 5);
	_tmp176__length = 0;
	_tmp176__size = 4;
	_tmp176__length1 = 0;
	g_variant_iter_init (&_tmp177_, _tmp175_);
	for (; (_tmp178_ = g_variant_iter_next_value (&_tmp177_)) != NULL; _tmp176__length1++) {
		if (_tmp176__size == _tmp176__length) {
			_tmp176__size = 2 * _tmp176__size;
			_tmp176_ = g_renew (guint, _tmp176_, _tmp176__size + 1);
		}
		_tmp176_[_tmp176__length++] = g_variant_get_uint32 (_tmp178_);
		g_variant_unref (_tmp178_);
	}
	_vala_green_length1 = _tmp176__length1;
	_vala_green = _tmp176_;
	g_variant_unref (_tmp175_);
	*green = _vala_green;
	*green_length1 = _vala_green_length1;
	_vala_blue_length1 = 0;
	_tmp179_ = g_variant_iter_next_value (&_reply_iter);
	_tmp180_ = g_new (guint, 5);
	_tmp180__length = 0;
	_tmp180__size = 4;
	_tmp180__length1 = 0;
	g_variant_iter_init (&_tmp181_, _tmp179_);
	for (; (_tmp182_ = g_variant_iter_next_value (&_tmp181_)) != NULL; _tmp180__length1++) {
		if (_tmp180__size == _tmp180__length) {
			_tmp180__size = 2 * _tmp180__size;
			_tmp180_ = g_renew (guint, _tmp180_, _tmp180__size + 1);
		}
		_tmp180_[_tmp180__length++] = g_variant_get_uint32 (_tmp182_);
		g_variant_unref (_tmp182_);
	}
	_vala_blue_length1 = _tmp180__length1;
	_vala_blue = _tmp180_;
	g_variant_unref (_tmp179_);
	*blue = _vala_blue;
	*blue_length1 = _vala_blue_length1;
	g_object_unref (_reply_message);
}

static void
mutter_display_config_interface_proxy_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                      guint serial,
                                                      guint crtc,
                                                      guint* red,
                                                      gint red_length1,
                                                      guint* green,
                                                      gint green_length1,
                                                      guint* blue,
                                                      gint blue_length1,
                                                      GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	guint* _tmp183_;
	GVariantBuilder _tmp184_;
	gint _tmp185_;
	guint* _tmp186_;
	GVariantBuilder _tmp187_;
	gint _tmp188_;
	guint* _tmp189_;
	GVariantBuilder _tmp190_;
	gint _tmp191_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "SetCrtcGamma");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (crtc));
	_tmp183_ = red;
	g_variant_builder_init (&_tmp184_, G_VARIANT_TYPE ("au"));
	for (_tmp185_ = 0; _tmp185_ < red_length1; _tmp185_++) {
		g_variant_builder_add_value (&_tmp184_, g_variant_new_uint32 (*_tmp183_));
		_tmp183_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp184_));
	_tmp186_ = green;
	g_variant_builder_init (&_tmp187_, G_VARIANT_TYPE ("au"));
	for (_tmp188_ = 0; _tmp188_ < green_length1; _tmp188_++) {
		g_variant_builder_add_value (&_tmp187_, g_variant_new_uint32 (*_tmp186_));
		_tmp186_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp187_));
	_tmp189_ = blue;
	g_variant_builder_init (&_tmp190_, G_VARIANT_TYPE ("au"));
	for (_tmp191_ = 0; _tmp191_ < blue_length1; _tmp191_++) {
		g_variant_builder_add_value (&_tmp190_, g_variant_new_uint32 (*_tmp189_));
		_tmp189_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp190_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static void
mutter_display_config_interface_proxy_get_current_state (MutterDisplayConfigInterface* self,
                                                         guint* serial,
                                                         MutterReadMonitor** monitors,
                                                         gint* monitors_length1,
                                                         MutterReadLogicalMonitor** logical_monitors,
                                                         gint* logical_monitors_length1,
                                                         GHashTable** properties,
                                                         GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	guint _vala_serial = 0U;
	GVariant* _tmp192_;
	MutterReadMonitor* _vala_monitors = NULL;
	gint _vala_monitors_length1;
	GVariant* _tmp193_;
	MutterReadMonitor* _tmp194_;
	gint _tmp194__length;
	gint _tmp194__size;
	gint _tmp194__length1;
	GVariantIter _tmp195_;
	GVariant* _tmp196_;
	MutterReadLogicalMonitor* _vala_logical_monitors = NULL;
	gint _vala_logical_monitors_length1;
	GVariant* _tmp231_;
	MutterReadLogicalMonitor* _tmp232_;
	gint _tmp232__length;
	gint _tmp232__size;
	gint _tmp232__length1;
	GVariantIter _tmp233_;
	GVariant* _tmp234_;
	GHashTable* _vala_properties = NULL;
	GVariant* _tmp257_;
	GHashTable* _tmp258_;
	GVariantIter _tmp259_;
	GVariant* _tmp260_;
	GVariant* _tmp261_;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "GetCurrentState");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp192_ = g_variant_iter_next_value (&_reply_iter);
	_vala_serial = g_variant_get_uint32 (_tmp192_);
	g_variant_unref (_tmp192_);
	*serial = _vala_serial;
	_vala_monitors_length1 = 0;
	_tmp193_ = g_variant_iter_next_value (&_reply_iter);
	_tmp194_ = g_new (MutterReadMonitor, 5);
	_tmp194__length = 0;
	_tmp194__size = 4;
	_tmp194__length1 = 0;
	g_variant_iter_init (&_tmp195_, _tmp193_);
	for (; (_tmp196_ = g_variant_iter_next_value (&_tmp195_)) != NULL; _tmp194__length1++) {
		MutterReadMonitor _tmp197_;
		GVariantIter _tmp198_;
		GVariant* _tmp199_;
		MutterReadMonitorInfo _tmp200_;
		GVariantIter _tmp201_;
		GVariant* _tmp202_;
		GVariant* _tmp203_;
		GVariant* _tmp204_;
		GVariant* _tmp205_;
		GVariant* _tmp206_;
		MutterReadMonitorMode* _tmp207_;
		gint _tmp207__length;
		gint _tmp207__size;
		gint _tmp207__length1;
		GVariantIter _tmp208_;
		GVariant* _tmp209_;
		GVariant* _tmp226_;
		GHashTable* _tmp227_;
		GVariantIter _tmp228_;
		GVariant* _tmp229_;
		GVariant* _tmp230_;
		if (_tmp194__size == _tmp194__length) {
			_tmp194__size = 2 * _tmp194__size;
			_tmp194_ = g_renew (MutterReadMonitor, _tmp194_, _tmp194__size + 1);
		}
		g_variant_iter_init (&_tmp198_, _tmp196_);
		_tmp199_ = g_variant_iter_next_value (&_tmp198_);
		g_variant_iter_init (&_tmp201_, _tmp199_);
		_tmp202_ = g_variant_iter_next_value (&_tmp201_);
		_tmp200_.connector = g_variant_dup_string (_tmp202_, NULL);
		g_variant_unref (_tmp202_);
		_tmp203_ = g_variant_iter_next_value (&_tmp201_);
		_tmp200_.vendor = g_variant_dup_string (_tmp203_, NULL);
		g_variant_unref (_tmp203_);
		_tmp204_ = g_variant_iter_next_value (&_tmp201_);
		_tmp200_.product = g_variant_dup_string (_tmp204_, NULL);
		g_variant_unref (_tmp204_);
		_tmp205_ = g_variant_iter_next_value (&_tmp201_);
		_tmp200_.serial = g_variant_dup_string (_tmp205_, NULL);
		g_variant_unref (_tmp205_);
		_tmp197_.monitor = _tmp200_;
		g_variant_unref (_tmp199_);
		_tmp206_ = g_variant_iter_next_value (&_tmp198_);
		_tmp207_ = g_new (MutterReadMonitorMode, 5);
		_tmp207__length = 0;
		_tmp207__size = 4;
		_tmp207__length1 = 0;
		g_variant_iter_init (&_tmp208_, _tmp206_);
		for (; (_tmp209_ = g_variant_iter_next_value (&_tmp208_)) != NULL; _tmp207__length1++) {
			MutterReadMonitorMode _tmp210_;
			GVariantIter _tmp211_;
			GVariant* _tmp212_;
			GVariant* _tmp213_;
			GVariant* _tmp214_;
			GVariant* _tmp215_;
			GVariant* _tmp216_;
			GVariant* _tmp217_;
			gdouble* _tmp218_;
			gint _tmp218__length;
			gint _tmp218__size;
			gint _tmp218__length1;
			GVariantIter _tmp219_;
			GVariant* _tmp220_;
			GVariant* _tmp221_;
			GHashTable* _tmp222_;
			GVariantIter _tmp223_;
			GVariant* _tmp224_;
			GVariant* _tmp225_;
			if (_tmp207__size == _tmp207__length) {
				_tmp207__size = 2 * _tmp207__size;
				_tmp207_ = g_renew (MutterReadMonitorMode, _tmp207_, _tmp207__size + 1);
			}
			g_variant_iter_init (&_tmp211_, _tmp209_);
			_tmp212_ = g_variant_iter_next_value (&_tmp211_);
			_tmp210_.id = g_variant_dup_string (_tmp212_, NULL);
			g_variant_unref (_tmp212_);
			_tmp213_ = g_variant_iter_next_value (&_tmp211_);
			_tmp210_.width = g_variant_get_int32 (_tmp213_);
			g_variant_unref (_tmp213_);
			_tmp214_ = g_variant_iter_next_value (&_tmp211_);
			_tmp210_.height = g_variant_get_int32 (_tmp214_);
			g_variant_unref (_tmp214_);
			_tmp215_ = g_variant_iter_next_value (&_tmp211_);
			_tmp210_.frequency = g_variant_get_double (_tmp215_);
			g_variant_unref (_tmp215_);
			_tmp216_ = g_variant_iter_next_value (&_tmp211_);
			_tmp210_.preferred_scale = g_variant_get_double (_tmp216_);
			g_variant_unref (_tmp216_);
			_tmp217_ = g_variant_iter_next_value (&_tmp211_);
			_tmp218_ = g_new (gdouble, 5);
			_tmp218__length = 0;
			_tmp218__size = 4;
			_tmp218__length1 = 0;
			g_variant_iter_init (&_tmp219_, _tmp217_);
			for (; (_tmp220_ = g_variant_iter_next_value (&_tmp219_)) != NULL; _tmp218__length1++) {
				if (_tmp218__size == _tmp218__length) {
					_tmp218__size = 2 * _tmp218__size;
					_tmp218_ = g_renew (gdouble, _tmp218_, _tmp218__size + 1);
				}
				_tmp218_[_tmp218__length++] = g_variant_get_double (_tmp220_);
				g_variant_unref (_tmp220_);
			}
			_tmp210_.supported_scales_length1 = _tmp218__length1;
			_tmp210_.supported_scales = _tmp218_;
			g_variant_unref (_tmp217_);
			_tmp221_ = g_variant_iter_next_value (&_tmp211_);
			_tmp222_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
			g_variant_iter_init (&_tmp223_, _tmp221_);
			while (g_variant_iter_loop (&_tmp223_, "{?*}", &_tmp224_, &_tmp225_)) {
				g_hash_table_insert (_tmp222_, g_variant_dup_string (_tmp224_, NULL), g_variant_get_variant (_tmp225_));
			}
			_tmp210_.properties = _tmp222_;
			g_variant_unref (_tmp221_);
			_tmp207_[_tmp207__length++] = _tmp210_;
			g_variant_unref (_tmp209_);
		}
		_tmp197_.modes_length1 = _tmp207__length1;
		_tmp197_.modes = _tmp207_;
		g_variant_unref (_tmp206_);
		_tmp226_ = g_variant_iter_next_value (&_tmp198_);
		_tmp227_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp228_, _tmp226_);
		while (g_variant_iter_loop (&_tmp228_, "{?*}", &_tmp229_, &_tmp230_)) {
			g_hash_table_insert (_tmp227_, g_variant_dup_string (_tmp229_, NULL), g_variant_get_variant (_tmp230_));
		}
		_tmp197_.properties = _tmp227_;
		g_variant_unref (_tmp226_);
		_tmp194_[_tmp194__length++] = _tmp197_;
		g_variant_unref (_tmp196_);
	}
	_vala_monitors_length1 = _tmp194__length1;
	_vala_monitors = _tmp194_;
	g_variant_unref (_tmp193_);
	*monitors = _vala_monitors;
	*monitors_length1 = _vala_monitors_length1;
	_vala_logical_monitors_length1 = 0;
	_tmp231_ = g_variant_iter_next_value (&_reply_iter);
	_tmp232_ = g_new (MutterReadLogicalMonitor, 5);
	_tmp232__length = 0;
	_tmp232__size = 4;
	_tmp232__length1 = 0;
	g_variant_iter_init (&_tmp233_, _tmp231_);
	for (; (_tmp234_ = g_variant_iter_next_value (&_tmp233_)) != NULL; _tmp232__length1++) {
		MutterReadLogicalMonitor _tmp235_;
		GVariantIter _tmp236_;
		GVariant* _tmp237_;
		GVariant* _tmp238_;
		GVariant* _tmp239_;
		GVariant* _tmp240_;
		GVariant* _tmp241_;
		GVariant* _tmp242_;
		MutterReadMonitorInfo* _tmp243_;
		gint _tmp243__length;
		gint _tmp243__size;
		gint _tmp243__length1;
		GVariantIter _tmp244_;
		GVariant* _tmp245_;
		GVariant* _tmp252_;
		GHashTable* _tmp253_;
		GVariantIter _tmp254_;
		GVariant* _tmp255_;
		GVariant* _tmp256_;
		if (_tmp232__size == _tmp232__length) {
			_tmp232__size = 2 * _tmp232__size;
			_tmp232_ = g_renew (MutterReadLogicalMonitor, _tmp232_, _tmp232__size + 1);
		}
		g_variant_iter_init (&_tmp236_, _tmp234_);
		_tmp237_ = g_variant_iter_next_value (&_tmp236_);
		_tmp235_.x = g_variant_get_int32 (_tmp237_);
		g_variant_unref (_tmp237_);
		_tmp238_ = g_variant_iter_next_value (&_tmp236_);
		_tmp235_.y = g_variant_get_int32 (_tmp238_);
		g_variant_unref (_tmp238_);
		_tmp239_ = g_variant_iter_next_value (&_tmp236_);
		_tmp235_.scale = g_variant_get_double (_tmp239_);
		g_variant_unref (_tmp239_);
		_tmp240_ = g_variant_iter_next_value (&_tmp236_);
		_tmp235_.transform = g_variant_get_uint32 (_tmp240_);
		g_variant_unref (_tmp240_);
		_tmp241_ = g_variant_iter_next_value (&_tmp236_);
		_tmp235_.primary = g_variant_get_boolean (_tmp241_);
		g_variant_unref (_tmp241_);
		_tmp242_ = g_variant_iter_next_value (&_tmp236_);
		_tmp243_ = g_new (MutterReadMonitorInfo, 5);
		_tmp243__length = 0;
		_tmp243__size = 4;
		_tmp243__length1 = 0;
		g_variant_iter_init (&_tmp244_, _tmp242_);
		for (; (_tmp245_ = g_variant_iter_next_value (&_tmp244_)) != NULL; _tmp243__length1++) {
			MutterReadMonitorInfo _tmp246_;
			GVariantIter _tmp247_;
			GVariant* _tmp248_;
			GVariant* _tmp249_;
			GVariant* _tmp250_;
			GVariant* _tmp251_;
			if (_tmp243__size == _tmp243__length) {
				_tmp243__size = 2 * _tmp243__size;
				_tmp243_ = g_renew (MutterReadMonitorInfo, _tmp243_, _tmp243__size + 1);
			}
			g_variant_iter_init (&_tmp247_, _tmp245_);
			_tmp248_ = g_variant_iter_next_value (&_tmp247_);
			_tmp246_.connector = g_variant_dup_string (_tmp248_, NULL);
			g_variant_unref (_tmp248_);
			_tmp249_ = g_variant_iter_next_value (&_tmp247_);
			_tmp246_.vendor = g_variant_dup_string (_tmp249_, NULL);
			g_variant_unref (_tmp249_);
			_tmp250_ = g_variant_iter_next_value (&_tmp247_);
			_tmp246_.product = g_variant_dup_string (_tmp250_, NULL);
			g_variant_unref (_tmp250_);
			_tmp251_ = g_variant_iter_next_value (&_tmp247_);
			_tmp246_.serial = g_variant_dup_string (_tmp251_, NULL);
			g_variant_unref (_tmp251_);
			_tmp243_[_tmp243__length++] = _tmp246_;
			g_variant_unref (_tmp245_);
		}
		_tmp235_.monitors_length1 = _tmp243__length1;
		_tmp235_.monitors = _tmp243_;
		g_variant_unref (_tmp242_);
		_tmp252_ = g_variant_iter_next_value (&_tmp236_);
		_tmp253_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp254_, _tmp252_);
		while (g_variant_iter_loop (&_tmp254_, "{?*}", &_tmp255_, &_tmp256_)) {
			g_hash_table_insert (_tmp253_, g_variant_dup_string (_tmp255_, NULL), g_variant_get_variant (_tmp256_));
		}
		_tmp235_.properties = _tmp253_;
		g_variant_unref (_tmp252_);
		_tmp232_[_tmp232__length++] = _tmp235_;
		g_variant_unref (_tmp234_);
	}
	_vala_logical_monitors_length1 = _tmp232__length1;
	_vala_logical_monitors = _tmp232_;
	g_variant_unref (_tmp231_);
	*logical_monitors = _vala_logical_monitors;
	*logical_monitors_length1 = _vala_logical_monitors_length1;
	_tmp257_ = g_variant_iter_next_value (&_reply_iter);
	_tmp258_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp259_, _tmp257_);
	while (g_variant_iter_loop (&_tmp259_, "{?*}", &_tmp260_, &_tmp261_)) {
		g_hash_table_insert (_tmp258_, g_variant_dup_string (_tmp260_, NULL), g_variant_get_variant (_tmp261_));
	}
	_vala_properties = _tmp258_;
	g_variant_unref (_tmp257_);
	*properties = _vala_properties;
	g_object_unref (_reply_message);
}

static void
mutter_display_config_interface_proxy_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                             guint serial,
                                                             MutterApplyMethod method,
                                                             MutterWriteLogicalMonitor* logical_monitors,
                                                             gint logical_monitors_length1,
                                                             GHashTable* properties,
                                                             GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	MutterWriteLogicalMonitor* _tmp262_;
	GVariantBuilder _tmp263_;
	gint _tmp264_;
	GVariantBuilder _tmp274_;
	GHashTableIter _tmp275_;
	gpointer _tmp276_;
	gpointer _tmp277_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.gnome.Mutter.DisplayConfig", "ApplyMonitorsConfig");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (serial));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_uint32 (method));
	_tmp262_ = logical_monitors;
	g_variant_builder_init (&_tmp263_, G_VARIANT_TYPE ("a(iiduba(ssa{sv}))"));
	for (_tmp264_ = 0; _tmp264_ < logical_monitors_length1; _tmp264_++) {
		GVariantBuilder _tmp265_;
		MutterWriteMonitor* _tmp266_;
		GVariantBuilder _tmp267_;
		gint _tmp268_;
		g_variant_builder_init (&_tmp265_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp265_, g_variant_new_int32 ((*_tmp262_).x));
		g_variant_builder_add_value (&_tmp265_, g_variant_new_int32 ((*_tmp262_).y));
		g_variant_builder_add_value (&_tmp265_, g_variant_new_double ((*_tmp262_).scale));
		g_variant_builder_add_value (&_tmp265_, g_variant_new_uint32 ((*_tmp262_).transform));
		g_variant_builder_add_value (&_tmp265_, g_variant_new_boolean ((*_tmp262_).primary));
		_tmp266_ = (*_tmp262_).monitors;
		g_variant_builder_init (&_tmp267_, G_VARIANT_TYPE ("a(ssa{sv})"));
		for (_tmp268_ = 0; _tmp268_ < (*_tmp262_).monitors_length1; _tmp268_++) {
			GVariantBuilder _tmp269_;
			GVariantBuilder _tmp270_;
			GHashTableIter _tmp271_;
			gpointer _tmp272_;
			gpointer _tmp273_;
			g_variant_builder_init (&_tmp269_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp269_, g_variant_new_string ((*_tmp266_).connector));
			g_variant_builder_add_value (&_tmp269_, g_variant_new_string ((*_tmp266_).monitor_mode));
			g_hash_table_iter_init (&_tmp271_, (*_tmp266_).properties);
			g_variant_builder_init (&_tmp270_, G_VARIANT_TYPE ("a{sv}"));
			while (g_hash_table_iter_next (&_tmp271_, &_tmp272_, &_tmp273_)) {
				gchar* _key;
				GVariant* _value;
				_key = (gchar*) _tmp272_;
				_value = (GVariant*) _tmp273_;
				g_variant_builder_add (&_tmp270_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
			}
			g_variant_builder_add_value (&_tmp269_, g_variant_builder_end (&_tmp270_));
			g_variant_builder_add_value (&_tmp267_, g_variant_builder_end (&_tmp269_));
			_tmp266_++;
		}
		g_variant_builder_add_value (&_tmp265_, g_variant_builder_end (&_tmp267_));
		g_variant_builder_add_value (&_tmp263_, g_variant_builder_end (&_tmp265_));
		_tmp262_++;
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp263_));
	g_hash_table_iter_init (&_tmp275_, properties);
	g_variant_builder_init (&_tmp274_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp275_, &_tmp276_, &_tmp277_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp276_;
		_value = (GVariant*) _tmp277_;
		g_variant_builder_add (&_tmp274_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp274_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}

static gint
mutter_display_config_interface_dbus_proxy_get_power_save_mode (MutterDisplayConfigInterface* self)
{
	GVariant *_inner_reply;
	gint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "PowerSaveMode");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.Mutter.DisplayConfig"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PowerSaveMode"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gint _tmp278_ = 0;
			return _tmp278_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_int32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
mutter_display_config_interface_dbus_proxy_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                                gint value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.gnome.Mutter.DisplayConfig"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PowerSaveMode"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_int32 (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}

static void
mutter_display_config_interface_proxy_mutter_display_config_interface_interface_init (MutterDisplayConfigInterfaceIface* iface)
{
	iface->get_resources = mutter_display_config_interface_proxy_get_resources;
	iface->apply_configuration = mutter_display_config_interface_proxy_apply_configuration;
	iface->change_backlight = mutter_display_config_interface_proxy_change_backlight;
	iface->get_crtc_gamma = mutter_display_config_interface_proxy_get_crtc_gamma;
	iface->set_crtc_gamma = mutter_display_config_interface_proxy_set_crtc_gamma;
	iface->get_current_state = mutter_display_config_interface_proxy_get_current_state;
	iface->apply_monitors_config = mutter_display_config_interface_proxy_apply_monitors_config;
	iface->get_power_save_mode = mutter_display_config_interface_dbus_proxy_get_power_save_mode;
	iface->set_power_save_mode = mutter_display_config_interface_dbus_proxy_set_power_save_mode;
}

static void
_vala_MutterReadDisplayCrtc_array_free (MutterReadDisplayCrtc * array,
                                        gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_display_crtc_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_vala_MutterReadDisplayOutput_array_free (MutterReadDisplayOutput * array,
                                          gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_display_output_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_mutter_display_config_interface_get_resources (MutterDisplayConfigInterface* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint serial = 0U;
	MutterReadDisplayCrtc* crtcs = NULL;
	gint crtcs_length1 = 0;
	MutterReadDisplayCrtc* _tmp279_;
	GVariantBuilder _tmp280_;
	gint _tmp281_;
	MutterReadDisplayOutput* outputs = NULL;
	gint outputs_length1 = 0;
	MutterReadDisplayOutput* _tmp290_;
	GVariantBuilder _tmp291_;
	gint _tmp292_;
	MutterReadDisplayMode* modes = NULL;
	gint modes_length1 = 0;
	MutterReadDisplayMode* _tmp307_;
	GVariantBuilder _tmp308_;
	gint _tmp309_;
	gint max_screen_width = 0;
	gint max_screen_height = 0;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mutter_display_config_interface_get_resources (self, &serial, &crtcs, &crtcs_length1, &outputs, &outputs_length1, &modes, &modes_length1, &max_screen_width, &max_screen_height, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (serial));
	_tmp279_ = crtcs;
	g_variant_builder_init (&_tmp280_, G_VARIANT_TYPE ("a(uxiiiiiuaua{sv})"));
	for (_tmp281_ = 0; _tmp281_ < crtcs_length1; _tmp281_++) {
		GVariantBuilder _tmp282_;
		DisplayTransform* _tmp283_;
		GVariantBuilder _tmp284_;
		gint _tmp285_;
		GVariantBuilder _tmp286_;
		GHashTableIter _tmp287_;
		gpointer _tmp288_;
		gpointer _tmp289_;
		g_variant_builder_init (&_tmp282_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp282_, g_variant_new_uint32 ((*_tmp279_).id));
		g_variant_builder_add_value (&_tmp282_, g_variant_new_int64 ((*_tmp279_).winsys_id));
		g_variant_builder_add_value (&_tmp282_, g_variant_new_int32 ((*_tmp279_).x));
		g_variant_builder_add_value (&_tmp282_, g_variant_new_int32 ((*_tmp279_).y));
		g_variant_builder_add_value (&_tmp282_, g_variant_new_int32 ((*_tmp279_).width));
		g_variant_builder_add_value (&_tmp282_, g_variant_new_int32 ((*_tmp279_).height));
		g_variant_builder_add_value (&_tmp282_, g_variant_new_int32 ((*_tmp279_).current_mode));
		g_variant_builder_add_value (&_tmp282_, g_variant_new_uint32 ((*_tmp279_).current_transform));
		_tmp283_ = (*_tmp279_).transforms;
		g_variant_builder_init (&_tmp284_, G_VARIANT_TYPE ("au"));
		for (_tmp285_ = 0; _tmp285_ < (*_tmp279_).transforms_length1; _tmp285_++) {
			g_variant_builder_add_value (&_tmp284_, g_variant_new_uint32 (*_tmp283_));
			_tmp283_++;
		}
		g_variant_builder_add_value (&_tmp282_, g_variant_builder_end (&_tmp284_));
		g_hash_table_iter_init (&_tmp287_, (*_tmp279_).properties);
		g_variant_builder_init (&_tmp286_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp287_, &_tmp288_, &_tmp289_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp288_;
			_value = (GVariant*) _tmp289_;
			g_variant_builder_add (&_tmp286_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp282_, g_variant_builder_end (&_tmp286_));
		g_variant_builder_add_value (&_tmp280_, g_variant_builder_end (&_tmp282_));
		_tmp279_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp280_));
	_tmp290_ = outputs;
	g_variant_builder_init (&_tmp291_, G_VARIANT_TYPE ("a(uxiausauaua{sv})"));
	for (_tmp292_ = 0; _tmp292_ < outputs_length1; _tmp292_++) {
		GVariantBuilder _tmp293_;
		guint* _tmp294_;
		GVariantBuilder _tmp295_;
		gint _tmp296_;
		guint* _tmp297_;
		GVariantBuilder _tmp298_;
		gint _tmp299_;
		guint* _tmp300_;
		GVariantBuilder _tmp301_;
		gint _tmp302_;
		GVariantBuilder _tmp303_;
		GHashTableIter _tmp304_;
		gpointer _tmp305_;
		gpointer _tmp306_;
		g_variant_builder_init (&_tmp293_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp293_, g_variant_new_uint32 ((*_tmp290_).id));
		g_variant_builder_add_value (&_tmp293_, g_variant_new_int64 ((*_tmp290_).winsys_id));
		g_variant_builder_add_value (&_tmp293_, g_variant_new_int32 ((*_tmp290_).current_crtc));
		_tmp294_ = (*_tmp290_).possible_crtcs;
		g_variant_builder_init (&_tmp295_, G_VARIANT_TYPE ("au"));
		for (_tmp296_ = 0; _tmp296_ < (*_tmp290_).possible_crtcs_length1; _tmp296_++) {
			g_variant_builder_add_value (&_tmp295_, g_variant_new_uint32 (*_tmp294_));
			_tmp294_++;
		}
		g_variant_builder_add_value (&_tmp293_, g_variant_builder_end (&_tmp295_));
		g_variant_builder_add_value (&_tmp293_, g_variant_new_string ((*_tmp290_).connector_name));
		_tmp297_ = (*_tmp290_).modes;
		g_variant_builder_init (&_tmp298_, G_VARIANT_TYPE ("au"));
		for (_tmp299_ = 0; _tmp299_ < (*_tmp290_).modes_length1; _tmp299_++) {
			g_variant_builder_add_value (&_tmp298_, g_variant_new_uint32 (*_tmp297_));
			_tmp297_++;
		}
		g_variant_builder_add_value (&_tmp293_, g_variant_builder_end (&_tmp298_));
		_tmp300_ = (*_tmp290_).clones;
		g_variant_builder_init (&_tmp301_, G_VARIANT_TYPE ("au"));
		for (_tmp302_ = 0; _tmp302_ < (*_tmp290_).clones_length1; _tmp302_++) {
			g_variant_builder_add_value (&_tmp301_, g_variant_new_uint32 (*_tmp300_));
			_tmp300_++;
		}
		g_variant_builder_add_value (&_tmp293_, g_variant_builder_end (&_tmp301_));
		g_hash_table_iter_init (&_tmp304_, (*_tmp290_).properties);
		g_variant_builder_init (&_tmp303_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp304_, &_tmp305_, &_tmp306_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp305_;
			_value = (GVariant*) _tmp306_;
			g_variant_builder_add (&_tmp303_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp293_, g_variant_builder_end (&_tmp303_));
		g_variant_builder_add_value (&_tmp291_, g_variant_builder_end (&_tmp293_));
		_tmp290_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp291_));
	_tmp307_ = modes;
	g_variant_builder_init (&_tmp308_, G_VARIANT_TYPE ("a(uxuudu)"));
	for (_tmp309_ = 0; _tmp309_ < modes_length1; _tmp309_++) {
		GVariantBuilder _tmp310_;
		g_variant_builder_init (&_tmp310_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp310_, g_variant_new_uint32 ((*_tmp307_).id));
		g_variant_builder_add_value (&_tmp310_, g_variant_new_int64 ((*_tmp307_).winsys_id));
		g_variant_builder_add_value (&_tmp310_, g_variant_new_uint32 ((*_tmp307_).width));
		g_variant_builder_add_value (&_tmp310_, g_variant_new_uint32 ((*_tmp307_).height));
		g_variant_builder_add_value (&_tmp310_, g_variant_new_double ((*_tmp307_).frequency));
		g_variant_builder_add_value (&_tmp310_, g_variant_new_uint32 ((*_tmp307_).flags));
		g_variant_builder_add_value (&_tmp308_, g_variant_builder_end (&_tmp310_));
		_tmp307_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp308_));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (max_screen_width));
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (max_screen_height));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	crtcs = (_vala_MutterReadDisplayCrtc_array_free (crtcs, crtcs_length1), NULL);
	outputs = (_vala_MutterReadDisplayOutput_array_free (outputs, outputs_length1), NULL);
	modes = (g_free (modes), NULL);
}

static void
_vala_MutterWriteDisplayCrtc_array_free (MutterWriteDisplayCrtc * array,
                                         gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_display_crtc_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_vala_MutterWriteDisplayOutput_array_free (MutterWriteDisplayOutput * array,
                                           gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_display_output_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_mutter_display_config_interface_apply_configuration (MutterDisplayConfigInterface* self,
                                                           GVariant* _parameters_,
                                                           GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp311_;
	gboolean persistent = FALSE;
	GVariant* _tmp312_;
	MutterWriteDisplayCrtc* crtcs = NULL;
	gint crtcs_length1 = 0;
	GVariant* _tmp313_;
	MutterWriteDisplayCrtc* _tmp314_;
	gint _tmp314__length;
	gint _tmp314__size;
	gint _tmp314__length1;
	GVariantIter _tmp315_;
	GVariant* _tmp316_;
	MutterWriteDisplayOutput* outputs = NULL;
	gint outputs_length1 = 0;
	GVariant* _tmp333_;
	MutterWriteDisplayOutput* _tmp334_;
	gint _tmp334__length;
	gint _tmp334__size;
	gint _tmp334__length1;
	GVariantIter _tmp335_;
	GVariant* _tmp336_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp311_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp311_);
	g_variant_unref (_tmp311_);
	_tmp312_ = g_variant_iter_next_value (&_arguments_iter);
	persistent = g_variant_get_boolean (_tmp312_);
	g_variant_unref (_tmp312_);
	_tmp313_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp314_ = g_new (MutterWriteDisplayCrtc, 5);
	_tmp314__length = 0;
	_tmp314__size = 4;
	_tmp314__length1 = 0;
	g_variant_iter_init (&_tmp315_, _tmp313_);
	for (; (_tmp316_ = g_variant_iter_next_value (&_tmp315_)) != NULL; _tmp314__length1++) {
		MutterWriteDisplayCrtc _tmp317_;
		GVariantIter _tmp318_;
		GVariant* _tmp319_;
		GVariant* _tmp320_;
		GVariant* _tmp321_;
		GVariant* _tmp322_;
		GVariant* _tmp323_;
		GVariant* _tmp324_;
		guint* _tmp325_;
		gint _tmp325__length;
		gint _tmp325__size;
		gint _tmp325__length1;
		GVariantIter _tmp326_;
		GVariant* _tmp327_;
		GVariant* _tmp328_;
		GHashTable* _tmp329_;
		GVariantIter _tmp330_;
		GVariant* _tmp331_;
		GVariant* _tmp332_;
		if (_tmp314__size == _tmp314__length) {
			_tmp314__size = 2 * _tmp314__size;
			_tmp314_ = g_renew (MutterWriteDisplayCrtc, _tmp314_, _tmp314__size + 1);
		}
		g_variant_iter_init (&_tmp318_, _tmp316_);
		_tmp319_ = g_variant_iter_next_value (&_tmp318_);
		_tmp317_.id = g_variant_get_uint32 (_tmp319_);
		g_variant_unref (_tmp319_);
		_tmp320_ = g_variant_iter_next_value (&_tmp318_);
		_tmp317_.new_mode = g_variant_get_int32 (_tmp320_);
		g_variant_unref (_tmp320_);
		_tmp321_ = g_variant_iter_next_value (&_tmp318_);
		_tmp317_.x = g_variant_get_int32 (_tmp321_);
		g_variant_unref (_tmp321_);
		_tmp322_ = g_variant_iter_next_value (&_tmp318_);
		_tmp317_.y = g_variant_get_int32 (_tmp322_);
		g_variant_unref (_tmp322_);
		_tmp323_ = g_variant_iter_next_value (&_tmp318_);
		_tmp317_.transform = g_variant_get_uint32 (_tmp323_);
		g_variant_unref (_tmp323_);
		_tmp324_ = g_variant_iter_next_value (&_tmp318_);
		_tmp325_ = g_new (guint, 5);
		_tmp325__length = 0;
		_tmp325__size = 4;
		_tmp325__length1 = 0;
		g_variant_iter_init (&_tmp326_, _tmp324_);
		for (; (_tmp327_ = g_variant_iter_next_value (&_tmp326_)) != NULL; _tmp325__length1++) {
			if (_tmp325__size == _tmp325__length) {
				_tmp325__size = 2 * _tmp325__size;
				_tmp325_ = g_renew (guint, _tmp325_, _tmp325__size + 1);
			}
			_tmp325_[_tmp325__length++] = g_variant_get_uint32 (_tmp327_);
			g_variant_unref (_tmp327_);
		}
		_tmp317_.outputs_length1 = _tmp325__length1;
		_tmp317_.outputs = _tmp325_;
		g_variant_unref (_tmp324_);
		_tmp328_ = g_variant_iter_next_value (&_tmp318_);
		_tmp329_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp330_, _tmp328_);
		while (g_variant_iter_loop (&_tmp330_, "{?*}", &_tmp331_, &_tmp332_)) {
			g_hash_table_insert (_tmp329_, g_variant_dup_string (_tmp331_, NULL), g_variant_get_variant (_tmp332_));
		}
		_tmp317_.properties = _tmp329_;
		g_variant_unref (_tmp328_);
		_tmp314_[_tmp314__length++] = _tmp317_;
		g_variant_unref (_tmp316_);
	}
	crtcs_length1 = _tmp314__length1;
	crtcs = _tmp314_;
	g_variant_unref (_tmp313_);
	_tmp333_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp334_ = g_new (MutterWriteDisplayOutput, 5);
	_tmp334__length = 0;
	_tmp334__size = 4;
	_tmp334__length1 = 0;
	g_variant_iter_init (&_tmp335_, _tmp333_);
	for (; (_tmp336_ = g_variant_iter_next_value (&_tmp335_)) != NULL; _tmp334__length1++) {
		MutterWriteDisplayOutput _tmp337_;
		GVariantIter _tmp338_;
		GVariant* _tmp339_;
		GVariant* _tmp340_;
		GHashTable* _tmp341_;
		GVariantIter _tmp342_;
		GVariant* _tmp343_;
		GVariant* _tmp344_;
		if (_tmp334__size == _tmp334__length) {
			_tmp334__size = 2 * _tmp334__size;
			_tmp334_ = g_renew (MutterWriteDisplayOutput, _tmp334_, _tmp334__size + 1);
		}
		g_variant_iter_init (&_tmp338_, _tmp336_);
		_tmp339_ = g_variant_iter_next_value (&_tmp338_);
		_tmp337_.id = g_variant_get_uint32 (_tmp339_);
		g_variant_unref (_tmp339_);
		_tmp340_ = g_variant_iter_next_value (&_tmp338_);
		_tmp341_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
		g_variant_iter_init (&_tmp342_, _tmp340_);
		while (g_variant_iter_loop (&_tmp342_, "{?*}", &_tmp343_, &_tmp344_)) {
			g_hash_table_insert (_tmp341_, g_variant_dup_string (_tmp343_, NULL), g_variant_get_variant (_tmp344_));
		}
		_tmp337_.properties = _tmp341_;
		g_variant_unref (_tmp340_);
		_tmp334_[_tmp334__length++] = _tmp337_;
		g_variant_unref (_tmp336_);
	}
	outputs_length1 = _tmp334__length1;
	outputs = _tmp334_;
	g_variant_unref (_tmp333_);
	mutter_display_config_interface_apply_configuration (self, serial, persistent, crtcs, crtcs_length1, outputs, outputs_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	crtcs = (_vala_MutterWriteDisplayCrtc_array_free (crtcs, crtcs_length1), NULL);
	outputs = (_vala_MutterWriteDisplayOutput_array_free (outputs, outputs_length1), NULL);
	;
}

static void
_dbus_mutter_display_config_interface_change_backlight (MutterDisplayConfigInterface* self,
                                                        GVariant* _parameters_,
                                                        GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp345_;
	guint output = 0U;
	GVariant* _tmp346_;
	gint value = 0;
	GVariant* _tmp347_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gint result;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp345_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp345_);
	g_variant_unref (_tmp345_);
	_tmp346_ = g_variant_iter_next_value (&_arguments_iter);
	output = g_variant_get_uint32 (_tmp346_);
	g_variant_unref (_tmp346_);
	_tmp347_ = g_variant_iter_next_value (&_arguments_iter);
	value = g_variant_get_int32 (_tmp347_);
	g_variant_unref (_tmp347_);
	result = mutter_display_config_interface_change_backlight (self, serial, output, value, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_int32 (result));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}

static void
_dbus_mutter_display_config_interface_get_crtc_gamma (MutterDisplayConfigInterface* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp348_;
	guint crtc = 0U;
	GVariant* _tmp349_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint* red = NULL;
	gint red_length1 = 0;
	guint* _tmp350_;
	GVariantBuilder _tmp351_;
	gint _tmp352_;
	guint* green = NULL;
	gint green_length1 = 0;
	guint* _tmp353_;
	GVariantBuilder _tmp354_;
	gint _tmp355_;
	guint* blue = NULL;
	gint blue_length1 = 0;
	guint* _tmp356_;
	GVariantBuilder _tmp357_;
	gint _tmp358_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp348_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp348_);
	g_variant_unref (_tmp348_);
	_tmp349_ = g_variant_iter_next_value (&_arguments_iter);
	crtc = g_variant_get_uint32 (_tmp349_);
	g_variant_unref (_tmp349_);
	mutter_display_config_interface_get_crtc_gamma (self, serial, crtc, &red, &red_length1, &green, &green_length1, &blue, &blue_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp350_ = red;
	g_variant_builder_init (&_tmp351_, G_VARIANT_TYPE ("au"));
	for (_tmp352_ = 0; _tmp352_ < red_length1; _tmp352_++) {
		g_variant_builder_add_value (&_tmp351_, g_variant_new_uint32 (*_tmp350_));
		_tmp350_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp351_));
	_tmp353_ = green;
	g_variant_builder_init (&_tmp354_, G_VARIANT_TYPE ("au"));
	for (_tmp355_ = 0; _tmp355_ < green_length1; _tmp355_++) {
		g_variant_builder_add_value (&_tmp354_, g_variant_new_uint32 (*_tmp353_));
		_tmp353_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp354_));
	_tmp356_ = blue;
	g_variant_builder_init (&_tmp357_, G_VARIANT_TYPE ("au"));
	for (_tmp358_ = 0; _tmp358_ < blue_length1; _tmp358_++) {
		g_variant_builder_add_value (&_tmp357_, g_variant_new_uint32 (*_tmp356_));
		_tmp356_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp357_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	red = (g_free (red), NULL);
	green = (g_free (green), NULL);
	blue = (g_free (blue), NULL);
}

static void
_dbus_mutter_display_config_interface_set_crtc_gamma (MutterDisplayConfigInterface* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp359_;
	guint crtc = 0U;
	GVariant* _tmp360_;
	guint* red = NULL;
	gint red_length1 = 0;
	GVariant* _tmp361_;
	guint* _tmp362_;
	gint _tmp362__length;
	gint _tmp362__size;
	gint _tmp362__length1;
	GVariantIter _tmp363_;
	GVariant* _tmp364_;
	guint* green = NULL;
	gint green_length1 = 0;
	GVariant* _tmp365_;
	guint* _tmp366_;
	gint _tmp366__length;
	gint _tmp366__size;
	gint _tmp366__length1;
	GVariantIter _tmp367_;
	GVariant* _tmp368_;
	guint* blue = NULL;
	gint blue_length1 = 0;
	GVariant* _tmp369_;
	guint* _tmp370_;
	gint _tmp370__length;
	gint _tmp370__size;
	gint _tmp370__length1;
	GVariantIter _tmp371_;
	GVariant* _tmp372_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp359_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp359_);
	g_variant_unref (_tmp359_);
	_tmp360_ = g_variant_iter_next_value (&_arguments_iter);
	crtc = g_variant_get_uint32 (_tmp360_);
	g_variant_unref (_tmp360_);
	_tmp361_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp362_ = g_new (guint, 5);
	_tmp362__length = 0;
	_tmp362__size = 4;
	_tmp362__length1 = 0;
	g_variant_iter_init (&_tmp363_, _tmp361_);
	for (; (_tmp364_ = g_variant_iter_next_value (&_tmp363_)) != NULL; _tmp362__length1++) {
		if (_tmp362__size == _tmp362__length) {
			_tmp362__size = 2 * _tmp362__size;
			_tmp362_ = g_renew (guint, _tmp362_, _tmp362__size + 1);
		}
		_tmp362_[_tmp362__length++] = g_variant_get_uint32 (_tmp364_);
		g_variant_unref (_tmp364_);
	}
	red_length1 = _tmp362__length1;
	red = _tmp362_;
	g_variant_unref (_tmp361_);
	_tmp365_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp366_ = g_new (guint, 5);
	_tmp366__length = 0;
	_tmp366__size = 4;
	_tmp366__length1 = 0;
	g_variant_iter_init (&_tmp367_, _tmp365_);
	for (; (_tmp368_ = g_variant_iter_next_value (&_tmp367_)) != NULL; _tmp366__length1++) {
		if (_tmp366__size == _tmp366__length) {
			_tmp366__size = 2 * _tmp366__size;
			_tmp366_ = g_renew (guint, _tmp366_, _tmp366__size + 1);
		}
		_tmp366_[_tmp366__length++] = g_variant_get_uint32 (_tmp368_);
		g_variant_unref (_tmp368_);
	}
	green_length1 = _tmp366__length1;
	green = _tmp366_;
	g_variant_unref (_tmp365_);
	_tmp369_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp370_ = g_new (guint, 5);
	_tmp370__length = 0;
	_tmp370__size = 4;
	_tmp370__length1 = 0;
	g_variant_iter_init (&_tmp371_, _tmp369_);
	for (; (_tmp372_ = g_variant_iter_next_value (&_tmp371_)) != NULL; _tmp370__length1++) {
		if (_tmp370__size == _tmp370__length) {
			_tmp370__size = 2 * _tmp370__size;
			_tmp370_ = g_renew (guint, _tmp370_, _tmp370__size + 1);
		}
		_tmp370_[_tmp370__length++] = g_variant_get_uint32 (_tmp372_);
		g_variant_unref (_tmp372_);
	}
	blue_length1 = _tmp370__length1;
	blue = _tmp370_;
	g_variant_unref (_tmp369_);
	mutter_display_config_interface_set_crtc_gamma (self, serial, crtc, red, red_length1, green, green_length1, blue, blue_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	red = (g_free (red), NULL);
	green = (g_free (green), NULL);
	blue = (g_free (blue), NULL);
	;
}

static void
_vala_MutterReadMonitor_array_free (MutterReadMonitor * array,
                                    gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_vala_MutterReadLogicalMonitor_array_free (MutterReadLogicalMonitor * array,
                                           gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_logical_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_mutter_display_config_interface_get_current_state (MutterDisplayConfigInterface* self,
                                                         GVariant* _parameters_,
                                                         GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	guint serial = 0U;
	MutterReadMonitor* monitors = NULL;
	gint monitors_length1 = 0;
	MutterReadMonitor* _tmp373_;
	GVariantBuilder _tmp374_;
	gint _tmp375_;
	MutterReadLogicalMonitor* logical_monitors = NULL;
	gint logical_monitors_length1 = 0;
	MutterReadLogicalMonitor* _tmp393_;
	GVariantBuilder _tmp394_;
	gint _tmp395_;
	GHashTable* properties = NULL;
	GVariantBuilder _tmp405_;
	GHashTableIter _tmp406_;
	gpointer _tmp407_;
	gpointer _tmp408_;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	mutter_display_config_interface_get_current_state (self, &serial, &monitors, &monitors_length1, &logical_monitors, &logical_monitors_length1, &properties, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_uint32 (serial));
	_tmp373_ = monitors;
	g_variant_builder_init (&_tmp374_, G_VARIANT_TYPE ("a((ssss)a(siiddada{sv})a{sv})"));
	for (_tmp375_ = 0; _tmp375_ < monitors_length1; _tmp375_++) {
		GVariantBuilder _tmp376_;
		GVariantBuilder _tmp377_;
		MutterReadMonitorMode* _tmp378_;
		GVariantBuilder _tmp379_;
		gint _tmp380_;
		GVariantBuilder _tmp389_;
		GHashTableIter _tmp390_;
		gpointer _tmp391_;
		gpointer _tmp392_;
		g_variant_builder_init (&_tmp376_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_init (&_tmp377_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp377_, g_variant_new_string ((*_tmp373_).monitor.connector));
		g_variant_builder_add_value (&_tmp377_, g_variant_new_string ((*_tmp373_).monitor.vendor));
		g_variant_builder_add_value (&_tmp377_, g_variant_new_string ((*_tmp373_).monitor.product));
		g_variant_builder_add_value (&_tmp377_, g_variant_new_string ((*_tmp373_).monitor.serial));
		g_variant_builder_add_value (&_tmp376_, g_variant_builder_end (&_tmp377_));
		_tmp378_ = (*_tmp373_).modes;
		g_variant_builder_init (&_tmp379_, G_VARIANT_TYPE ("a(siiddada{sv})"));
		for (_tmp380_ = 0; _tmp380_ < (*_tmp373_).modes_length1; _tmp380_++) {
			GVariantBuilder _tmp381_;
			gdouble* _tmp382_;
			GVariantBuilder _tmp383_;
			gint _tmp384_;
			GVariantBuilder _tmp385_;
			GHashTableIter _tmp386_;
			gpointer _tmp387_;
			gpointer _tmp388_;
			g_variant_builder_init (&_tmp381_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp381_, g_variant_new_string ((*_tmp378_).id));
			g_variant_builder_add_value (&_tmp381_, g_variant_new_int32 ((*_tmp378_).width));
			g_variant_builder_add_value (&_tmp381_, g_variant_new_int32 ((*_tmp378_).height));
			g_variant_builder_add_value (&_tmp381_, g_variant_new_double ((*_tmp378_).frequency));
			g_variant_builder_add_value (&_tmp381_, g_variant_new_double ((*_tmp378_).preferred_scale));
			_tmp382_ = (*_tmp378_).supported_scales;
			g_variant_builder_init (&_tmp383_, G_VARIANT_TYPE ("ad"));
			for (_tmp384_ = 0; _tmp384_ < (*_tmp378_).supported_scales_length1; _tmp384_++) {
				g_variant_builder_add_value (&_tmp383_, g_variant_new_double (*_tmp382_));
				_tmp382_++;
			}
			g_variant_builder_add_value (&_tmp381_, g_variant_builder_end (&_tmp383_));
			g_hash_table_iter_init (&_tmp386_, (*_tmp378_).properties);
			g_variant_builder_init (&_tmp385_, G_VARIANT_TYPE ("a{sv}"));
			while (g_hash_table_iter_next (&_tmp386_, &_tmp387_, &_tmp388_)) {
				gchar* _key;
				GVariant* _value;
				_key = (gchar*) _tmp387_;
				_value = (GVariant*) _tmp388_;
				g_variant_builder_add (&_tmp385_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
			}
			g_variant_builder_add_value (&_tmp381_, g_variant_builder_end (&_tmp385_));
			g_variant_builder_add_value (&_tmp379_, g_variant_builder_end (&_tmp381_));
			_tmp378_++;
		}
		g_variant_builder_add_value (&_tmp376_, g_variant_builder_end (&_tmp379_));
		g_hash_table_iter_init (&_tmp390_, (*_tmp373_).properties);
		g_variant_builder_init (&_tmp389_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp390_, &_tmp391_, &_tmp392_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp391_;
			_value = (GVariant*) _tmp392_;
			g_variant_builder_add (&_tmp389_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp376_, g_variant_builder_end (&_tmp389_));
		g_variant_builder_add_value (&_tmp374_, g_variant_builder_end (&_tmp376_));
		_tmp373_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp374_));
	_tmp393_ = logical_monitors;
	g_variant_builder_init (&_tmp394_, G_VARIANT_TYPE ("a(iiduba(ssss)a{sv})"));
	for (_tmp395_ = 0; _tmp395_ < logical_monitors_length1; _tmp395_++) {
		GVariantBuilder _tmp396_;
		MutterReadMonitorInfo* _tmp397_;
		GVariantBuilder _tmp398_;
		gint _tmp399_;
		GVariantBuilder _tmp401_;
		GHashTableIter _tmp402_;
		gpointer _tmp403_;
		gpointer _tmp404_;
		g_variant_builder_init (&_tmp396_, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_tmp396_, g_variant_new_int32 ((*_tmp393_).x));
		g_variant_builder_add_value (&_tmp396_, g_variant_new_int32 ((*_tmp393_).y));
		g_variant_builder_add_value (&_tmp396_, g_variant_new_double ((*_tmp393_).scale));
		g_variant_builder_add_value (&_tmp396_, g_variant_new_uint32 ((*_tmp393_).transform));
		g_variant_builder_add_value (&_tmp396_, g_variant_new_boolean ((*_tmp393_).primary));
		_tmp397_ = (*_tmp393_).monitors;
		g_variant_builder_init (&_tmp398_, G_VARIANT_TYPE ("a(ssss)"));
		for (_tmp399_ = 0; _tmp399_ < (*_tmp393_).monitors_length1; _tmp399_++) {
			GVariantBuilder _tmp400_;
			g_variant_builder_init (&_tmp400_, G_VARIANT_TYPE_TUPLE);
			g_variant_builder_add_value (&_tmp400_, g_variant_new_string ((*_tmp397_).connector));
			g_variant_builder_add_value (&_tmp400_, g_variant_new_string ((*_tmp397_).vendor));
			g_variant_builder_add_value (&_tmp400_, g_variant_new_string ((*_tmp397_).product));
			g_variant_builder_add_value (&_tmp400_, g_variant_new_string ((*_tmp397_).serial));
			g_variant_builder_add_value (&_tmp398_, g_variant_builder_end (&_tmp400_));
			_tmp397_++;
		}
		g_variant_builder_add_value (&_tmp396_, g_variant_builder_end (&_tmp398_));
		g_hash_table_iter_init (&_tmp402_, (*_tmp393_).properties);
		g_variant_builder_init (&_tmp401_, G_VARIANT_TYPE ("a{sv}"));
		while (g_hash_table_iter_next (&_tmp402_, &_tmp403_, &_tmp404_)) {
			gchar* _key;
			GVariant* _value;
			_key = (gchar*) _tmp403_;
			_value = (GVariant*) _tmp404_;
			g_variant_builder_add (&_tmp401_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
		}
		g_variant_builder_add_value (&_tmp396_, g_variant_builder_end (&_tmp401_));
		g_variant_builder_add_value (&_tmp394_, g_variant_builder_end (&_tmp396_));
		_tmp393_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp394_));
	g_hash_table_iter_init (&_tmp406_, properties);
	g_variant_builder_init (&_tmp405_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp406_, &_tmp407_, &_tmp408_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp407_;
		_value = (GVariant*) _tmp408_;
		g_variant_builder_add (&_tmp405_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp405_));
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	monitors = (_vala_MutterReadMonitor_array_free (monitors, monitors_length1), NULL);
	logical_monitors = (_vala_MutterReadLogicalMonitor_array_free (logical_monitors, logical_monitors_length1), NULL);
	_g_hash_table_unref0 (properties);
}

static void
_vala_MutterWriteLogicalMonitor_array_free (MutterWriteLogicalMonitor * array,
                                            gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_logical_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static void
_dbus_mutter_display_config_interface_apply_monitors_config (MutterDisplayConfigInterface* self,
                                                             GVariant* _parameters_,
                                                             GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	guint serial = 0U;
	GVariant* _tmp409_;
	MutterApplyMethod method = 0;
	GVariant* _tmp410_;
	MutterWriteLogicalMonitor* logical_monitors = NULL;
	gint logical_monitors_length1 = 0;
	GVariant* _tmp411_;
	MutterWriteLogicalMonitor* _tmp412_;
	gint _tmp412__length;
	gint _tmp412__size;
	gint _tmp412__length1;
	GVariantIter _tmp413_;
	GVariant* _tmp414_;
	GHashTable* properties = NULL;
	GVariant* _tmp435_;
	GHashTable* _tmp436_;
	GVariantIter _tmp437_;
	GVariant* _tmp438_;
	GVariant* _tmp439_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp409_ = g_variant_iter_next_value (&_arguments_iter);
	serial = g_variant_get_uint32 (_tmp409_);
	g_variant_unref (_tmp409_);
	_tmp410_ = g_variant_iter_next_value (&_arguments_iter);
	method = g_variant_get_uint32 (_tmp410_);
	g_variant_unref (_tmp410_);
	_tmp411_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp412_ = g_new (MutterWriteLogicalMonitor, 5);
	_tmp412__length = 0;
	_tmp412__size = 4;
	_tmp412__length1 = 0;
	g_variant_iter_init (&_tmp413_, _tmp411_);
	for (; (_tmp414_ = g_variant_iter_next_value (&_tmp413_)) != NULL; _tmp412__length1++) {
		MutterWriteLogicalMonitor _tmp415_;
		GVariantIter _tmp416_;
		GVariant* _tmp417_;
		GVariant* _tmp418_;
		GVariant* _tmp419_;
		GVariant* _tmp420_;
		GVariant* _tmp421_;
		GVariant* _tmp422_;
		MutterWriteMonitor* _tmp423_;
		gint _tmp423__length;
		gint _tmp423__size;
		gint _tmp423__length1;
		GVariantIter _tmp424_;
		GVariant* _tmp425_;
		if (_tmp412__size == _tmp412__length) {
			_tmp412__size = 2 * _tmp412__size;
			_tmp412_ = g_renew (MutterWriteLogicalMonitor, _tmp412_, _tmp412__size + 1);
		}
		g_variant_iter_init (&_tmp416_, _tmp414_);
		_tmp417_ = g_variant_iter_next_value (&_tmp416_);
		_tmp415_.x = g_variant_get_int32 (_tmp417_);
		g_variant_unref (_tmp417_);
		_tmp418_ = g_variant_iter_next_value (&_tmp416_);
		_tmp415_.y = g_variant_get_int32 (_tmp418_);
		g_variant_unref (_tmp418_);
		_tmp419_ = g_variant_iter_next_value (&_tmp416_);
		_tmp415_.scale = g_variant_get_double (_tmp419_);
		g_variant_unref (_tmp419_);
		_tmp420_ = g_variant_iter_next_value (&_tmp416_);
		_tmp415_.transform = g_variant_get_uint32 (_tmp420_);
		g_variant_unref (_tmp420_);
		_tmp421_ = g_variant_iter_next_value (&_tmp416_);
		_tmp415_.primary = g_variant_get_boolean (_tmp421_);
		g_variant_unref (_tmp421_);
		_tmp422_ = g_variant_iter_next_value (&_tmp416_);
		_tmp423_ = g_new (MutterWriteMonitor, 5);
		_tmp423__length = 0;
		_tmp423__size = 4;
		_tmp423__length1 = 0;
		g_variant_iter_init (&_tmp424_, _tmp422_);
		for (; (_tmp425_ = g_variant_iter_next_value (&_tmp424_)) != NULL; _tmp423__length1++) {
			MutterWriteMonitor _tmp426_;
			GVariantIter _tmp427_;
			GVariant* _tmp428_;
			GVariant* _tmp429_;
			GVariant* _tmp430_;
			GHashTable* _tmp431_;
			GVariantIter _tmp432_;
			GVariant* _tmp433_;
			GVariant* _tmp434_;
			if (_tmp423__size == _tmp423__length) {
				_tmp423__size = 2 * _tmp423__size;
				_tmp423_ = g_renew (MutterWriteMonitor, _tmp423_, _tmp423__size + 1);
			}
			g_variant_iter_init (&_tmp427_, _tmp425_);
			_tmp428_ = g_variant_iter_next_value (&_tmp427_);
			_tmp426_.connector = g_variant_dup_string (_tmp428_, NULL);
			g_variant_unref (_tmp428_);
			_tmp429_ = g_variant_iter_next_value (&_tmp427_);
			_tmp426_.monitor_mode = g_variant_dup_string (_tmp429_, NULL);
			g_variant_unref (_tmp429_);
			_tmp430_ = g_variant_iter_next_value (&_tmp427_);
			_tmp431_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
			g_variant_iter_init (&_tmp432_, _tmp430_);
			while (g_variant_iter_loop (&_tmp432_, "{?*}", &_tmp433_, &_tmp434_)) {
				g_hash_table_insert (_tmp431_, g_variant_dup_string (_tmp433_, NULL), g_variant_get_variant (_tmp434_));
			}
			_tmp426_.properties = _tmp431_;
			g_variant_unref (_tmp430_);
			_tmp423_[_tmp423__length++] = _tmp426_;
			g_variant_unref (_tmp425_);
		}
		_tmp415_.monitors_length1 = _tmp423__length1;
		_tmp415_.monitors = _tmp423_;
		g_variant_unref (_tmp422_);
		_tmp412_[_tmp412__length++] = _tmp415_;
		g_variant_unref (_tmp414_);
	}
	logical_monitors_length1 = _tmp412__length1;
	logical_monitors = _tmp412_;
	g_variant_unref (_tmp411_);
	_tmp435_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp436_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp437_, _tmp435_);
	while (g_variant_iter_loop (&_tmp437_, "{?*}", &_tmp438_, &_tmp439_)) {
		g_hash_table_insert (_tmp436_, g_variant_dup_string (_tmp438_, NULL), g_variant_get_variant (_tmp439_));
	}
	properties = _tmp436_;
	g_variant_unref (_tmp435_);
	mutter_display_config_interface_apply_monitors_config (self, serial, method, logical_monitors, logical_monitors_length1, properties, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	logical_monitors = (_vala_MutterWriteLogicalMonitor_array_free (logical_monitors, logical_monitors_length1), NULL);
	_g_hash_table_unref0 (properties);
	;
}

static void
mutter_display_config_interface_dbus_interface_method_call (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* method_name,
                                                            GVariant* parameters,
                                                            GDBusMethodInvocation* invocation,
                                                            gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetResources") == 0) {
		_dbus_mutter_display_config_interface_get_resources (object, parameters, invocation);
	} else if (strcmp (method_name, "ApplyConfiguration") == 0) {
		_dbus_mutter_display_config_interface_apply_configuration (object, parameters, invocation);
	} else if (strcmp (method_name, "ChangeBacklight") == 0) {
		_dbus_mutter_display_config_interface_change_backlight (object, parameters, invocation);
	} else if (strcmp (method_name, "GetCrtcGamma") == 0) {
		_dbus_mutter_display_config_interface_get_crtc_gamma (object, parameters, invocation);
	} else if (strcmp (method_name, "SetCrtcGamma") == 0) {
		_dbus_mutter_display_config_interface_set_crtc_gamma (object, parameters, invocation);
	} else if (strcmp (method_name, "GetCurrentState") == 0) {
		_dbus_mutter_display_config_interface_get_current_state (object, parameters, invocation);
	} else if (strcmp (method_name, "ApplyMonitorsConfig") == 0) {
		_dbus_mutter_display_config_interface_apply_monitors_config (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_mutter_display_config_interface_get_power_save_mode (MutterDisplayConfigInterface* self)
{
	gint result;
	GVariant* _reply;
	result = mutter_display_config_interface_get_power_save_mode (self);
	_reply = g_variant_new_int32 (result);
	return _reply;
}

static GVariant*
mutter_display_config_interface_dbus_interface_get_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GError** error,
                                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PowerSaveMode") == 0) {
		return _dbus_mutter_display_config_interface_get_power_save_mode (object);
	}
	return NULL;
}

static void
_dbus_mutter_display_config_interface_set_power_save_mode (MutterDisplayConfigInterface* self,
                                                           GVariant* _value)
{
	gint value = 0;
	value = g_variant_get_int32 (_value);
	mutter_display_config_interface_set_power_save_mode (self, value);
}

static gboolean
mutter_display_config_interface_dbus_interface_set_property (GDBusConnection* connection,
                                                             const gchar* sender,
                                                             const gchar* object_path,
                                                             const gchar* interface_name,
                                                             const gchar* property_name,
                                                             GVariant* value,
                                                             GError** error,
                                                             gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "PowerSaveMode") == 0) {
		_dbus_mutter_display_config_interface_set_power_save_mode (object, value);
		return TRUE;
	}
	return FALSE;
}

static void
_dbus_mutter_display_config_interface_monitors_changed (GObject* _sender,
                                                        gpointer* _data)
{
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "org.gnome.Mutter.DisplayConfig", "MonitorsChanged", _arguments, NULL);
}

guint
mutter_display_config_interface_register_object (gpointer object,
                                                 GDBusConnection* connection,
                                                 const gchar* path,
                                                 GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_mutter_display_config_interface_dbus_interface_info), &_mutter_display_config_interface_dbus_interface_vtable, data, _mutter_display_config_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "monitors-changed", (GCallback) _dbus_mutter_display_config_interface_monitors_changed, data);
	return result;
}

static void
_mutter_display_config_interface_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_signal_handlers_disconnect_by_func (data[0], _dbus_mutter_display_config_interface_monitors_changed, data);
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static GType
mutter_apply_method_get_type_once (void)
{
	static const GEnumValue values[] = {{MUTTER_APPLY_METHOD_VERIFY, "MUTTER_APPLY_METHOD_VERIFY", "verify"}, {MUTTER_APPLY_METHOD_TEMPORARY, "MUTTER_APPLY_METHOD_TEMPORARY", "temporary"}, {MUTTER_APPLY_METHOD_PERSISTENT, "MUTTER_APPLY_METHOD_PERSISTENT", "persistent"}, {0, NULL, NULL}};
	GType mutter_apply_method_type_id;
	mutter_apply_method_type_id = g_enum_register_static ("MutterApplyMethod", values);
	return mutter_apply_method_type_id;
}

GType
mutter_apply_method_get_type (void)
{
	static volatile gsize mutter_apply_method_type_id__once = 0;
	if (g_once_init_enter (&mutter_apply_method_type_id__once)) {
		GType mutter_apply_method_type_id;
		mutter_apply_method_type_id = mutter_apply_method_get_type_once ();
		g_once_init_leave (&mutter_apply_method_type_id__once, mutter_apply_method_type_id);
	}
	return mutter_apply_method_type_id__once;
}

gchar*
display_transform_to_string (DisplayTransform self)
{
	gchar* result;
	switch (self) {
		case DISPLAY_TRANSFORM_ROTATION_90:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Clockwise"));
			result = _tmp0_;
			return result;
		}
		case DISPLAY_TRANSFORM_ROTATION_180:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Upside-down"));
			result = _tmp1_;
			return result;
		}
		case DISPLAY_TRANSFORM_ROTATION_270:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Counterclockwise"));
			result = _tmp2_;
			return result;
		}
		case DISPLAY_TRANSFORM_FLIPPED:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Flipped"));
			result = _tmp3_;
			return result;
		}
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_90:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Flipped Clockwise"));
			result = _tmp4_;
			return result;
		}
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_180:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Flipped Upside-down"));
			result = _tmp5_;
			return result;
		}
		case DISPLAY_TRANSFORM_FLIPPED_ROTATION_270:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Flipped Counterclockwise"));
			result = _tmp6_;
			return result;
		}
		default:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup (_ ("None"));
			result = _tmp7_;
			return result;
		}
	}
}

static GType
display_transform_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_TRANSFORM_NORMAL, "DISPLAY_TRANSFORM_NORMAL", "normal"}, {DISPLAY_TRANSFORM_ROTATION_90, "DISPLAY_TRANSFORM_ROTATION_90", "rotation-90"}, {DISPLAY_TRANSFORM_ROTATION_180, "DISPLAY_TRANSFORM_ROTATION_180", "rotation-180"}, {DISPLAY_TRANSFORM_ROTATION_270, "DISPLAY_TRANSFORM_ROTATION_270", "rotation-270"}, {DISPLAY_TRANSFORM_FLIPPED, "DISPLAY_TRANSFORM_FLIPPED", "flipped"}, {DISPLAY_TRANSFORM_FLIPPED_ROTATION_90, "DISPLAY_TRANSFORM_FLIPPED_ROTATION_90", "flipped-rotation-90"}, {DISPLAY_TRANSFORM_FLIPPED_ROTATION_180, "DISPLAY_TRANSFORM_FLIPPED_ROTATION_180", "flipped-rotation-180"}, {DISPLAY_TRANSFORM_FLIPPED_ROTATION_270, "DISPLAY_TRANSFORM_FLIPPED_ROTATION_270", "flipped-rotation-270"}, {0, NULL, NULL}};
	GType display_transform_type_id;
	display_transform_type_id = g_enum_register_static ("DisplayTransform", values);
	return display_transform_type_id;
}

GType
display_transform_get_type (void)
{
	static volatile gsize display_transform_type_id__once = 0;
	if (g_once_init_enter (&display_transform_type_id__once)) {
		GType display_transform_type_id;
		display_transform_type_id = display_transform_get_type_once ();
		g_once_init_leave (&display_transform_type_id__once, display_transform_type_id);
	}
	return display_transform_type_id__once;
}

guint
mutter_read_monitor_info_get_hash (MutterReadMonitorInfo* self)
{
	guint result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	guint _tmp10_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = (*self).connector;
	_tmp1_ = (*self).vendor;
	_tmp2_ = g_strconcat (_tmp0_, _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = (*self).product;
	_tmp5_ = g_strconcat (_tmp3_, _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	_tmp7_ = (*self).serial;
	_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_str_hash (_tmp9_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp3_);
	result = _tmp10_;
	return result;
}

void
mutter_read_monitor_info_copy (const MutterReadMonitorInfo* self,
                               MutterReadMonitorInfo* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	_tmp0_ = (*self).connector;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).connector);
	(*dest).connector = _tmp1_;
	_tmp2_ = (*self).vendor;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).vendor);
	(*dest).vendor = _tmp3_;
	_tmp4_ = (*self).product;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 ((*dest).product);
	(*dest).product = _tmp5_;
	_tmp6_ = (*self).serial;
	_tmp7_ = g_strdup (_tmp6_);
	_g_free0 ((*dest).serial);
	(*dest).serial = _tmp7_;
}

void
mutter_read_monitor_info_destroy (MutterReadMonitorInfo* self)
{
	_g_free0 ((*self).connector);
	_g_free0 ((*self).vendor);
	_g_free0 ((*self).product);
	_g_free0 ((*self).serial);
}

MutterReadMonitorInfo*
mutter_read_monitor_info_dup (const MutterReadMonitorInfo* self)
{
	MutterReadMonitorInfo* dup;
	dup = g_new0 (MutterReadMonitorInfo, 1);
	mutter_read_monitor_info_copy (self, dup);
	return dup;
}

void
mutter_read_monitor_info_free (MutterReadMonitorInfo* self)
{
	mutter_read_monitor_info_destroy (self);
	g_free (self);
}

static GType
mutter_read_monitor_info_get_type_once (void)
{
	GType mutter_read_monitor_info_type_id;
	mutter_read_monitor_info_type_id = g_boxed_type_register_static ("MutterReadMonitorInfo", (GBoxedCopyFunc) mutter_read_monitor_info_dup, (GBoxedFreeFunc) mutter_read_monitor_info_free);
	return mutter_read_monitor_info_type_id;
}

GType
mutter_read_monitor_info_get_type (void)
{
	static volatile gsize mutter_read_monitor_info_type_id__once = 0;
	if (g_once_init_enter (&mutter_read_monitor_info_type_id__once)) {
		GType mutter_read_monitor_info_type_id;
		mutter_read_monitor_info_type_id = mutter_read_monitor_info_get_type_once ();
		g_once_init_leave (&mutter_read_monitor_info_type_id__once, mutter_read_monitor_info_type_id);
	}
	return mutter_read_monitor_info_type_id__once;
}

static gdouble*
_vala_array_dup1 (gdouble* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (gdouble));
	}
	return NULL;
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
	return self ? g_hash_table_ref (self) : NULL;
}

void
mutter_read_monitor_mode_copy (const MutterReadMonitorMode* self,
                               MutterReadMonitorMode* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gdouble* _tmp2_;
	gint _tmp2__length1;
	gdouble* _tmp3_;
	gint _tmp3__length1;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	_tmp0_ = (*self).id;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).id);
	(*dest).id = _tmp1_;
	(*dest).width = (*self).width;
	(*dest).height = (*self).height;
	(*dest).frequency = (*self).frequency;
	(*dest).preferred_scale = (*self).preferred_scale;
	_tmp2_ = (*self).supported_scales;
	_tmp2__length1 = (*self).supported_scales_length1;
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup1 (_tmp2_, _tmp2__length1) : _tmp2_;
	_tmp3__length1 = _tmp2__length1;
	(*dest).supported_scales = (g_free ((*dest).supported_scales), NULL);
	(*dest).supported_scales = _tmp3_;
	(*dest).supported_scales_length1 = _tmp3__length1;
	_tmp4_ = (*self).properties;
	_tmp5_ = _g_hash_table_ref0 (_tmp4_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp5_;
}

void
mutter_read_monitor_mode_destroy (MutterReadMonitorMode* self)
{
	_g_free0 ((*self).id);
	(*self).supported_scales = (g_free ((*self).supported_scales), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadMonitorMode*
mutter_read_monitor_mode_dup (const MutterReadMonitorMode* self)
{
	MutterReadMonitorMode* dup;
	dup = g_new0 (MutterReadMonitorMode, 1);
	mutter_read_monitor_mode_copy (self, dup);
	return dup;
}

void
mutter_read_monitor_mode_free (MutterReadMonitorMode* self)
{
	mutter_read_monitor_mode_destroy (self);
	g_free (self);
}

static GType
mutter_read_monitor_mode_get_type_once (void)
{
	GType mutter_read_monitor_mode_type_id;
	mutter_read_monitor_mode_type_id = g_boxed_type_register_static ("MutterReadMonitorMode", (GBoxedCopyFunc) mutter_read_monitor_mode_dup, (GBoxedFreeFunc) mutter_read_monitor_mode_free);
	return mutter_read_monitor_mode_type_id;
}

GType
mutter_read_monitor_mode_get_type (void)
{
	static volatile gsize mutter_read_monitor_mode_type_id__once = 0;
	if (g_once_init_enter (&mutter_read_monitor_mode_type_id__once)) {
		GType mutter_read_monitor_mode_type_id;
		mutter_read_monitor_mode_type_id = mutter_read_monitor_mode_get_type_once ();
		g_once_init_leave (&mutter_read_monitor_mode_type_id__once, mutter_read_monitor_mode_type_id);
	}
	return mutter_read_monitor_mode_type_id__once;
}

static void
_vala_MutterReadMonitorMode_array_free (MutterReadMonitorMode * array,
                                        gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_monitor_mode_destroy (&array[i]);
		}
	}
	g_free (array);
}

static MutterReadMonitorMode*
_vala_array_dup2 (MutterReadMonitorMode* self,
                  gssize length)
{
	if (length > 0) {
		MutterReadMonitorMode* result;
		gssize i;
		result = g_new0 (MutterReadMonitorMode, length);
		for (i = 0; i < length; i++) {
			MutterReadMonitorMode _tmp0_;
			MutterReadMonitorMode _tmp1_ = {0};
			_tmp0_ = self[i];
			mutter_read_monitor_mode_copy (&_tmp0_, &_tmp1_);
			result[i] = _tmp1_;
		}
		return result;
	}
	return NULL;
}

void
mutter_read_monitor_copy (const MutterReadMonitor* self,
                          MutterReadMonitor* dest)
{
	MutterReadMonitorInfo _tmp0_;
	MutterReadMonitorInfo _tmp1_;
	MutterReadMonitorInfo _tmp2_ = {0};
	MutterReadMonitorMode* _tmp3_;
	gint _tmp3__length1;
	MutterReadMonitorMode* _tmp4_;
	gint _tmp4__length1;
	GHashTable* _tmp5_;
	GHashTable* _tmp6_;
	_tmp0_ = (*self).monitor;
	_tmp1_ = _tmp0_;
	mutter_read_monitor_info_copy (&_tmp1_, &_tmp2_);
	mutter_read_monitor_info_destroy (&(*dest).monitor);
	(*dest).monitor = _tmp2_;
	_tmp3_ = (*self).modes;
	_tmp3__length1 = (*self).modes_length1;
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup2 (_tmp3_, _tmp3__length1) : _tmp3_;
	_tmp4__length1 = _tmp3__length1;
	(*dest).modes = (_vala_MutterReadMonitorMode_array_free ((*dest).modes, (*dest).modes_length1), NULL);
	(*dest).modes = _tmp4_;
	(*dest).modes_length1 = _tmp4__length1;
	_tmp5_ = (*self).properties;
	_tmp6_ = _g_hash_table_ref0 (_tmp5_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp6_;
}

void
mutter_read_monitor_destroy (MutterReadMonitor* self)
{
	mutter_read_monitor_info_destroy (&(*self).monitor);
	(*self).modes = (_vala_MutterReadMonitorMode_array_free ((*self).modes, (*self).modes_length1), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadMonitor*
mutter_read_monitor_dup (const MutterReadMonitor* self)
{
	MutterReadMonitor* dup;
	dup = g_new0 (MutterReadMonitor, 1);
	mutter_read_monitor_copy (self, dup);
	return dup;
}

void
mutter_read_monitor_free (MutterReadMonitor* self)
{
	mutter_read_monitor_destroy (self);
	g_free (self);
}

static GType
mutter_read_monitor_get_type_once (void)
{
	GType mutter_read_monitor_type_id;
	mutter_read_monitor_type_id = g_boxed_type_register_static ("MutterReadMonitor", (GBoxedCopyFunc) mutter_read_monitor_dup, (GBoxedFreeFunc) mutter_read_monitor_free);
	return mutter_read_monitor_type_id;
}

GType
mutter_read_monitor_get_type (void)
{
	static volatile gsize mutter_read_monitor_type_id__once = 0;
	if (g_once_init_enter (&mutter_read_monitor_type_id__once)) {
		GType mutter_read_monitor_type_id;
		mutter_read_monitor_type_id = mutter_read_monitor_get_type_once ();
		g_once_init_leave (&mutter_read_monitor_type_id__once, mutter_read_monitor_type_id);
	}
	return mutter_read_monitor_type_id__once;
}

static void
_vala_MutterReadMonitorInfo_array_free (MutterReadMonitorInfo * array,
                                        gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_read_monitor_info_destroy (&array[i]);
		}
	}
	g_free (array);
}

static MutterReadMonitorInfo*
_vala_array_dup3 (MutterReadMonitorInfo* self,
                  gssize length)
{
	if (length > 0) {
		MutterReadMonitorInfo* result;
		gssize i;
		result = g_new0 (MutterReadMonitorInfo, length);
		for (i = 0; i < length; i++) {
			MutterReadMonitorInfo _tmp0_;
			MutterReadMonitorInfo _tmp1_ = {0};
			_tmp0_ = self[i];
			mutter_read_monitor_info_copy (&_tmp0_, &_tmp1_);
			result[i] = _tmp1_;
		}
		return result;
	}
	return NULL;
}

void
mutter_read_logical_monitor_copy (const MutterReadLogicalMonitor* self,
                                  MutterReadLogicalMonitor* dest)
{
	MutterReadMonitorInfo* _tmp0_;
	gint _tmp0__length1;
	MutterReadMonitorInfo* _tmp1_;
	gint _tmp1__length1;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	(*dest).x = (*self).x;
	(*dest).y = (*self).y;
	(*dest).scale = (*self).scale;
	(*dest).transform = (*self).transform;
	(*dest).primary = (*self).primary;
	_tmp0_ = (*self).monitors;
	_tmp0__length1 = (*self).monitors_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup3 (_tmp0_, _tmp0__length1) : _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	(*dest).monitors = (_vala_MutterReadMonitorInfo_array_free ((*dest).monitors, (*dest).monitors_length1), NULL);
	(*dest).monitors = _tmp1_;
	(*dest).monitors_length1 = _tmp1__length1;
	_tmp2_ = (*self).properties;
	_tmp3_ = _g_hash_table_ref0 (_tmp2_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp3_;
}

void
mutter_read_logical_monitor_destroy (MutterReadLogicalMonitor* self)
{
	(*self).monitors = (_vala_MutterReadMonitorInfo_array_free ((*self).monitors, (*self).monitors_length1), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadLogicalMonitor*
mutter_read_logical_monitor_dup (const MutterReadLogicalMonitor* self)
{
	MutterReadLogicalMonitor* dup;
	dup = g_new0 (MutterReadLogicalMonitor, 1);
	mutter_read_logical_monitor_copy (self, dup);
	return dup;
}

void
mutter_read_logical_monitor_free (MutterReadLogicalMonitor* self)
{
	mutter_read_logical_monitor_destroy (self);
	g_free (self);
}

static GType
mutter_read_logical_monitor_get_type_once (void)
{
	GType mutter_read_logical_monitor_type_id;
	mutter_read_logical_monitor_type_id = g_boxed_type_register_static ("MutterReadLogicalMonitor", (GBoxedCopyFunc) mutter_read_logical_monitor_dup, (GBoxedFreeFunc) mutter_read_logical_monitor_free);
	return mutter_read_logical_monitor_type_id;
}

GType
mutter_read_logical_monitor_get_type (void)
{
	static volatile gsize mutter_read_logical_monitor_type_id__once = 0;
	if (g_once_init_enter (&mutter_read_logical_monitor_type_id__once)) {
		GType mutter_read_logical_monitor_type_id;
		mutter_read_logical_monitor_type_id = mutter_read_logical_monitor_get_type_once ();
		g_once_init_leave (&mutter_read_logical_monitor_type_id__once, mutter_read_logical_monitor_type_id);
	}
	return mutter_read_logical_monitor_type_id__once;
}

void
mutter_write_monitor_copy (const MutterWriteMonitor* self,
                           MutterWriteMonitor* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	GHashTable* _tmp5_;
	_tmp0_ = (*self).connector;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).connector);
	(*dest).connector = _tmp1_;
	_tmp2_ = (*self).monitor_mode;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).monitor_mode);
	(*dest).monitor_mode = _tmp3_;
	_tmp4_ = (*self).properties;
	_tmp5_ = _g_hash_table_ref0 (_tmp4_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp5_;
}

void
mutter_write_monitor_destroy (MutterWriteMonitor* self)
{
	_g_free0 ((*self).connector);
	_g_free0 ((*self).monitor_mode);
	_g_hash_table_unref0 ((*self).properties);
}

MutterWriteMonitor*
mutter_write_monitor_dup (const MutterWriteMonitor* self)
{
	MutterWriteMonitor* dup;
	dup = g_new0 (MutterWriteMonitor, 1);
	mutter_write_monitor_copy (self, dup);
	return dup;
}

void
mutter_write_monitor_free (MutterWriteMonitor* self)
{
	mutter_write_monitor_destroy (self);
	g_free (self);
}

static GType
mutter_write_monitor_get_type_once (void)
{
	GType mutter_write_monitor_type_id;
	mutter_write_monitor_type_id = g_boxed_type_register_static ("MutterWriteMonitor", (GBoxedCopyFunc) mutter_write_monitor_dup, (GBoxedFreeFunc) mutter_write_monitor_free);
	return mutter_write_monitor_type_id;
}

GType
mutter_write_monitor_get_type (void)
{
	static volatile gsize mutter_write_monitor_type_id__once = 0;
	if (g_once_init_enter (&mutter_write_monitor_type_id__once)) {
		GType mutter_write_monitor_type_id;
		mutter_write_monitor_type_id = mutter_write_monitor_get_type_once ();
		g_once_init_leave (&mutter_write_monitor_type_id__once, mutter_write_monitor_type_id);
	}
	return mutter_write_monitor_type_id__once;
}

static void
_vala_MutterWriteMonitor_array_free (MutterWriteMonitor * array,
                                     gssize array_length)
{
	if (array != NULL) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			mutter_write_monitor_destroy (&array[i]);
		}
	}
	g_free (array);
}

static MutterWriteMonitor*
_vala_array_dup4 (MutterWriteMonitor* self,
                  gssize length)
{
	if (length > 0) {
		MutterWriteMonitor* result;
		gssize i;
		result = g_new0 (MutterWriteMonitor, length);
		for (i = 0; i < length; i++) {
			MutterWriteMonitor _tmp0_;
			MutterWriteMonitor _tmp1_ = {0};
			_tmp0_ = self[i];
			mutter_write_monitor_copy (&_tmp0_, &_tmp1_);
			result[i] = _tmp1_;
		}
		return result;
	}
	return NULL;
}

void
mutter_write_logical_monitor_copy (const MutterWriteLogicalMonitor* self,
                                   MutterWriteLogicalMonitor* dest)
{
	MutterWriteMonitor* _tmp0_;
	gint _tmp0__length1;
	MutterWriteMonitor* _tmp1_;
	gint _tmp1__length1;
	(*dest).x = (*self).x;
	(*dest).y = (*self).y;
	(*dest).scale = (*self).scale;
	(*dest).transform = (*self).transform;
	(*dest).primary = (*self).primary;
	_tmp0_ = (*self).monitors;
	_tmp0__length1 = (*self).monitors_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup4 (_tmp0_, _tmp0__length1) : _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	(*dest).monitors = (_vala_MutterWriteMonitor_array_free ((*dest).monitors, (*dest).monitors_length1), NULL);
	(*dest).monitors = _tmp1_;
	(*dest).monitors_length1 = _tmp1__length1;
}

void
mutter_write_logical_monitor_destroy (MutterWriteLogicalMonitor* self)
{
	(*self).monitors = (_vala_MutterWriteMonitor_array_free ((*self).monitors, (*self).monitors_length1), NULL);
}

MutterWriteLogicalMonitor*
mutter_write_logical_monitor_dup (const MutterWriteLogicalMonitor* self)
{
	MutterWriteLogicalMonitor* dup;
	dup = g_new0 (MutterWriteLogicalMonitor, 1);
	mutter_write_logical_monitor_copy (self, dup);
	return dup;
}

void
mutter_write_logical_monitor_free (MutterWriteLogicalMonitor* self)
{
	mutter_write_logical_monitor_destroy (self);
	g_free (self);
}

static GType
mutter_write_logical_monitor_get_type_once (void)
{
	GType mutter_write_logical_monitor_type_id;
	mutter_write_logical_monitor_type_id = g_boxed_type_register_static ("MutterWriteLogicalMonitor", (GBoxedCopyFunc) mutter_write_logical_monitor_dup, (GBoxedFreeFunc) mutter_write_logical_monitor_free);
	return mutter_write_logical_monitor_type_id;
}

GType
mutter_write_logical_monitor_get_type (void)
{
	static volatile gsize mutter_write_logical_monitor_type_id__once = 0;
	if (g_once_init_enter (&mutter_write_logical_monitor_type_id__once)) {
		GType mutter_write_logical_monitor_type_id;
		mutter_write_logical_monitor_type_id = mutter_write_logical_monitor_get_type_once ();
		g_once_init_leave (&mutter_write_logical_monitor_type_id__once, mutter_write_logical_monitor_type_id);
	}
	return mutter_write_logical_monitor_type_id__once;
}

static DisplayTransform*
_vala_array_dup5 (DisplayTransform* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (DisplayTransform));
	}
	return NULL;
}

void
mutter_read_display_crtc_copy (const MutterReadDisplayCrtc* self,
                               MutterReadDisplayCrtc* dest)
{
	DisplayTransform* _tmp0_;
	gint _tmp0__length1;
	DisplayTransform* _tmp1_;
	gint _tmp1__length1;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	(*dest).id = (*self).id;
	(*dest).winsys_id = (*self).winsys_id;
	(*dest).x = (*self).x;
	(*dest).y = (*self).y;
	(*dest).width = (*self).width;
	(*dest).height = (*self).height;
	(*dest).current_mode = (*self).current_mode;
	(*dest).current_transform = (*self).current_transform;
	_tmp0_ = (*self).transforms;
	_tmp0__length1 = (*self).transforms_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup5 (_tmp0_, _tmp0__length1) : _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	(*dest).transforms = (g_free ((*dest).transforms), NULL);
	(*dest).transforms = _tmp1_;
	(*dest).transforms_length1 = _tmp1__length1;
	_tmp2_ = (*self).properties;
	_tmp3_ = _g_hash_table_ref0 (_tmp2_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp3_;
}

void
mutter_read_display_crtc_destroy (MutterReadDisplayCrtc* self)
{
	(*self).transforms = (g_free ((*self).transforms), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadDisplayCrtc*
mutter_read_display_crtc_dup (const MutterReadDisplayCrtc* self)
{
	MutterReadDisplayCrtc* dup;
	dup = g_new0 (MutterReadDisplayCrtc, 1);
	mutter_read_display_crtc_copy (self, dup);
	return dup;
}

void
mutter_read_display_crtc_free (MutterReadDisplayCrtc* self)
{
	mutter_read_display_crtc_destroy (self);
	g_free (self);
}

static GType
mutter_read_display_crtc_get_type_once (void)
{
	GType mutter_read_display_crtc_type_id;
	mutter_read_display_crtc_type_id = g_boxed_type_register_static ("MutterReadDisplayCrtc", (GBoxedCopyFunc) mutter_read_display_crtc_dup, (GBoxedFreeFunc) mutter_read_display_crtc_free);
	return mutter_read_display_crtc_type_id;
}

GType
mutter_read_display_crtc_get_type (void)
{
	static volatile gsize mutter_read_display_crtc_type_id__once = 0;
	if (g_once_init_enter (&mutter_read_display_crtc_type_id__once)) {
		GType mutter_read_display_crtc_type_id;
		mutter_read_display_crtc_type_id = mutter_read_display_crtc_get_type_once ();
		g_once_init_leave (&mutter_read_display_crtc_type_id__once, mutter_read_display_crtc_type_id);
	}
	return mutter_read_display_crtc_type_id__once;
}

static guint*
_vala_array_dup6 (guint* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (guint));
	}
	return NULL;
}

void
mutter_write_display_crtc_copy (const MutterWriteDisplayCrtc* self,
                                MutterWriteDisplayCrtc* dest)
{
	guint* _tmp0_;
	gint _tmp0__length1;
	guint* _tmp1_;
	gint _tmp1__length1;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	(*dest).id = (*self).id;
	(*dest).new_mode = (*self).new_mode;
	(*dest).x = (*self).x;
	(*dest).y = (*self).y;
	(*dest).transform = (*self).transform;
	_tmp0_ = (*self).outputs;
	_tmp0__length1 = (*self).outputs_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup6 (_tmp0_, _tmp0__length1) : _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	(*dest).outputs = (g_free ((*dest).outputs), NULL);
	(*dest).outputs = _tmp1_;
	(*dest).outputs_length1 = _tmp1__length1;
	_tmp2_ = (*self).properties;
	_tmp3_ = _g_hash_table_ref0 (_tmp2_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp3_;
}

void
mutter_write_display_crtc_destroy (MutterWriteDisplayCrtc* self)
{
	(*self).outputs = (g_free ((*self).outputs), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterWriteDisplayCrtc*
mutter_write_display_crtc_dup (const MutterWriteDisplayCrtc* self)
{
	MutterWriteDisplayCrtc* dup;
	dup = g_new0 (MutterWriteDisplayCrtc, 1);
	mutter_write_display_crtc_copy (self, dup);
	return dup;
}

void
mutter_write_display_crtc_free (MutterWriteDisplayCrtc* self)
{
	mutter_write_display_crtc_destroy (self);
	g_free (self);
}

static GType
mutter_write_display_crtc_get_type_once (void)
{
	GType mutter_write_display_crtc_type_id;
	mutter_write_display_crtc_type_id = g_boxed_type_register_static ("MutterWriteDisplayCrtc", (GBoxedCopyFunc) mutter_write_display_crtc_dup, (GBoxedFreeFunc) mutter_write_display_crtc_free);
	return mutter_write_display_crtc_type_id;
}

GType
mutter_write_display_crtc_get_type (void)
{
	static volatile gsize mutter_write_display_crtc_type_id__once = 0;
	if (g_once_init_enter (&mutter_write_display_crtc_type_id__once)) {
		GType mutter_write_display_crtc_type_id;
		mutter_write_display_crtc_type_id = mutter_write_display_crtc_get_type_once ();
		g_once_init_leave (&mutter_write_display_crtc_type_id__once, mutter_write_display_crtc_type_id);
	}
	return mutter_write_display_crtc_type_id__once;
}

static guint*
_vala_array_dup7 (guint* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (guint));
	}
	return NULL;
}

static guint*
_vala_array_dup8 (guint* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (guint));
	}
	return NULL;
}

static guint*
_vala_array_dup9 (guint* self,
                  gssize length)
{
	if (length > 0) {
		return _vala_memdup2 (self, length * sizeof (guint));
	}
	return NULL;
}

void
mutter_read_display_output_copy (const MutterReadDisplayOutput* self,
                                 MutterReadDisplayOutput* dest)
{
	guint* _tmp0_;
	gint _tmp0__length1;
	guint* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	guint* _tmp4_;
	gint _tmp4__length1;
	guint* _tmp5_;
	gint _tmp5__length1;
	guint* _tmp6_;
	gint _tmp6__length1;
	guint* _tmp7_;
	gint _tmp7__length1;
	GHashTable* _tmp8_;
	GHashTable* _tmp9_;
	(*dest).id = (*self).id;
	(*dest).winsys_id = (*self).winsys_id;
	(*dest).current_crtc = (*self).current_crtc;
	_tmp0_ = (*self).possible_crtcs;
	_tmp0__length1 = (*self).possible_crtcs_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup7 (_tmp0_, _tmp0__length1) : _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	(*dest).possible_crtcs = (g_free ((*dest).possible_crtcs), NULL);
	(*dest).possible_crtcs = _tmp1_;
	(*dest).possible_crtcs_length1 = _tmp1__length1;
	_tmp2_ = (*self).connector_name;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).connector_name);
	(*dest).connector_name = _tmp3_;
	_tmp4_ = (*self).modes;
	_tmp4__length1 = (*self).modes_length1;
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup8 (_tmp4_, _tmp4__length1) : _tmp4_;
	_tmp5__length1 = _tmp4__length1;
	(*dest).modes = (g_free ((*dest).modes), NULL);
	(*dest).modes = _tmp5_;
	(*dest).modes_length1 = _tmp5__length1;
	_tmp6_ = (*self).clones;
	_tmp6__length1 = (*self).clones_length1;
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup9 (_tmp6_, _tmp6__length1) : _tmp6_;
	_tmp7__length1 = _tmp6__length1;
	(*dest).clones = (g_free ((*dest).clones), NULL);
	(*dest).clones = _tmp7_;
	(*dest).clones_length1 = _tmp7__length1;
	_tmp8_ = (*self).properties;
	_tmp9_ = _g_hash_table_ref0 (_tmp8_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp9_;
}

void
mutter_read_display_output_destroy (MutterReadDisplayOutput* self)
{
	(*self).possible_crtcs = (g_free ((*self).possible_crtcs), NULL);
	_g_free0 ((*self).connector_name);
	(*self).modes = (g_free ((*self).modes), NULL);
	(*self).clones = (g_free ((*self).clones), NULL);
	_g_hash_table_unref0 ((*self).properties);
}

MutterReadDisplayOutput*
mutter_read_display_output_dup (const MutterReadDisplayOutput* self)
{
	MutterReadDisplayOutput* dup;
	dup = g_new0 (MutterReadDisplayOutput, 1);
	mutter_read_display_output_copy (self, dup);
	return dup;
}

void
mutter_read_display_output_free (MutterReadDisplayOutput* self)
{
	mutter_read_display_output_destroy (self);
	g_free (self);
}

static GType
mutter_read_display_output_get_type_once (void)
{
	GType mutter_read_display_output_type_id;
	mutter_read_display_output_type_id = g_boxed_type_register_static ("MutterReadDisplayOutput", (GBoxedCopyFunc) mutter_read_display_output_dup, (GBoxedFreeFunc) mutter_read_display_output_free);
	return mutter_read_display_output_type_id;
}

GType
mutter_read_display_output_get_type (void)
{
	static volatile gsize mutter_read_display_output_type_id__once = 0;
	if (g_once_init_enter (&mutter_read_display_output_type_id__once)) {
		GType mutter_read_display_output_type_id;
		mutter_read_display_output_type_id = mutter_read_display_output_get_type_once ();
		g_once_init_leave (&mutter_read_display_output_type_id__once, mutter_read_display_output_type_id);
	}
	return mutter_read_display_output_type_id__once;
}

void
mutter_write_display_output_copy (const MutterWriteDisplayOutput* self,
                                  MutterWriteDisplayOutput* dest)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	(*dest).id = (*self).id;
	_tmp0_ = (*self).properties;
	_tmp1_ = _g_hash_table_ref0 (_tmp0_);
	_g_hash_table_unref0 ((*dest).properties);
	(*dest).properties = _tmp1_;
}

void
mutter_write_display_output_destroy (MutterWriteDisplayOutput* self)
{
	_g_hash_table_unref0 ((*self).properties);
}

MutterWriteDisplayOutput*
mutter_write_display_output_dup (const MutterWriteDisplayOutput* self)
{
	MutterWriteDisplayOutput* dup;
	dup = g_new0 (MutterWriteDisplayOutput, 1);
	mutter_write_display_output_copy (self, dup);
	return dup;
}

void
mutter_write_display_output_free (MutterWriteDisplayOutput* self)
{
	mutter_write_display_output_destroy (self);
	g_free (self);
}

static GType
mutter_write_display_output_get_type_once (void)
{
	GType mutter_write_display_output_type_id;
	mutter_write_display_output_type_id = g_boxed_type_register_static ("MutterWriteDisplayOutput", (GBoxedCopyFunc) mutter_write_display_output_dup, (GBoxedFreeFunc) mutter_write_display_output_free);
	return mutter_write_display_output_type_id;
}

GType
mutter_write_display_output_get_type (void)
{
	static volatile gsize mutter_write_display_output_type_id__once = 0;
	if (g_once_init_enter (&mutter_write_display_output_type_id__once)) {
		GType mutter_write_display_output_type_id;
		mutter_write_display_output_type_id = mutter_write_display_output_get_type_once ();
		g_once_init_leave (&mutter_write_display_output_type_id__once, mutter_write_display_output_type_id);
	}
	return mutter_write_display_output_type_id__once;
}

MutterReadDisplayMode*
mutter_read_display_mode_dup (const MutterReadDisplayMode* self)
{
	MutterReadDisplayMode* dup;
	dup = g_new0 (MutterReadDisplayMode, 1);
	memcpy (dup, self, sizeof (MutterReadDisplayMode));
	return dup;
}

void
mutter_read_display_mode_free (MutterReadDisplayMode* self)
{
	g_free (self);
}

static GType
mutter_read_display_mode_get_type_once (void)
{
	GType mutter_read_display_mode_type_id;
	mutter_read_display_mode_type_id = g_boxed_type_register_static ("MutterReadDisplayMode", (GBoxedCopyFunc) mutter_read_display_mode_dup, (GBoxedFreeFunc) mutter_read_display_mode_free);
	return mutter_read_display_mode_type_id;
}

GType
mutter_read_display_mode_get_type (void)
{
	static volatile gsize mutter_read_display_mode_type_id__once = 0;
	if (g_once_init_enter (&mutter_read_display_mode_type_id__once)) {
		GType mutter_read_display_mode_type_id;
		mutter_read_display_mode_type_id = mutter_read_display_mode_get_type_once ();
		g_once_init_leave (&mutter_read_display_mode_type_id__once, mutter_read_display_mode_type_id);
	}
	return mutter_read_display_mode_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

